﻿---------------------------
--- Core Addon Creation ---
---------------------------
local tomQuest2 = LibStub("AceAddon-3.0"):NewAddon("tomQuest2", "AceEvent-3.0", "AceTimer-3.0", "AceBucket-3.0", "AceHook-3.0", "AceComm-3.0", "AceSerializer-3.0", "LibSink-2.0")
_G["tomQuest2"] = tomQuest2

-----------------------
--- Library loading ---
-----------------------
local LC = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Core")
local LibTourist = LibStub("LibTourist-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
local LDB = LibStub("LibDataBroker-1.1")
local LBF = LibStub("LibButtonFacade", true)

--------------------------------------
--- Copy global functions to local ---
--------------------------------------
local sub, format, tconcat, tremove, sort, find, match, gsub = string.sub, format, table.concat, tremove, sort, string.find, string.match, gsub
local pairs, ipairs, next, band, GetTime, tonumber = pairs, ipairs, next, bit.band, GetTime, tonumber

-----------------
--- variables ---
-----------------
WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
local DUNGEON, HEROIC, RAID, GROUP = LFG_TYPE_DUNGEON, ITEM_HEROIC, LFG_TYPE_RAID, GROUP
if GetLocale() == "zhTW" then
	GROUP = "團體"
end
local QUESTS_TRACKER, QUESTS_TOOLTIP, ACHIEVEMENTS_TRACKER = "questsTracker", "questsTooltip", "achievementsTracker"
local PARTYQUESTSZONE = LC["PARTYQUESTSZONE"]
local tooltipHeaderCell, tooltipHeaderButton, qTrSQuestItemCategory, qTrSQuestItemCategoryButton, qTrQuestItemCategory, qTrQuestItemCategoryButton, qTrSQuestItemFakeLine, qTrQuestItemFakeLine
local _, prdb, chdb, gldb, abandoning, hideQuestsTracker, hideAchievementsTracker, syncParty, displayFrames, LBFGroup
local version, firstCompatibleVersion, lastIncompatibleVersion = 403, 403, 402
local subZone, currentZone, oldZone = "", "", ""
local playerName = UnitName("player")
local localClass, playerClass = UnitClass("player")
local playerLevel = UnitLevel("player")
local numQuests, numCompletedQuests, numPartyMembers, numRaidMembers = 0, 0, 0, 0
local firstRun = true
local cQToFontTQ2, qQToFontTQ2, qoQToFontTQ2 = CreateFont("cQToFontTQ2"), CreateFont("qQToFontTQ2"), CreateFont("qoQToFontTQ2")
local cQTrFontTQ2, qQTrFontTQ2, qoQTrFontTQ2 = CreateFont("cQTrFontTQ2"), CreateFont("qQTrFontTQ2"), CreateFont("qoQTrFontTQ2")
local cATrFontTQ2, scATrFontTQ2, aATrFontTQ2, acATrFontTQ2, sbATrFontTQ2 = CreateFont("cATrFontTQ2"), CreateFont("scATrFontTQ2"), CreateFont("aATrFontTQ2"), CreateFont("acATrFontTQ2"), CreateFont("sbATrFontTQ2")
local quests, questsObjectives, questsCategories, questsByCategory, achievementsCategories, achievements = {}, {}, {}, {}, {}, {}
local items, itemStartingQuest, usableQuestItems, classColors, hintCells, party, partyTimeStamp = {}, {}, {}, {}, {}, {}, {}
local questsTitleToqid, sortedCategories, sortedQuestsByCategory, sortedQuests, collapsedHeader, questStartedByItem = {}, {}, {}, {}, {}, {}
local pId = {"party1", "party2", "party3", "party4"}
local interactivityAction = {
	mouseRightShift = LC["Shift + Right click"],
	mouseRightControl = LC["Ctrl + Right click"],
	mouseRightAlt = LC["Alt + Right click"],
	mouseRight = LC["Right click"],
	mouseLeftShift = LC["Shift + Left click"],
	mouseLeftControl = LC["Ctrl + Left click"],
	mouseLeftAlt = LC["Alt + Left click"],
	mouseLeft = LC["Left click"],
	mouseMiddleShift = LC["Shift + Middle click"],
	mouseMiddleControl = LC["Ctrl + Middle click"],
	mouseMiddleAlt = LC["Alt + Middle click"],
	mouseMiddle = LC["Middle click"],
}
local tags = {
	[DAILY] = "daily",
	[GROUP] = "group",
	[ELITE] = "elite",
	[PVP] = "pvp",
	[DUNGEON] = "dungeon",
	[HEROIC] = "heroic",
	[LC["Escort"]] = "escort",
	[""] = "notag",
}
local reactions = {
	[FACTION_STANDING_LABEL1] = 1, [FACTION_STANDING_LABEL1_FEMALE] = 1,
	[FACTION_STANDING_LABEL2] = 2, [FACTION_STANDING_LABEL2_FEMALE] = 2,
	[FACTION_STANDING_LABEL3] = 3, [FACTION_STANDING_LABEL3_FEMALE] = 3,
	[FACTION_STANDING_LABEL4] = 4, [FACTION_STANDING_LABEL4_FEMALE] = 4,
	[FACTION_STANDING_LABEL5] = 5, [FACTION_STANDING_LABEL5_FEMALE] = 5,
	[FACTION_STANDING_LABEL6] = 6, [FACTION_STANDING_LABEL6_FEMALE] = 6,
	[FACTION_STANDING_LABEL7] = 7, [FACTION_STANDING_LABEL7_FEMALE] = 7,
	[FACTION_STANDING_LABEL8] = 8, [FACTION_STANDING_LABEL8_FEMALE] = 8,
}

local getItemButton, recycleItemButton, getButton, recycleButton, getStatusBar, recycleStatusBar, updateStatusbar, getContentCell, recycleContentCell, updateQuestCategoryCell, createQuestCategoryCell, removeQuestCategoryCells, updateQuestTextCell, updateQuestCells, removeQuestCells, updateQuestObjectiveStatus, updateQuestObjectiveCells, createQuestDescriptionCells, updateAllQuestsStatus, updateAchievementCategoryCells, createAchievementCategoryCells, removeAchievementsCategoryCells
local getContainer, updateScrolling, setBackDrop, setQuestsTooltipLayout, setQuestsTrackerLayout, setAchievementsTrackerLayout
local objectsPattern, monstersPattern, factionPattern, playersPattern, dailyCounterPattern, found, item, kill, playerKilled, oComplete, qComplete, qFailed
do--define pattern
	local function paternize(pattern)
		pattern = pattern:gsub("[()]", "%%%1")
		return format("^%s$", pattern:gsub("(%%%d?$?.)", "(.+)"))
	end
	objectsPattern, monstersPattern, factionPattern = paternize(QUEST_OBJECTS_FOUND), paternize(QUEST_MONSTERS_KILLED), paternize(QUEST_FACTION_NEEDED)
	playersPattern, dailyCounterPattern = paternize(QUEST_PLAYERS_KILLED), paternize(DAILY_QUESTS_REMAINING)
	found, item, kill, playerKilled = paternize(ERR_QUEST_ADD_FOUND_SII), paternize(ERR_QUEST_ADD_ITEM_SII), paternize(ERR_QUEST_ADD_KILL_SII), paternize(ERR_QUEST_ADD_PLAYER_KILL_SII)
	oComplete, qComplete, qFailed = paternize(ERR_QUEST_OBJECTIVE_COMPLETE_S), paternize(ERR_QUEST_COMPLETE_S), paternize(ERR_QUEST_FAILED_S)
end

tomQuest2.PARTYQUESTSZONE = PARTYQUESTSZONE
tomQuest2.quests, tomQuest2.questsObjectives, tomQuest2.questsCategories, tomQuest2.questsByCategory = quests, questsObjectives, questsCategories, questsByCategory
tomQuest2.achievementsCategories, tomQuest2.achievements = achievementsCategories, achievements
tomQuest2.achievementsCategoryButtons, tomQuest2.achievementCategoryTextCells, tomQuest2.achievementCategoryStatusCells = {}, {}, {}
tomQuest2.moduleState = {}
tomQuest2.interactivityList = {
	["chatLink"] = LC["Insert quest link in chat"],
	["objectiveProgress"] = LC["Insert quest objectives progress in chat"],
	["macroUpdate"] = LC["Update special quest item macro"],
	["tooltip"] = LC["Display of quest tooltip"],
	["shareQuest"] = LC["Share quest"],
	["trackQuest"] = LC["Track quest"],
	["abandonQuest"] = LC["Abandon quest"],
	["displayQuest"] = LC["Diplay quest log"],
	["displayQuestInfo"] = LC["Display quest on map"],
	["autoQuestComplete"] = LC["Auto quest complete"],
	["nothing"] = LC["Do nothing"],
}

---------------------------------------
--- Shared Media Sound Registration ---
---------------------------------------
LSM:Register("sound", "Peon Ready", [[Sound\Creature\Peon\PeonReady1.wav]])
LSM:Register("sound", "Work Done", [[Interface\Addons\tomQuest2\media\Peasant_work_done.mp3]])
LSM:Register("sound", "More work?", [[Sound\Creature\Peasant\PeasantWhat3.wav]])
LSM:Register("sound", "Work complete!", [[Sound\Creature\Peon\PeonBuildingComplete1.wav]])
LSM:Register("sound", "Quest Added", [[Sound\interface\iQuestActivate.wav]])
LSM:Register("sound", "Quest Completed", [[Sound\interface\iQuestComplete.wav]])
LSM:Register("sound", "Quest Failed", [[Sound\interface\igQuestFailed.wav]])
LSM:Register("sound", "Quest Auto Complete", "UI_AutoQuestComplete")

-----------------------
--- Tools functions ---
-----------------------
local cSort = {
	nameD = function(a, b)
		return a > b
	end,
	nameA = function(a, b)
		return a < b
	end,
	levelD = function(a, b)
		local aLvl = questsCategories[a].sLevel
		local bLvl = questsCategories[b].sLevel
		if aLvl == bLvl then
			return a > b
		else
			return aLvl > bLvl
		end
	end,
	levelA = function(a, b)
		local aLvl = questsCategories[a].sLevel
		local bLvl = questsCategories[b].sLevel
		if aLvl == bLvl then
			return a < b
		else
			return aLvl < bLvl
		end
	end
}

local qSort = {
	weightedA = function(a, b)
		local aWL = quests[a].weightedLevel
		local bWL = quests[b].weightedLevel
		if aWL == bWL then
			return quests[a].title < quests[b].title
		else
			return aWL < bWL
		end
	end,
	weightedD = function(a, b)
		local aWL = quests[a].weightedLevel
		local bWL = quests[b].weightedLevel
		if aWL == bWL then
			return quests[a].title > quests[b].title
		else
			return aWL > bWL
		end
	end,
	levelA = function(a, b)
		local aL = quests[a].level
		local bL = quests[b].level
		if aL == bL then
			return quests[a].title < quests[b].title
		else
			return aL < bL
		end
	end,
	levelD = function(a, b)
		local aL = quests[a].level
		local bL = quests[b].level
		if aL == bL then
			return quests[a].title > quests[b].title
		else
			return aL > bL
		end
	end,
	nameA = function(a, b)
		return quests[a].title > quests[b].title
	end,
	nameD = function(a, b)
		return quests[a].title < quests[b].title
	end,
}

function tomQuest2:questsSort()
	local tIndex1, tIndex2 = 0, 0
	for category in pairs(questsCategories) do
		local tIndex3 = 0
		tIndex1 = tIndex1 + 1
		sortedCategories[tIndex1] = category
		for qid in pairs(questsByCategory[category]) do
			tIndex2 = tIndex2 + 1
			tIndex3 = tIndex3 + 1
			sortedQuestsByCategory[category][tIndex3] = qid
			sortedQuests[tIndex2] = qid
		end
		for i = tIndex3 + 1, #sortedQuestsByCategory[category] do
			sortedQuestsByCategory[category][i] = nil
		end
		sort(sortedQuestsByCategory[category], qSort[prdb.questsSorting])
	end
	for i = tIndex1 + 1, #sortedCategories do
		sortedCategories[i] = nil
	end
	for i = tIndex2 + 1, #sortedQuests do
		sortedQuests[i] = nil
	end
	sort(sortedCategories, cSort[prdb.categorySorting])
	sort(sortedQuests, qSort[prdb.questsSorting])
end

local function onLeave(self)
	GameTooltip:Hide()
end

local function play(sound)
	local soundPlayed = PlaySoundFile(sound)
	if not soundPlayed then
		PlaySound(sound)
	end
end

local levelTag = {
	elite = function(qid, level, group)
		return level + prdb.eliteAddLevel
	end,
	group = function(qid, level, group)
		return level + prdb.groupAddLevel * (group - numPartyMembers)
	end,
	heroic = function(qid, level, group)
		return level + prdb.heroicAddLevel * (group - numPartyMembers)
	end,
	dungeon = function(qid, level, group)
		return level + prdb.dungeonAddLevel * (group - numPartyMembers)
	end,
	raid = function(qid, level, group)
		return level + prdb.raidAddLevel * (group - max(numRaidMembers, numPartyMembers))
	end,
	escort = function(qid, level, group)
		return level
	end,
	pvp = function(qid, level, group)
		return level
	end,
	daily = function(qid, level, group)
		return level
	end,
	notag = function(qid, level, group)
		return level
	end,
}

local function getDifficultyColor(levelDiff)
	if levelDiff >= 5 then
		return QuestDifficultyColors["impossible"]
	elseif levelDiff >= 3 then
		return QuestDifficultyColors["verydifficult"]
	elseif levelDiff >= -2 then
		return QuestDifficultyColors["difficult"]
	elseif -levelDiff <= GetQuestGreenRange() then
		return QuestDifficultyColors["standard"]
	else
		return QuestDifficultyColors["trivial"]
	end
end

local getColorFromCompletionRGB, getColorFromCompletionHEX
do--getColorFromCompletion
	local function normalizeColorComponent(component)
		if component > 1 then return 1 elseif component < 0 then return 0 else return component end
	end
	function getColorFromCompletionRGB(percent)
		if percent <= 0 then
			return prdb.rj0, prdb.gj0, prdb.bj0
		elseif percent >= 1 then
			return prdb.rj3, prdb.gj3, prdb.bj3
		elseif percent <= 0.5 then
			return normalizeColorComponent(prdb.ri1*percent + prdb.rj1), normalizeColorComponent(prdb.gi1*percent + prdb.gj1), normalizeColorComponent(prdb.bi1*percent + prdb.bj1)
		else
			return normalizeColorComponent(prdb.ri2*percent + prdb.rj2), normalizeColorComponent(prdb.gi2*percent + prdb.gj2), normalizeColorComponent(prdb.bi2*percent + prdb.bj2)
		end
	end
	function getColorFromCompletionHEX(percent)
		if percent <= 0 then
			return format("%02x%02x%02x", 255*prdb.rj0, 255*prdb.gj0, 255*prdb.bj0)
		elseif percent >= 1 then
			return format("%02x%02x%02x", 255*prdb.rj3, 255*prdb.gj3, 255*prdb.bj3)
		elseif percent <= 0.5 then
			return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.ri1*percent + prdb.rj1), 255*normalizeColorComponent(prdb.gi1*percent + prdb.gj1), 255*normalizeColorComponent(prdb.bi1*percent + prdb.bj1))
		else
			return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.ri2*percent + prdb.rj2), 255*normalizeColorComponent(prdb.gi2*percent + prdb.gj2), 255*normalizeColorComponent(prdb.bi2*percent + prdb.bj2))
		end
	end
end

function tomQuest2:Print(text)
	if text then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99tomQuest2|r: "..text)
	end
end

local BAG_UPDATE
do--scan bags
	local ITEM_SPELL_TRIGGER_ONUSE = ITEM_SPELL_TRIGGER_ONUSE
	local specialItems, itemsTimeStamp = {["32971"] = true}, {}
	local scanTooltipLines = {"scanTooltipTQ2TextLeft2", "scanTooltipTQ2TextLeft3", "scanTooltipTQ2TextLeft4", "scanTooltipTQ2TextLeft5"}
	local scanTooltipTQ2 = CreateFrame( "GameTooltip", "scanTooltipTQ2", nil, "GameToolTipTemplate")
	scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")

	local function findItemOnUse(itemLink)
		scanTooltipTQ2:ClearLines()
		scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
		scanTooltipTQ2:SetHyperlink(itemLink)
		scanTooltipTQ2:Show()
		for _, lineNum in pairs(scanTooltipLines) do
			local text = _G[lineNum]:GetText()
			if text and find(text, ITEM_SPELL_TRIGGER_ONUSE) then
				scanTooltipTQ2:Hide()
				return true
			end
		end
		scanTooltipTQ2:Hide()
		return false
	end

	local function linkQuestItem(itemID, itemName, itemTexture)
		for qid, qData in pairs (quests) do
			if qData.playerStatus and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) and not quests[qid].specialItemID then
				items[itemID] = qid
				quests[qid].specialItemID = itemID
				quests[qid].questsTooltipFakeItem = getButton(quests[qid].questsTooltipText, itemTexture, prdb.questsTooltip.questItemIconSize, "item", itemID)
				quests[qid].questsTrackerFakeItem = getButton(quests[qid].questsTrackerText, itemTexture, prdb.questsTracker.questItemIconSize, "item", itemID)
				return true
			end
		end
	end

	function BAG_UPDATE()
		if InCombatLockdown() then
			tomQuest2.updateBagAfterCombat = true
			return
		end
		local timeStamp = GetTime()
		local updateTracker
		for bag = 0, 4 do
			for slot = 1, GetContainerNumSlots(bag) do
				local itemID = GetContainerItemID(bag, slot)
				if itemID then
					itemsTimeStamp[itemID] = timeStamp
					if not items[itemID] then
						local isQuestItem, qid, isActive = GetContainerItemQuestInfo(bag, slot)
						local itemName, itemLink, _, _, _, _, _, _, _, itemTexture = GetItemInfo(itemID)
						if qid and not isActive then
							items[itemID] = 0
							questStartedByItem[qid] = itemID
							itemStartingQuest[itemID] = getButton(displayFrames.questsTracker.scrollChild, itemTexture, prdb.questsTracker.questItemIconSize, "item", itemID)
							if not firstRun then
								if tomQuest2.moduleState["notifications"] and prdb.notifyItemStartingQuestLooted then
									tomQuest2:Pour(format(LC["You've just looted %s which start a quest"], itemName), 0, 1, 0)
								end
							end
							updateTracker = true
						elseif isQuestItem and qid and quests[qid] then
							items[itemID] = qid
							quests[qid].specialItemID = itemID
							quests[qid].questsTooltipFakeItem = getButton(quests[qid].questsTooltipText, itemTexture, prdb.questsTooltip.questItemIconSize, "item", itemID)
							quests[qid].questsTrackerFakeItem = getButton(quests[qid].questsTrackerText, itemTexture, prdb.questsTracker.questItemIconSize, "item", itemID)
							updateTracker = true
						elseif isQuestItem or specialItems[itemID] then
							if GetItemSpell(itemID) or findItemOnUse(itemLink) then
								if not linkQuestItem(itemID, itemName, itemTexture) then
									items[itemID] = -1
									usableQuestItems[itemID] = getButton(displayFrames.questsTracker.scrollChild, itemTexture, prdb.questsTracker.questItemIconSize, "item", itemID)
									updateTracker = true
								end
							else
								items[itemID] = -2
							end
						else
							items[itemID] = -2
						end
					elseif items[itemID] == 0 then
						local isQuestItem, qid, isActive = GetContainerItemQuestInfo(bag, slot)
						if qid and isActive then
							items[questStartedByItem[qid]] = nil
							itemsTimeStamp[itemID] = 0
						end
					end
				end
			end
		end
		for slotId = 0, 19, 1 do
			local itemID = GetInventoryItemID("player", slotId)
			if itemID and itemID > 0 then
				itemsTimeStamp[itemID] = timeStamp
			end
		end
		for itemID in pairs(itemsTimeStamp) do
			if itemsTimeStamp[itemID] ~= timeStamp then
				itemsTimeStamp[itemID] = nil
				if items[itemID] then
					if items[itemID] == 0 then
						recycleButton(itemStartingQuest[itemID])
						itemStartingQuest[itemID], items[itemID] = nil, nil
						updateTracker = true
					elseif items[itemID] == -1 then
						recycleButton(usableQuestItems[itemID])
						usableQuestItems[itemID], items[itemID] = nil, nil
						updateTracker = true
					elseif items[itemID] == -2 then
						items[itemID] = nil
					end
				end
			end
		end
		if updateTracker then
			setQuestsTrackerLayout()
		end
	end
end

-------------------
--- Class Color ---
-------------------
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
	classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end
local playerColor = classColors[playerClass]

local function updateClassColors()
	for class, color in pairs(CUSTOM_CLASS_COLORS) do
		classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
	end
	playerColor = classColors[playerClass]
	updateAllQuestsStatus()
end

-----------------------
--- Default profile ---
-----------------------
local defaults = {
	profile = {
		dataObjMouseRightShift = "openOptions",
		dataObjMouseRightControl = "openOptions",
		dataObjMouseRightAlt = "openOptions",
		dataObjMouseRight = "openOptions",
		dataObjMouseLeftShift = "toggleQuestTracker",
		dataObjMouseLeftControl = "toggleAnnouncementModule",
		dataObjMouseLeftAlt = "toggleAchievementsTracker",
		dataObjMouseLeft = "toggleQuestsLog",
		dataObjMouseMiddleShift = "toggleQuestTracker",
		dataObjMouseMiddleControl = "toggleAnnouncementModule",
		dataObjMouseMiddleAlt = "toggleAchievementsTracker",
		dataObjMouseMiddle = "toggleQuestsLog",
		--Achievements Tracker
		timedAchievements = true,
		--Quests Tracker
		onLogIn = false,
		onQuestAccepted = 3,
		onObjectiveProgress = true,
		unTrackInactive = false,
		unTrackDelay = 5,
		onSubZone = true,
		onZone = true,
		onDaily = true,
		onClass = true,
		--Quests Tooltip
		showNumCompletedQuests = true,
		showNumQuests = true,
		showMaxQuest = true,
		colorizeQuestsCounter = true,
		--Daily Quests Tooltip
		showNumCompletedDailyQuests = true,
		showMaxDailyQuest = true,
		showRemainingTime = true,
		colorizeDailyQuestsCounter = true,
		colorizeDailyQuestsTimer = true,
		showCOTD = true,
		--Tooltips
		mobTooltip = true,
		itemTooltip = true,
		--Quests Givers
		questTitleColor = "000000",
		addQuestLevel = true,
		fadeNotCompletedQuests = true,
		automaticAccept = 4,
		automaticAcceptEscort = false,
		automaticTurnIn = false,
		--Announce
		announcePlayerObjectiveProgress = true,
		announcePlayerObjectiveComplete = true,
		announcePlayerQuestComplete = true,
		announcePlayerQuestFailed = true,
		announceObjectiveProgressWhenQuestComplete = false,
		--Notifications
		hideBlizzardNotification = true,
		notifiyObjectiveProgressWhenQuestComplete = false,
		notifyPlayerObjectiveProgress = true,
		notifyPlayerObjectiveComplete = true,
		notifyPlayerQuestComplete = true,
		notifyPlayerQuestAutoComplete = true,
		notifyPlayerQuestFailed = true,
		notifyItemStartingQuestLooted = true,
		notifyPartyObjectiveProgress = true,
		notifyPartyObjectiveComplete = true,
		notifyPartyQuestComplete = true,
		notifyPartyQuestFailed = true,
		notifyPartyQuestAccepted = true,
		notifyPartyQuestTurnedIn = true,
		notifyPartyQuestAbandonned = true,
		sinkOptions = {
		},
		--SoundNotifications
		soundQuestComplete = "Work Done",
		soundQuestAutoComplete = "Quest Auto Complete",
		soundQuestFailed = "Thrumm",
		soundObjectiveComplete = "Peon Ready",
		--Display Engine
		skin = {
			skin = "DreamLayout",
			gloss = 0,
			backdrop = false,
			Colors = {},
		},
		questsTooltip = {
			hideCompletedObjective = 2,
			hideZoneLevelRange = false,
			hideQuestTag = false,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			questFont = LSM.DefaultMedia.font,
			questFontSize = 10,
			questFontOutline = "",
			questObjectiveFont = LSM.DefaultMedia.font,
			questObjectiveFontSize = 8,
			questObjectiveFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderInset = 2.5,
			borderWidth = 14,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			showCollapseButton = true,
			collapseButtonSize = 14,
			questsCellPadding = 5,
			objectivesCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeCategoryName = true,
			defaultCategoryNameColor = "ffffff",
			colorizeCategoryLevel = true,
			defaultCategoryLevelColor = "ffffff",
			colorizeQuestName = true,
			defaultQuestNameColor = "ffffff",
			colorizeQuestLevel = true,
			defaultQuestLevelColor = "ffffff",
			colorizeQuestTimer = true,
			defaultQuestTimerColor = "ffffff",
			colorizeQuestObjective = true,
			defaultQuestObjectiveColor = "ffffff",
			colorizeQuestObjectiveCounter = true,
			defaultQuestObjectiveCounterColor = "ffffff",
			defaultQuestDescriptionColor = "ffffff",
			showQuestItemIcon = true,
			questItemIconSize = 18,
			showHints = true,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "objectiveProgress",
			mouseRightAlt = "macroUpdate",
			mouseRight = "tooltip",
			mouseLeftShift = "trackQuest",
			mouseLeftControl = "shareQuest",
			mouseLeftAlt = "abandonQuest",
			mouseLeft = "displayQuest",
			mouseMiddleShift = "autoQuestComplete",
			mouseMiddleControl = "displayQuestInfo",
			mouseMiddleAlt = "displayQuestInfo",
			mouseMiddle = "displayQuestInfo",
		},
		questsTracker = {
			point = "TOPRIGHT",
			relativePoint = "TOPRIGHT",
			xOffset = -30,
			yOffset = -30,
			overrideAnchor = false,
			overridePoint = "TOPRIGHT",
			showByCategory = true,
			autoCollapseCategory = true,
			lockTracker = true,
			toggleTracker = true,
			hideTrackerInCombat = true,
			hideCompletedQuest = 2,
			hideCompletedObjective = 2,
			onlyCurrentZone = false,
			limitQuestLevel = false,
			maxLevelDiff = 3,
			hideZoneLevelRange = false,
			hideQuestTag = false,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			questFont = LSM.DefaultMedia.font,
			questFontSize = 10,
			questFontOutline = "",
			questObjectiveFont = LSM.DefaultMedia.font,
			questObjectiveFontSize = 8,
			questObjectiveFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderInset = 2.5,
			borderWidth = 14,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			showCollapseButton = true,
			collapseButtonSize = 12,
			questsCellPadding = 5,
			objectivesCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeCategoryName = true,
			defaultCategoryNameColor = "ffffff",
			colorizeCategoryLevel = true,
			defaultCategoryLevelColor = "ffffff",
			colorizeQuestName = true,
			defaultQuestNameColor = "ffffff",
			colorizeQuestLevel = true,
			defaultQuestLevelColor = "ffffff",
			colorizeQuestTimer = true,
			defaultQuestTimerColor = "ffffff",
			colorizeQuestObjective = true,
			defaultQuestObjectiveColor = "ffffff",
			colorizeQuestObjectiveCounter = true,
			defaultQuestObjectiveCounterColor = "ffffff",
			defaultQuestDescriptionColor = "ffffff",
			showQuestItemIcon = true,
			questItemIconSize = 18,
			oorColor = {0.8, 0.1, 0.1},
			showItemsStartingQuest = true,
			showUsableQuestItemsNotAttached = true,
			otherItemIconSize = 12,
			disableInteraction = false,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "objectiveProgress",
			mouseRightAlt = "macroUpdate",
			mouseRight = "tooltip",
			mouseLeftShift = "trackQuest",
			mouseLeftControl = "shareQuest",
			mouseLeftAlt = "abandonQuest",
			mouseLeft = "displayQuest",
			mouseMiddleShift = "autoQuestComplete",
			mouseMiddleControl = "displayQuestInfo",
			mouseMiddleAlt = "displayQuestInfo",
			mouseMiddle = "displayQuestInfo",
		},
		achievementsTracker = {
			point = "TOPLEFT",
			relativePoint = "TOPLEFT",
			xOffset = 30,
			yOffset = -30,
			overrideAnchor = false,
			overridePoint = "TOPLEFT",
			showInQuestTracker = true,
			positionInQuestTracker = 1,
			lockTracker = true,
			toggleTracker = true,
			hideTrackerInCombat = true,
			hideCompletedCriteria = true,
			showByCategory = true,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			subCategoryFont = LSM.DefaultMedia.font,
			subCategoryFontSize = 12,
			subCategoryFontOutline = "",
			achievementFont = LSM.DefaultMedia.font,
			achievementFontSize = 10,
			achievementFontOutline = "",
			achievementCriterionFont = LSM.DefaultMedia.font,
			achievementCriterionFontSize = 8,
			achievementCriterionFontOutline = "",
			statusBarFont = LSM.DefaultMedia.font,
			statusBarFontSize = 8,
			statusBarFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderWidth = 14,
			borderInset = 2.5,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			subCategoryCellPadding = 5,
			showCollapseButton = true,
			categoryCollapseButtonSize = 12,
			subCategoryCollapseButtonSize = 12,
			showAchievementIcon = true,
			achievementIconSize = 10,
			achievementCellPadding = 5,
			criteriaCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			numBooleanCriteriaColumns = 2,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeACName = true,
			defaultACNameColor = "ffffff",
			colorizeACCounter = true,
			defaultACCounterColor = "ffffff",
			colorizeASCName = true,
			defaultASCNameColor = "ffffff",
			colorizeASCCounter = true,
			defaultASCCounterColor = "ffffff",
			defaultANameColor = "ffffff",
			colorizeATimer = true,
			defaultATimerColor = "ffffff",
			colorizeACrName = true,
			defaultACrNameColor = "ffffff",
			colorizeACrStatus = true,
			defaultACrStatusColor = "ffffff",
			colorizeStatusBar = true,
			defaultStatusBarColor = {0, 0.6, 0},
			colorizeStatusBarText = false,
			defaultStatusBarTextColor = "ffffff",
			defaultDescriptionColor = "ffffff",
			displayAsStatusBar = true,
			statusBarTexture = LSM.DefaultMedia.statusbar,
			statusBarHeight = 12,
			rightStatusBarPadding = 40,
			leftStatusBarPadding = 40,
			disableInteraction = false,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "nothing",
			mouseRightAlt = "nothing",
			mouseRight = "tooltip",
			mouseLeftShift = "removeTrackedAchievement",
			mouseLeftControl = "nothing",
			mouseLeftAlt = "nothing",
			mouseLeft = "displayAchievement",
			mouseMiddleShift = "nothing",
			mouseMiddleControl = "nothing",
			mouseMiddleAlt = "nothing",
			mouseMiddle = "nothing",
		},
		--Quests information
		backDropColor = {0.09, 0.09, 0.19, 0.5},
		borderColor = {0.5, 0.5, 0.5, 1},
		attach = 1,
		showQuestLog = true,
		qlFont = LSM.DefaultMedia.font,
		qlFontSizeH1 = 14,
		qlFontSizeH2 = 12,
		qlFontSize = 10,
		showLightHeaded = true,
		showAllCommentsOnOnePage = false,
		lhFont = LSM.DefaultMedia.font,
		lhFontSize = 10,
		tomQuest2ParentFrameWidth = 640,
		tomQuest2ParentFrameHeight = 400,
		tomQuest2ParentFramePoint = "CENTER",
		tomQuest2ParentFrameX = 0,
		tomQuest2ParentFrameY = 0,
		color = "ffffd100",
		--Core
		font = LSM.DefaultMedia.font,
		fontSize = 12,
		fontOutline = "",
		maximumTooltipWidth = 250,
		partyHeader = true,
		categorySorting = "levelA", categoryWithoutLvlPos = 0, questsSorting = "weightedA",
		hideDefaultBlizTracker = true,
		eliteAddLevel = 3, groupAddLevel = 1, dungeonAddLevel = 2, heroicAddLevel = 3, raidAddLevel = 1,
		level = "questLevel", elite = "+", group = "g", pvp = "p", raid = "r", dungeon = "d", heroic = "d+", daily = "\226\128\162", escort = "e", notag = "",
		completedColor = "00ff00", failedColor = "ff0000",
		customColorMode = true,
		rj0 = 1, gj0 = 0, bj0 = 0,
		ri1 = 0, rj1 = 1, gi1 = 2, gj1 = 0, bi1 = 0, bj1 = 0,
		ri2 = -2, rj2 = 2, gi2 = 0, gj2 = 1, bi2 = 0, bj2 = 0,
		rj3 = 0, gj3 = 1, bj3 = 0,
		modules = {
			dailyTooltip = true,
			notifications = true,
			informations = true,
			questsTooltip = true,
			questsTracker = true,
			soundNotifications = true,
			syncParty = true,
			questsGivers = true,
			tagQuestLog = true,
			tooltips = true,
			announce = false,
			achievementsTracker = true,
			achievementsTradeSkills = true,
		},
		raidModules = {
			enabled = true,
			dailyTooltip = "inRaidInstance",
			notifications = "inRaidInstance",
			informations = "enabled",
			questsTooltip = "enabled",
			questsTracker = "inRaidInstance",
			soundNotifications = "enabled",
			syncParty = "inRaidInstance",
			questsGivers = "enabled",
			tagQuestLog = "enabled",
			tooltips = "inRaidInstance",
			announce = "inRaidInstance",
			achievementsTracker = "enabled",
			achievementsTradeSkills = "enabled",
		},
	},
}

--------------------------
--- Quests information ---
--------------------------
local displayQuestInformation, refreshQuestInformation, hideQuestInformation
do --Display quest log information
	local stack, temp = {}, {}
	local lhrepl = {["<"] = "&lt;", [">"] = "&gt;"}
	local currentQid, currentPage, tq2ParentFrame
	local qlFontN, qlFontH1, qlFontH2, lhFont = CreateFont("tq2QlFontN"), CreateFont("tq2QlFontH1"), CreateFont("tq2QlFontH2"), CreateFont("tq2LhFont")

	local function onUpdateFix(self, elapsed)
		self.text:SetText(self.updateText)
		self:SetScript("OnUpdate", nil)
	end

	local function onInfoSizeChanged(self, width, height)
		self.text:SetWidth(width - 65)
		self:setText(self.textBackup)
	end

	local function onCloseClick(self, button)
		currentQid = nil
		tq2ParentFrame:Hide()
	end

	local function onResizeMouseDown(self, button)
		tq2ParentFrame:StartSizing()
	end

	local function onMovingMouseDown(self, button)
		tq2ParentFrame:StartMoving()
	end

	local function onMouseUp(self, button)
		tq2ParentFrame:StopMovingOrSizing()
		local width, height = tq2ParentFrame:GetSize()
		prdb.tomQuest2ParentFrameWidth, prdb.tomQuest2ParentFrameHeight = width, height
		prdb.tomQuest2ParentFramePoint = "BOTTOMLEFT"
		prdb.tomQuest2ParentFrameX, prdb.tomQuest2ParentFrameY = tq2ParentFrame:GetLeft(), tq2ParentFrame:GetBottom()
		if prdb.showQuestLog then
			if prdb.showLightHeaded and LightHeaded then
				tq2ParentFrame.ql:SetSize(width/2, height)
				tq2ParentFrame.lh:SetSize(width/2, height)
			else
				tq2ParentFrame.ql:SetSize(width, height)
			end
		elseif prdb.showLightHeaded and LightHeaded then
			tq2ParentFrame.lh:SetSize(width, height)
		end
	end

	local function onIconClick(self, button)
		StaticPopup_Show("LIGHTHEADED_ABOUT_DIALOG")
	end

	local function onInfoEnter(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
		GameTooltip:SetText(self.text)
		GameTooltip:Show()
	end

	local function onAbandonClick(self, button)
		if quests[currentQid].id then
			SelectQuestLogEntry(quests[currentQid].id)
			SetAbandonQuest()
			local items = GetAbandonQuestItems()
			if items then
				StaticPopup_Hide("ABANDON_QUEST")
				StaticPopup_Show("ABANDON_QUEST_WITH_ITEMS", GetAbandonQuestName(), items)
			else
				StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
				StaticPopup_Show("ABANDON_QUEST", GetAbandonQuestName())
			end
		end
	end

	local function onShareClick(self, button)
		local wasSelected = GetQuestLogSelection()
		SelectQuestLogEntry(quests[currentQid].id)
		QuestLogPushQuest()
		SelectQuestLogEntry(wasSelected)
	end

	local function clean(text)
		text = gsub(text, "%[ul%]", "")
		text = gsub(text, "%[/ul%]", "")
		text = gsub(text, "%[li%]", "")
		text = gsub(text, "%[/li%]", "")
		text = gsub(text, "%[url=(.-)%](.-)%[/url%]", "lhref:external:%1:%2")
		return text
	end

	local function getQuestLogInformation(qid)
		local tIndex = 2
		if quests[qid].playersOnQuest > 1 then
			temp[1] = format("<HTML><BODY><H1>|cff%s%s%s|r &lt;%d&gt;</H1>", quests[qid].color, quests[qid].tag, quests[qid].title, quests[qid].playersOnQuest)
		else
			temp[1] = format("<HTML><BODY><H1>|cff%s%s%s|r</H1>", quests[qid].color, quests[qid].tag, quests[qid].title)
		end
		if not quests[qid].description then
			temp[tIndex] = LC["Quests information not yet available, please try once synchronization with party is complete"]
			tq2ParentFrame.ql:setText(tconcat(temp, "<P><BR/>", 1, tIndex).."</P></BODY></HTML>")
		else
			if questsObjectives[qid] then
				temp[tIndex] = format("<P>%s</P><P>", gsub(quests[qid].objective, "[<>]", lhrepl))
				for oid, qoData in pairs(questsObjectives[qid]) do
					tIndex = tIndex + 1
					local qoStatus, qoColor = updateQuestObjectiveStatus(qid, oid)
					temp[tIndex] = format("|cff%s%s|r : %s", qoColor, qoData.desc, format(qoStatus, qoColor))
				end
				tIndex = tIndex + 1
				temp[tIndex] = format("</P><BR/><H2>|c%s%s|r</H2>", prdb.color, QUEST_DESCRIPTION)
			else
				temp[tIndex] = format("<P>%s</P>", gsub(quests[qid].objective, "[<>]", lhrepl))
				tIndex = tIndex + 1
				temp[tIndex] = format("<H2>|c%s%s|r</H2>", prdb.color, QUEST_DESCRIPTION)
			end
			tIndex = tIndex + 1
			temp[tIndex] = format("<P>%s</P>", gsub(quests[qid].description, "[<>]", lhrepl))
			if (quests[qid].titleReward ~= "" or quests[qid].rewardSpellLink or (quests[qid].numRewards + quests[qid].numChoices + quests[qid].money + quests[qid].xp + quests[qid].talent + quests[qid].numReputations + quests[qid].numCurrencies) > 0 ) then
				tIndex = tIndex + 1
				temp[tIndex] = format("<H2>|c%s%s|r</H2><P>", prdb.color, QUEST_REWARDS)
				if quests[qid].numChoices > 0 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r<BR/>", prdb.color, REWARD_CHOICES)
					for i = 1, quests[qid].numChoices do
						local numItems = quests[qid].itemChoices[i].numItems
						if numItems > 1 then
							if quests[qid].itemChoices[i].texture and quests[qid].itemChoices[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("%d |T%s:32|t%s", numItems, quests[qid].itemChoices[i].texture, quests[qid].itemChoices[i].link)
							elseif quests[qid].itemChoices[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("%d %s", numItems, quests[qid].itemChoices[i].link)
							end
						else
							if quests[qid].itemChoices[i].texture and quests[qid].itemChoices[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("|T%s:32|t%s", quests[qid].itemChoices[i].texture, quests[qid].itemChoices[i].link)
							elseif quests[qid].itemChoices[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = quests[qid].itemChoices[i].link
							end
						end
					end
					if (quests[qid].titleReward ~= "" or quests[qid].rewardSpellLink or (quests[qid].numRewards + quests[qid].money + quests[qid].xp + quests[qid].talent + quests[qid].numReputations) > 0 ) then
						tIndex = tIndex + 1
						temp[tIndex] = format("<BR/>|c%s%s|r", prdb.color, REWARD_ITEMS)
					end
				else
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r", prdb.color, REWARD_ITEMS_ONLY)
				end
				if quests[qid].rewardSpellName ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r|T%s:32|t |cff71d5ff|Hlhref:spell:%d|h[%s]|h|r<BR/>", prdb.color, REWARD_SPELL, quests[qid].rewardSpellTexture, qid, quests[qid].rewardSpellName)
				end
				if quests[qid].money > 0 then
					tIndex = tIndex + 1
					temp[tIndex] = format("%s<BR/>", GetMoneyString(quests[qid].money))
				end
				if quests[qid].xp > 0 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r %d <BR/>", prdb.color, EXPERIENCE_COLON, quests[qid].xp)
				end
				if quests[qid].numReputations > 0 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r", prdb.color, REWARD_REPUTATION_TEXT)
					for faction, amount in pairs(quests[qid].reputationRewards) do
						tIndex = tIndex + 1
						temp[tIndex] = format(" |c%s- %s :|r %d", prdb.color, faction, amount)
					end
					temp[tIndex] = temp[tIndex].."<BR/>"
				end
				if quests[qid].talent > 0 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r %d<BR/>", prdb.color, BONUS_TALENTS, quests[qid].talent)
				end
				if quests[qid].titleReward ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("|c%s%s|r %s<BR/>", prdb.color, REWARD_TITLE, quests[qid].titleReward)
				end
				if quests[qid].numRewards > 0 then
					for i = 1, quests[qid].numRewards do
						local numItems = quests[qid].itemRewards[i].numItems
						if numItems > 1 then
							if quests[qid].itemRewards[i].texture and quests[qid].itemRewards[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("%d |T%s:32|t%s", numItems, quests[qid].itemRewards[i].texture, quests[qid].itemRewards[i].link)
							elseif quests[qid].itemRewards[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("%d %s", numItems, quests[qid].itemRewards[i].link)
							end
						else
							if quests[qid].itemRewards[i].texture and quests[qid].itemRewards[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = format("|T%s:32|t%s", quests[qid].itemRewards[i].texture, quests[qid].itemRewards[i].link)
							elseif quests[qid].itemRewards[i].link then
								tIndex = tIndex + 1
								temp[tIndex] = quests[qid].itemRewards[i].link
							end
						end
					end
				end
				if quests[qid].numCurrencies > 0 then
					for i = 1, quests[qid].numCurrencies do
						local numItems = quests[qid].currencies[i].numItems
						tIndex = tIndex + 1
						if numItems > 1 then
							temp[tIndex] = format("%d |T%s:32|t%s", numItems, quests[qid].currencies[i].texture, quests[qid].currencies[i].name)
						else
							temp[tIndex] = format("|T%s:32|t%s", quests[qid].currencies[i].texture, quests[qid].currencies[i].name)
						end
					end
				end
				tq2ParentFrame.ql:setText(tconcat(temp, "<BR/>", 1, tIndex).."</P></BODY></HTML>")
			else
				tq2ParentFrame.ql:setText(tconcat(temp, "<BR/>", 1, tIndex).."</BODY></HTML>")
			end
		end
	end

	local function getQuestLightHeadedInformation(qid, page, header)
		local title = quests[qid] and quests[qid].title or LightHeaded:GetQuestName(qid)
		local numComments = LightHeaded:GetNumQuestComments(qid) or 0
		currentPage, currentQid = page, qid
		if prdb.showAllCommentsOnOnePage or numComments == 0 then
			tq2ParentFrame.lh.next:Hide()
			tq2ParentFrame.lh.prev:Hide()
			tq2ParentFrame.lh.page:Hide()
		elseif not prdb.showAllCommentsOnOnePage then
			tq2ParentFrame.lh.next:Show()
			tq2ParentFrame.lh.prev:Show()
			tq2ParentFrame.lh.page:Show()
			tq2ParentFrame.lh.next:Enable()
			tq2ParentFrame.lh.prev:Enable()
			if page == 1 then
				tq2ParentFrame.lh.prev:Disable()
			elseif page == numComments + 1 then
				tq2ParentFrame.lh.next:Disable()
			end
		end
		local infoAvailable = LightHeaded:GetQuestData(qid)
		if not infoAvailable or not infoAvailable[1] then
			return tq2ParentFrame.lh:setText(format(LC["Could not find quest information for quest %s"], qid))
		end
		if prdb.showAllCommentsOnOnePage or page == 1 then
			temp[1] = header
			local tIndex = 4
			for qid, sharable, level, reqlev, stype, sname, sid, etype, ename, eid, exp, rep, series in LightHeaded:IterateQuestInfo(qid) do
				temp[2] = format("|c%s%s%s", prdb.color, LC["Name:|r "], title)
				temp[3] = format("%s |Hlhref:external:http://www.wowhead.com/?quest=%d|h%d|h", LC["Quest ID:|r"], qid, qid)
				if sharable then
					temp[4] = format("%s%s", LC["Sharable:|r "], YES)
				else
					temp[4] = format(LC["Sharable:|r "], NO)
				end
				if level ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("%s%d", LC["Level:|r "], level)
				end
				if reqlev ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("%s%d", LC["Required level:|r"], reqlev)
				end
				if stype ~= "" and sname ~= "" then
					tIndex = tIndex + 1
					if stype == "npc" then
						temp[tIndex] = format("%s|cFF0066FF|Hlhref:npc:%d:%s|h[%s]|h|r", LC["Starts:|r "], sid, sname, sname)
					else
						temp[tIndex] = format("%s%s", LC["Starts:|r "], sname)
					end
				end
				if etype ~= "" and ename ~= "" then
					tIndex = tIndex + 1
					if etype == "npc" then
						temp[tIndex] = format("%s|cFF0066FF|Hlhref:npc:%d:%s|h[%s]|h|r", LC["Ends:|r "], eid, ename, ename)
					else
						temp[tIndex] = format("%s%s", LC["Ends:|r "], ename)
					end
				end
				if exp ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("%s|r %d", EXPERIENCE_COLON, exp)
				end
				if rep ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = format("%s|r", REWARD_REPUTATION_TEXT)
					for name, value in rep:gmatch("([^\029]+)\029([^\029]+)") do
						tIndex = tIndex + 1
						temp[tIndex] = format(" - %s :|r %d", name, value)
					end
				end
				if series ~= "" then
					tIndex = tIndex + 1
					temp[tIndex] = LC["Quest series:|r"]
					for step, id in series:gmatch("([^\029]+)\029([^\029]+)") do
						tIndex = tIndex + 1
						if qid == id then
							temp[tIndex] = format("%d - %s|r", step, title)
						else
							temp[tIndex] = format("%d - |r|cFF0066FF|Hlhref:quest:%d|h[%s]|h|r", step, id, LightHeaded:GetQuestName(id))
						end
					end
				end
			end
			if prdb.showAllCommentsOnOnePage and numComments > 0 then
				tIndex = tIndex + 1
				temp[tIndex] = format("%s%s", LC["Comments for:|r "], title)
				for page = 1, numComments do
					tIndex = tIndex + 1
					temp[tIndex] = clean(LightHeaded:GetCommentText(qid, page))
				end
				tq2ParentFrame.lh:setText(tconcat(temp, "\n|c"..prdb.color, 1, tIndex - numComments).."\n"..tconcat(temp, "\n", tIndex - numComments + 1, tIndex))
			else
				tq2ParentFrame.lh:setText(tconcat(temp, "\n|c"..prdb.color, 1, tIndex))
			end
		elseif page > 1 then
			tq2ParentFrame.lh:setText(header.."|c"..prdb.color..LC["Comments for:|r "]..title.."\n"..clean(LightHeaded:GetCommentText(qid, page - 1)))
		end
		tq2ParentFrame.lh.page:SetText(format(LC["Page %s of %s"], page, numComments + 1))
	end

	local function onPrevNextClick(self, button)
		if currentPage then
			getQuestLightHeadedInformation(currentQid, currentPage + self.offset, #stack > 0 and "|cFF0066FF|Hlhref:back|h[Back]|h|r\n" or "")
		end
	end

	local function onHyperlinkClick(self, link)
		if not link then return end
		if link:match("^lhref:npc") then
			stack[#stack+1] = currentPage
			stack[#stack+1] = currentQid
			local id, name = link:match("^lhref:npc:(.+):(.+)$")
			id = tonumber(id)
			if LightHeaded:LoadNPCData(id) then
				local tIndex = 1
				temp[tIndex] = "|cFF0066FF|Hlhref:back|h[Back]|h|r\n\n\n"..LC["Known locations for "].."|cFFFFFFFF"..name.."|r:"
				for c, z, x, y in LightHeaded:IterateNPCLocs(id) do
					tIndex = tIndex + 1
					temp[tIndex] = "|cFF0066FF|Hlhref:zcoord:"..c..":"..z..":"..x..":"..y..":"..name.."|h["..LightHeaded:GetCoordText(x, y).."]|h|r"
				end
				tq2ParentFrame.lh:setText(tconcat(temp, "\n", 1, tIndex))
			else
				tq2ParentFrame.lh:setText("|cFF0066FF|Hlhref:back|h[Back]|h|r\n\n\n"..LC["Location unknown"].."|cFFFFFFFF"..name.."|r")
			end
			tq2ParentFrame.lh.next:Disable()
			tq2ParentFrame.lh.prev:Disable()
		elseif link:match("^lhref:coord") then
			local x, y, qid = link:match("^lhref:coord:([^:]+):([^:]+):(.+)")
			x, y = tonumber(x), tonumber(y)
			if not x or not y then
				tomQuest2:Print(format(LC["The coordinate you clicked on was not valid: %s"], link))
				return
			end
			local note = tonumber(qid) and LightHeaded:GetQuestName(qid) or qid
			if TomTom then
				TomTom:AddWaypoint(x, y, note)
			end
		elseif link:match("^lhref:zcoord") then
			local c, z, x, y, qid = link:match("^lhref:zcoord:([^:]+):([^:]+):([^:]+):([^:]+):(.+)")
			c, z, x, y = tonumber(c), tonumber(z), tonumber(x), tonumber(y)
			if not c or not z or not x or not y then
				tomQuest2:Print(format(LC["The coordinate you clicked on was not valid: %s"], link))
				return
			end
			local note = tonumber(qid) and LightHeaded:GetQuestName(qid) or qid
			if TomTom then
				TomTom:AddZWaypoint(c, z, x, y, note)
			end
		elseif link:match("^lhref:external") then
			local url = link:match("^lhref:external:(.+)$")
			ChatEdit_GetLastActiveWindow():Show()
			ChatEdit_GetLastActiveWindow():SetText(url)
			ChatEdit_FocusActiveWindow()
		elseif link:match("^lhref:quest:") then
			stack[#stack+1] = currentPage
			stack[#stack+1] = currentQid
			local qid = link:match("^lhref:quest:(.+)$")
			qid = tonumber(qid)
			getQuestLightHeadedInformation(qid, 1, #stack > 0 and "|cFF0066FF|Hlhref:back|h[Back]|h|r\n" or "")
		elseif link:match("^lhref:back$") then
			local qid = tremove(stack)
			local page = tremove(stack)
			getQuestLightHeadedInformation(qid, page, #stack > 0 and "|cFF0066FF|Hlhref:back|h[Back]|h|r\n" or "")
		elseif link:match("^lhref:item:") or link:match("^item:") then
			if link:match("^lhref:item:") then
				link = link:sub(7)
			end
			local name, chatLink = GetItemInfo(link)
			if name then
				if IsControlKeyDown() then
					DressUpItemLink(link)
				elseif IsShiftKeyDown() and ChatEdit_GetActiveWindow() then
					ChatEdit_InsertLink(chatLink)
					ChatEdit_FocusActiveWindow()
				else
					SetItemRef(link)
				end
			end
		elseif not link:match("^lhref:spell:(%d+)") then
			tomQuest2:Print(format(LC["Unmanaged lhref:%s "], link))
		end
	end

	local function onHyperlinkEnter(self, link)
		if not link then return end
		if link:match("^lhref:item") then
			GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
			GameTooltip:SetHyperlink(link:sub(7))
		elseif link:match("^item") then
			GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
			GameTooltip:SetHyperlink(link)
		elseif link:match("^lhref:spell:(%d+)") then
			local qid = tonumber(link:match("^lhref:spell:(%d+)"))
			if not qid then return end
			GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
			GameTooltip:SetQuestLogRewardSpell(quests[qid].id)
		end
	end

	local function createSubPanel(name, title)
		local panelFrame = CreateFrame("Frame", "tomQuest2"..name.."Frame", tq2ParentFrame)
		panelFrame:EnableMouse(true)
		panelFrame:SetMovable(1)
		panelFrame:SetResizable(1)
		panelFrame:SetMinResize(300, 300)
		panelFrame:SetFrameLevel(0)
		panelFrame.title = panelFrame:CreateFontString(nil, "ARTWORK")
		panelFrame.title:SetPoint("TOP", 0, -4)
		panelFrame.title:SetFontObject(GameFontHighlight)
		panelFrame.title:SetText(title)
		panelFrame.scroll = CreateFrame("ScrollFrame", "tomQuest2"..name.."ScrollFrame", panelFrame, "UIPanelScrollFrameTemplate")
		panelFrame.scroll:SetPoint("TOPLEFT", 30, -30)
		panelFrame.scroll:SetPoint("BOTTOMRIGHT", -35, 55)
		panelFrame.text = CreateFrame("SimpleHTML", "tomQuest2"..name.."SimpleHTML", panelFrame.scroll)
		panelFrame.text:SetPoint("TOPLEFT", 0, 0)
		panelFrame.text:SetHeight(300)
		panelFrame.text:SetFontObject(GameFontHighlight)
		panelFrame.text:SetScript("OnHyperlinkClick", onHyperlinkClick)
		panelFrame.text:SetScript("OnHyperlinkEnter", onHyperlinkEnter)
		panelFrame.text:SetScript("OnHyperlinkLeave", onLeave)
		panelFrame.scroll:SetScrollChild(panelFrame.text)
		panelFrame:SetScript("OnSizeChanged", onInfoSizeChanged)
		function panelFrame:setText(msg)
			panelFrame.updateText = msg
			panelFrame.textBackup = msg
			panelFrame:SetScript("OnUpdate", onUpdateFix)
		end
		return panelFrame
	end

	function displayQuestInformation(qid)
		if tomQuest2.moduleState["informations"] then
			if not quests[qid] then return end
			if currentQid == qid then
				currentQid = nil
				if tq2ParentFrame and tq2ParentFrame:IsVisible() then
					tq2ParentFrame:Hide()
				end
				return
			end
			currentQid, currentPage = qid, 1
			if not tq2ParentFrame then
				tq2ParentFrame = CreateFrame("frame", "tomQuest2ParentFrame", UIParent)
				tq2ParentFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = {left = 5, right = 5, top = 5, bottom = 5}, tile = true, tileSize = 16})
				tq2ParentFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])
				tq2ParentFrame:SetBackdropBorderColor(prdb.borderColor[1], prdb.borderColor[2], prdb.borderColor[3], prdb.borderColor[4])
				UISpecialFrames[#UISpecialFrames+1] = "tomQuest2ParentFrame"
				tq2ParentFrame:EnableMouse(true)
				tq2ParentFrame:SetMovable(1)
				tq2ParentFrame:SetResizable(1)
				tq2ParentFrame:SetFrameLevel(0)
				local close = CreateFrame("Button", nil, tq2ParentFrame, "UIPanelCloseButton")
				close:SetScript("OnClick", onCloseClick)
				close:SetPoint("TOPRIGHT")
				local resize = CreateFrame("Button", nil, tq2ParentFrame)
				resize:SetNormalTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
				resize:SetHighlightTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
				resize:SetSize(12, 12)
				resize.text = LC["Click to resize tomQuest2"]
				resize:SetScript("OnEnter", onInfoEnter)
				resize:SetScript("OnLeave", onLeave)
				resize:SetScript("OnMouseDown", onResizeMouseDown)
				resize:SetScript("OnMouseUp", onMouseUp)
				resize:SetPoint("BOTTOMRIGHT", -3, 3)
				local titlereg = CreateFrame("Button", nil, tq2ParentFrame)
				titlereg:SetHeight(20)
				titlereg:SetScript("OnMouseDown", onMovingMouseDown)
				titlereg:SetScript("OnMouseUp", onMouseUp)
				titlereg:SetPoint("TOPLEFT", 5, -5)
				titlereg:SetPoint("TOPRIGHT", 0, 0)
				if LightHeaded then
					tq2ParentFrame.lh = createSubPanel("lh", "tomQuest2 - LightHeaded")
					local icon = CreateFrame("Button", nil, tq2ParentFrame.lh)
					icon:SetSize(64, 64)
					icon:SetNormalTexture("Interface\\AddOns\\LightHeaded\\images\\wh_icon")
					icon:SetHighlightTexture("Interface\\AddOns\\LightHeaded\\images\\wh_icon_hover")
					icon:GetHighlightTexture():SetBlendMode("BLEND")
					icon:SetPoint("BOTTOMRIGHT", -10, -10)
					icon:SetScript("OnClick", onIconClick)
					tq2ParentFrame.lh.page = tq2ParentFrame.lh:CreateFontString(nil, "ARTWORK")
					tq2ParentFrame.lh.page:SetFontObject(GameFontNormalSmall)
					tq2ParentFrame.lh.page:SetPoint("BOTTOM", -32, 15)
					tq2ParentFrame.lh.prev = CreateFrame("Button", nil, tq2ParentFrame.lh)
					tq2ParentFrame.lh.prev:SetSize(21, 21)
					tq2ParentFrame.lh.prev:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up")
					tq2ParentFrame.lh.prev:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down")
					tq2ParentFrame.lh.prev:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled")
					tq2ParentFrame.lh.prev:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
					tq2ParentFrame.lh.prev:SetPoint("RIGHT", tq2ParentFrame.lh.page, "LEFT", -25, 0)
					tq2ParentFrame.lh.prev.text = LC["Previous page"]
					tq2ParentFrame.lh.prev.offset = -1
					tq2ParentFrame.lh.prev:SetScript("OnEnter", onInfoEnter)
					tq2ParentFrame.lh.prev:SetScript("OnLeave", onLeave)
					tq2ParentFrame.lh.prev:SetScript("OnClick", onPrevNextClick)
					tq2ParentFrame.lh.next = CreateFrame("Button", nil, tq2ParentFrame.lh)
					tq2ParentFrame.lh.next:SetSize(21, 21)
					tq2ParentFrame.lh.next:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up")
					tq2ParentFrame.lh.next:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down")
					tq2ParentFrame.lh.next:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled")
					tq2ParentFrame.lh.next:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
					tq2ParentFrame.lh.next:SetPoint("LEFT", tq2ParentFrame.lh.page, "RIGHT", 25, 0)
					tq2ParentFrame.lh.next.text = LC["Next page"]
					tq2ParentFrame.lh.next.offset = 1
					tq2ParentFrame.lh.next:SetScript("OnEnter", onInfoEnter)
					tq2ParentFrame.lh.next:SetScript("OnLeave", onLeave)
					tq2ParentFrame.lh.next:SetScript("OnClick", onPrevNextClick)
				end
				tq2ParentFrame.ql = createSubPanel("ql", "tomQuest2 - QuestLog")
				tq2ParentFrame.ql.abandon = CreateFrame("Button", "tq2QlAbandonFrame", tq2ParentFrame.ql, "UIPanelButtonTemplate")
				tq2ParentFrame.ql.abandon:SetSize(125, 21)
				tq2ParentFrame.ql.abandon:SetPoint("BOTTOMLEFT", tq2ParentFrame.ql, "BOTTOMLEFT", 15, 10)
				tq2ParentFrame.ql.abandon:SetText(ABANDON_QUEST)
				tq2ParentFrame.ql.abandon:SetScript("OnClick", onAbandonClick)
				tq2ParentFrame.ql.share = CreateFrame("Button", "tq2QlShareFrame", tq2ParentFrame.ql, "UIPanelButtonTemplate")
				tq2ParentFrame.ql.share:SetSize(125, 21)
				tq2ParentFrame.ql.share:SetPoint("BOTTOMRIGHT", tq2ParentFrame.ql, "BOTTOMRIGHT", -15, 10)
				tq2ParentFrame.ql.share:SetText(SHARE_QUEST)
				tq2ParentFrame.ql.share:SetScript("OnClick", onShareClick)
				tq2ParentFrame:SetAlpha(1)
				tq2ParentFrame:SetFrameStrata("HIGH")
			end
			qlFontN:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSize)
			qlFontH1:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSizeH1, "OUTLINE")
			qlFontH2:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSizeH2, "OUTLINE")
			tq2ParentFrame.ql.title:SetFontObject(qlFontN)
			tq2ParentFrame.ql.text:SetFontObject(qlFontN)
			tq2ParentFrame.ql.text:SetFontObject("h1", qlFontH1)
			tq2ParentFrame.ql.text:SetFontObject("h2", qlFontH2)
			if LightHeaded then
				lhFont:SetFont(LSM:Fetch("font", prdb.lhFont), prdb.lhFontSize)
				tq2ParentFrame.lh.title:SetFontObject(lhFont)
				tq2ParentFrame.lh.page:SetFontObject(lhFont)
				tq2ParentFrame.lh.text:SetFontObject(lhFont)
			end
			if prdb.showQuestLog then
				if quests[qid].id then
					tq2ParentFrame.ql.abandon:Enable()
					if numPartyMembers > 0 and quests[qid].sharable then
						tq2ParentFrame.ql.share:Enable()
					else
						tq2ParentFrame.ql.share:Disable()
					end
				else
					tq2ParentFrame.ql.abandon:Disable()
					tq2ParentFrame.ql.share:Disable()
				end
				if prdb.showLightHeaded and LightHeaded then
					tq2ParentFrame:SetMinResize(600, 300)
					local width, height = prdb.tomQuest2ParentFrameWidth / 2, prdb.tomQuest2ParentFrameHeight
					tq2ParentFrame.ql:SetSize(width, height)
					tq2ParentFrame.lh:SetSize(width, height)
					tq2ParentFrame.ql:ClearAllPoints()
					tq2ParentFrame.lh:ClearAllPoints()
					if prdb.attach == 1 then
						tq2ParentFrame.ql:SetPoint("TOPLEFT")
						tq2ParentFrame.ql:SetPoint("BOTTOMLEFT")
						tq2ParentFrame.lh:SetPoint("TOPRIGHT")
						tq2ParentFrame.lh:SetPoint("BOTTOMRIGHT")
					else
						tq2ParentFrame.ql:SetPoint("TOPRIGHT")
						tq2ParentFrame.ql:SetPoint("BOTTOMRIGHT")
						tq2ParentFrame.lh:SetPoint("TOPLEFT")
						tq2ParentFrame.lh:SetPoint("BOTTOMLEFT")
					end
					tq2ParentFrame.ql:Show()
					tq2ParentFrame.lh:Show()
					getQuestLightHeadedInformation(qid, 1, "")
				else
					tq2ParentFrame:SetMinResize(300, 300)
					local width, height = prdb.tomQuest2ParentFrameWidth, prdb.tomQuest2ParentFrameHeight
					tq2ParentFrame.ql:SetSize(width, height)
					tq2ParentFrame.ql:SetPoint("TOPLEFT")
					tq2ParentFrame.ql:SetPoint("BOTTOMRIGHT")
					tq2ParentFrame.ql:Show()
				end
				getQuestLogInformation(qid)
			elseif prdb.showLightHeaded and LightHeaded then
				tq2ParentFrame:SetMinResize(300, 300)
				local width, height = prdb.tomQuest2ParentFrameWidth, prdb.tomQuest2ParentFrameHeight
				tq2ParentFrame.lh:SetSize(width, height)
				tq2ParentFrame.lh:SetPoint("TOPLEFT")
				tq2ParentFrame.lh:SetPoint("BOTTOMRIGHT")
				tq2ParentFrame.ql:Hide()
				tq2ParentFrame.lh:Show()
				getQuestLightHeadedInformation(qid, 1, "")
			else
				tq2ParentFrame:Hide()
				return
			end
			tq2ParentFrame:ClearAllPoints()
			tq2ParentFrame:SetPoint(prdb.tomQuest2ParentFramePoint, prdb.tomQuest2ParentFrameX, prdb.tomQuest2ParentFrameY)
			tq2ParentFrame:SetSize(prdb.tomQuest2ParentFrameWidth, prdb.tomQuest2ParentFrameHeight)
			tq2ParentFrame:Show()
		elseif quests[qid] and quests[qid].id then
			QuestLog_OpenToQuest(quests[qid].id)
		end
	end

	function refreshQuestInformation()
		if currentQid then
			local qid = currentQid
			currentQid = nil
			displayQuestInformation(qid)
		end
	end

	function hideQuestInformation(qid)
		if qid == currentQid then
			currentQid = nil
			tq2ParentFrame:Hide()
		end
	end
end
tomQuest2.refreshQuestInformation = refreshQuestInformation

----------------------
--- Display Engine ---
----------------------
do --Display Engine layouts
	local TOOLTIP_PADDING, CELL_MARGIN_L, CELL_MARGIN_R, CELL_MARGIN_V, LINE_SPACING_V = 10, 14, 4, 3, 2
	local framesBackDrop = {questsTooltip = GameTooltip:GetBackdrop(), questsTracker = GameTooltip:GetBackdrop(), achievementsTracker = GameTooltip:GetBackdrop()}
	local statusBarBackDrop = {bgFile = "Interface\\ChatFrame\\ChatFrameBackground", insets = {top = -1, left = -1, bottom = -1, right = -1}}
	local sliderBackDrop = {bgFile = "Interface\\Buttons\\UI-SliderBar-Background", edgeFile = "Interface\\Buttons\\UI-SliderBar-Border", tile = true, edgeSize = 8, tileSize = 8, insets = {top = 3, left = 3, bottom = 3, right = 3}}
	local overridePointY = {TOPLEFT = UIParent:GetHeight(), BOTTOMLEFT = 0, TOPRIGHT = UIParent:GetHeight(), BOTTOMRIGHT = 0}
	local overridePointX = {TOPLEFT = 0, BOTTOMLEFT = 0, TOPRIGHT = UIParent:GetWidth(), BOTTOMRIGHT = UIParent:GetWidth()}

	local function startTrackerMoving(self)
		if prdb[self.containerType].lockTracker then return end
		self:StartMoving()
	end

	local function stopTrackerMoving(self)
		self:StopMovingOrSizing()
		local containerType, width, height = self.containerType, UIParent:GetWidth(), UIParent:GetHeight()
		local hhalf, xOffset, vhalf, yOffset, x, y
		if prdb[containerType].overrideAnchor then
			local overridePoint = prdb[containerType].overridePoint
			x, y = overridePointX[overridePoint], overridePointY[overridePoint]
		else
			x, y = self:GetCenter()
		end
		if x > width/2 then
			hhalf = "RIGHT"
			xOffset = -(width - self:GetRight())
		else
			hhalf = "LEFT"
			xOffset = self:GetLeft()
		end
		if y > height/2 then
			vhalf = "TOP"
			yOffset = -(height - self:GetTop())
		else
			vhalf = "BOTTOM"
			yOffset = self:GetBottom()
		end
		local point = vhalf..hhalf
		prdb[containerType].point, prdb[containerType].relativePoint, prdb[containerType].xOffset, prdb[containerType].yOffset = point, point, xOffset, yOffset
		self:SetPoint(prdb[containerType].point, UIParent, prdb[containerType].relativePoint, xOffset, yOffset)
	end

	local function setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, cellPadding, showButton, buttonSize, useItemSize, enableInteraction, displayFrame, cell, button)
		cell:EnableMouse(enableInteraction)
		local textWidth = min(max(cell.fs:GetStringWidth(), totalMinWidth - cellPadding - CELL_MARGIN_L), totalMaxWidth - cellPadding - CELL_MARGIN_L)
		maxTotalWidth = max(maxTotalWidth, textWidth)
		cell.fs:SetWidth(textWidth)
		local height
		if button then
			if showButton then
				button:Show()
				button:RegisterForClicks(enableInteraction and "AnyDown" or nil)
			else
				button:Hide()
			end
			if useItemSize then
				height = max(buttonSize, cell.fs:GetHeight())
			else
				height = cell.fs:GetHeight()
			end
		else
			height = cell.fs:GetHeight()
		end
		cell:SetHeight(height)
		cell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", cellPadding + CELL_MARGIN_L, -vSpaceUsed)
		vSpaceUsed = vSpaceUsed + height
		cell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", cellPadding + CELL_MARGIN_L + textWidth, -vSpaceUsed)
		cell:Show()
		return vSpaceUsed + LINE_SPACING_V, maxTotalWidth
	end

	local function setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, textCellPadding, showButton, buttonSize, useItemSize, enableInteraction, displayFrame, textCell, statusCell, button)
		textCell:EnableMouse(enableInteraction)
		local textWidth = min(max(textCell.fs:GetStringWidth(), minWidth - textCellPadding - CELL_MARGIN_L), maxWidth - textCellPadding - CELL_MARGIN_L)
		maxTextWidth = max(maxTextWidth, textWidth)
		textCell.fs:SetWidth(textWidth)
		statusCell:EnableMouse(enableInteraction)
		local statusWidth = min(max(statusCell.fs:GetStringWidth(), statusMinWidth), statusMaxWidth)
		maxStatusWidth = max(maxStatusWidth, statusWidth)
		statusCell.fs:SetWidth(statusWidth)
		maxTotalWidth = max(maxTotalWidth, textWidth + statusWidth)
		local height
		if button then
			if showButton then
				button:Show()
				button:RegisterForClicks(enableInteraction and "AnyDown" or nil)
			else
				button:Hide()
			end
			if useItemSize then
				height = max(buttonSize, textCell.fs:GetHeight(), statusCell.fs:GetHeight())
			else
				height = max(textCell.fs:GetHeight(), statusCell.fs:GetHeight())
			end
		else
			height = max(textCell.fs:GetHeight(), statusCell.fs:GetHeight())
		end
		textCell:SetHeight(height)
		statusCell:SetHeight(height)
		textCell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", textCellPadding + CELL_MARGIN_L, -vSpaceUsed)
		statusCell:SetPoint("TOPRIGHT", displayFrame, "TOPRIGHT", - CELL_MARGIN_R, -vSpaceUsed)
		vSpaceUsed = vSpaceUsed + height
		textCell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", textCellPadding + textWidth + CELL_MARGIN_L, -vSpaceUsed)
		statusCell:SetPoint("BOTTOMLEFT", displayFrame, "TOPRIGHT", -statusWidth - CELL_MARGIN_R, -vSpaceUsed)
		textCell:Show()
		statusCell:Show()
		return vSpaceUsed + LINE_SPACING_V, maxTextWidth, maxStatusWidth, maxTotalWidth
	end

	local function setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, achievementCellPadding, criteriaCellPadding)
		local displayFrame = displayFrames[tomQuest2.ACHIEVEMENTS_TRACKER_FRAME].scrollChild
		vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, achievementCellPadding, prdb.achievementsTracker.showAchievementIcon, achievementIconSize, true, enableInteraction, displayFrame, achievements[aid].cell, achievements[aid].icon)
		if achievements[aid].numCriteria == 0 then
			vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, achievements[aid].descriptionCell, nil)
		else
			local cIndex, numBooleanCriteriaColumns, maxCellWidth, rowHeight, hasCindex = 1, prdb.achievementsTracker.numBooleanCriteriaColumns, 0, 0
			for cid, critData in pairs(achievements[aid].criteria) do
				if critData.booleanCell and ((prdb.achievementsTracker.hideCompletedCriteria and achievements[aid].criteria[cid].completed == 0) or (not prdb.achievementsTracker.hideCompletedCriteria)) then
					local textWidth = min(max(critData.booleanCell.fs:GetStringWidth(), columnMinWidth - criteriaCellPadding - CELL_MARGIN_L), columnMaxWidth - criteriaCellPadding - CELL_MARGIN_L)
					maxCellWidth = max(maxCellWidth, textWidth)
				end
			end
			maxTotalWidth = max(maxTotalWidth, numBooleanCriteriaColumns*(maxCellWidth + CELL_MARGIN_L) + CELL_MARGIN_R)
			for cid, critData in pairs(achievements[aid].criteria) do
				if critData.booleanCell then
					if (prdb.achievementsTracker.hideCompletedCriteria and achievements[aid].criteria[cid].completed == 0) or (not prdb.achievementsTracker.hideCompletedCriteria) then
						hasCindex = true
						critData.booleanCell:EnableMouse(enableInteraction)
						critData.booleanCell.fs:SetWidth(maxCellWidth)
						rowHeight = max(rowHeight, critData.booleanCell.fs:GetHeight())
						critData.booleanCell:SetHeight(rowHeight)
						critData.booleanCell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", criteriaCellPadding + CELL_MARGIN_L + (cIndex-1) * (maxCellWidth + CELL_MARGIN_L), -vSpaceUsed)
						critData.booleanCell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", criteriaCellPadding + CELL_MARGIN_L + cIndex * maxCellWidth, -vSpaceUsed - rowHeight)
						critData.booleanCell:Show()
						if cIndex == numBooleanCriteriaColumns then
							vSpaceUsed = vSpaceUsed + rowHeight + LINE_SPACING_V
							cIndex, rowHeight = 1, 0
						else
							cIndex = cIndex + 1
						end
					else
						critData.booleanCell:Hide()
					end
				elseif critData.statusBar then
					if prdb.achievementsTracker.displayAsStatusBar then
						if achievements[aid].descriptionCell then
							vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, achievements[aid].descriptionCell, nil)
						end
						critData.statusBar:EnableMouse(enableInteraction)
						critData.statusBar:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", prdb.achievementsTracker.leftStatusBarPadding, -vSpaceUsed - 1)
						vSpaceUsed = vSpaceUsed + prdb.achievementsTracker.statusBarHeight + 2
						critData.statusBar:SetPoint("BOTTOMRIGHT", displayFrame, "TOPRIGHT", -prdb.achievementsTracker.rightStatusBarPadding, -vSpaceUsed + 1)
						critData.statusBar:Show()
						if critData.textCell then
							critData.textCell:Hide()
							critData.statusCell:Hide()
						end
					else
						critData.statusBar:Hide()
						achievements[aid].descriptionCell:Hide()
						vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, critData.textCell, critData.statusCell, nil)
					end
					cIndex = 1
				elseif (prdb.achievementsTracker.hideCompletedCriteria and achievements[aid].criteria[cid].completed == 0) or (not prdb.achievementsTracker.hideCompletedCriteria) then
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, critData.textCell, critData.statusCell, nil)
					cIndex = 1
				else
					critData.textCell:Hide()
					critData.statusCell:Hide()
					cIndex = 1
				end
			end
			if hasCindex then
				hasCindex = nil
				vSpaceUsed = vSpaceUsed + rowHeight + LINE_SPACING_V
			end
		end
		return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
	end

	local function hideAchievementCells(aid)
		achievements[aid].cell:Hide()
		achievements[aid].icon:Hide()
		local descriptionCell = achievements[aid].descriptionCell
		if descriptionCell then
			descriptionCell:Hide()
		end
		for cid, critData in pairs(achievements[aid].criteria) do
			if critData.booleanCell then
				critData.booleanCell:Hide()
			elseif critData.statusBar then
				critData.statusBar:Hide()
			elseif critData.textCell then
				critData.textCell:Hide()
				critData.statusCell:Hide()
			end
		end
	end

	local function setAchievementsCategoryLayout(frameUsed, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, categoryCollapseIconSize, subCategoryCollapseIconSize, achievementIconSize, achievementCellPadding, criteriaCellPadding, subCategoryCellPadding, subAchievementCellPadding, subCriteriaCellPadding)
		local displayFrame = displayFrames[frameUsed].scrollChild
		if not next(achievements) then
			return displayFrame:Hide()
		elseif prdb.achievementsTracker.showByCategory then
			for cid, cData in pairs(achievementsCategories) do
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, 0, prdb.achievementsTracker.showCollapseButton, categoryCollapseIconSize, true, enableInteraction, displayFrame, tomQuest2.achievementCategoryTextCells[cid], tomQuest2.achievementCategoryStatusCells[cid], tomQuest2.achievementsCategoryButtons[cid])
				if chdb.categoryDisplay.achievementsTracker[cid] == 1 or not enableInteraction then
					if next(cData.achievements) then
						for aid in pairs(cData.achievements) do
							vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, achievementCellPadding, criteriaCellPadding)
						end
					end
					if next(cData.subCategory) then
						for scid, scData in pairs(cData.subCategory) do
							vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, subCategoryCellPadding, prdb.achievementsTracker.showCollapseButton, subCategoryCollapseIconSize, true, enableInteraction, displayFrame, tomQuest2.achievementCategoryTextCells[scid], tomQuest2.achievementCategoryStatusCells[scid], tomQuest2.achievementsCategoryButtons[scid])
							if chdb.categoryDisplay.achievementsTracker[scid] == 1 or not enableInteraction then
								for aid in pairs(scData) do
									vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, subAchievementCellPadding, subCriteriaCellPadding)
								end
							else
								for aid in pairs(scData) do
									hideAchievementCells(aid)
								end
							end
						end
					end
				else
					if next(cData.achievements) then
						for aid in pairs(cData.achievements) do
							hideAchievementCells(aid)
						end
					end
					if next(cData.subCategory) then
						for scid, scData in pairs(cData.subCategory) do
							tomQuest2.achievementCategoryTextCells[scid]:Hide()
							tomQuest2.achievementCategoryStatusCells[scid]:Hide()
							for aid in pairs(scData) do
								hideAchievementCells(aid)
							end
						end
					end
				end
			end
		else
			for aid, aData in pairs(achievements) do
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, achievementCellPadding, criteriaCellPadding)
			end
		end
		return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
	end

	local function setQuestLayout(qid, cellType, questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, enableInteraction)
		local displayFrame = displayFrames[cellType].scrollChild
		vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, questsCellPadding, (prdb[cellType].showQuestItemIcon and quests[qid].partyStatus ~= 1) and true or false, questItemIconSize, false, enableInteraction, displayFrame, quests[qid][cellType.."Text"], quests[qid][cellType.."Status"], quests[qid][cellType.."SpecialItem"] or quests[qid][cellType.."FakeItem"])
		local vSpaceUsedOld = vSpaceUsed
		if questsObjectives[qid] then
			for oid, qoData in ipairs(questsObjectives[qid]) do
				if prdb[cellType].hideCompletedObjective == 3 or (prdb[cellType].hideCompletedObjective == 2 and qoData.partyStatus == 0) or (prdb[cellType].hideCompletedObjective == 1 and qoData.playerStatus == 0) then
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, objectivesCellPadding, nil, nil, nil, enableInteraction, displayFrame, questsObjectives[qid][oid][cellType.."Text"], questsObjectives[qid][oid][cellType.."Status"], nil)
				else
					qoData[cellType.."Text"]:Hide()
					qoData[cellType.."Status"]:Hide()
				end
			end
		elseif quests[qid][cellType.."Description"] then
			vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, objectivesCellPadding, nil, nil, nil, enableInteraction, displayFrame, quests[qid][cellType.."Description"], nil)
		end
		if vSpaceUsedOld == vSpaceUsed then
			if quests[qid][cellType.."SpecialItem"] then
				quests[qid][cellType.."SpecialItem"]:Hide()
			elseif quests[qid][cellType.."FakeItem"] then
				quests[qid][cellType.."FakeItem"]:Hide()
			end
		end
		return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
	end

	local function hideQuest(qid)
		quests[qid].questsTrackerText:Hide()
		quests[qid].questsTrackerStatus:Hide()
		if questsObjectives[qid] then
			for _, qoData in ipairs(questsObjectives[qid]) do
				qoData.questsTrackerText:Hide()
				qoData.questsTrackerStatus:Hide()
			end
		elseif quests[qid].objective then
			quests[qid].questsTrackerDescription:Hide()
		end
	end

	local function setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, enableInteraction, collapseIconSize, questItemIconSize, questsCellPadding, objectivesCellPadding)
		local displayFrame = displayFrames.questsTracker.scrollChild
		if prdb.questsTracker.showByCategory then
			for _, category in ipairs(sortedCategories) do
				if not prdb.questsTracker.onlyCurrentZone or category == tomQuest2.currentZone then
					local vSpaceUsedOld = vSpaceUsed
					local questCategoryButton = questsCategories[category].questsTrackerCollapse
					local questCategoryCell = questsCategories[category].questsTracker
					vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, 0, prdb.questsTracker.showCollapseButton, collapseIconSize, true, enableInteraction, displayFrame, questCategoryCell, questCategoryButton)
					local hideCategory = true
					if chdb.categoryDisplay.questsTracker[category] == 1 or not enableInteraction then
						for _, qid in ipairs(sortedQuestsByCategory[category]) do
							if quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and quests[qid].partyStatus <= 0) or (prdb.questsTracker.hideCompletedQuest == 1 and quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (quests[qid].weightedLevel - playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
								hideCategory = false
								vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestLayout(qid, QUESTS_TRACKER, questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, enableInteraction)
							else
								hideQuest(qid)
							end
						end
						maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
					else
						for _, qid in ipairs(sortedQuestsByCategory[category]) do
							hideQuest(qid)
							if quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and quests[qid].partyStatus <= 0 ) or (prdb.questsTracker.hideCompletedQuest == 1 and quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (quests[qid].weightedLevel - playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
								hideCategory = false
							end
						end
					end
					if hideCategory then
						questCategoryCell:Hide()
						vSpaceUsed = vSpaceUsedOld
					else
						questCategoryCell:Show()
					end
				else
					questsCategories[category].questsTracker:Hide()
				end
			end
		else
			for _, qid in ipairs(sortedQuests) do
				if quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and quests[qid].partyStatus <= 0) or (prdb.questsTracker.hideCompletedQuest == 1 and quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (quests[qid].weightedLevel - playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestLayout(qid, "questsTracker", questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, enableInteraction)
				else
					hideQuest(qid)
				end
			end
			maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
		end
		if next(itemStartingQuest) then
			if prdb.questsTracker.showItemsStartingQuest then
				vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, 0, prdb.questsTracker.showCollapseButton, collapseIconSize, true, enableInteraction, displayFrame, qTrSQuestItemCategory, qTrSQuestItemCategoryButton)
				if chdb.sQuestItem == 1 or not enableInteraction then
					qTrSQuestItemFakeLine:SetSize(1, questItemIconSize)
					qTrSQuestItemFakeLine:Show()
					local i, attachPoint = 0, qTrSQuestItemFakeLine
					for itemId, button in pairs(itemStartingQuest) do
						i = i + 1
						button:SetPoint("TOPRIGHT", attachPoint, "TOPLEFT", 0, 0)
						attachPoint = button
						button:Show()
					end
					qTrSQuestItemFakeLine:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", CELL_MARGIN_L + i*questItemIconSize, -vSpaceUsed)
					vSpaceUsed = vSpaceUsed + questItemIconSize + LINE_SPACING_V
				else
					for itemId, button in pairs(itemStartingQuest) do
						button:Hide()
					end
				end
			else
				qTrSQuestItemCategory:Hide()
				qTrSQuestItemCategoryButton:Hide()
				qTrSQuestItemFakeLine:Hide()
				for itemId, button in pairs(itemStartingQuest) do
					button:Hide()
				end
			end
		else
			qTrSQuestItemCategory:Hide()
			qTrSQuestItemCategoryButton:Hide()
			qTrSQuestItemFakeLine:Hide()
		end
		if next(usableQuestItems) then
			if prdb.questsTracker.showUsableQuestItemsNotAttached then
				vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, 0, prdb.questsTracker.showCollapseButton, collapseIconSize, true, enableInteraction, displayFrame, qTrQuestItemCategory, qTrQuestItemCategoryButton)
				if chdb.questItem == 1 or not enableInteraction then
					qTrQuestItemFakeLine:SetSize(1, questItemIconSize)
					qTrQuestItemFakeLine:Show()
					local i, attachPoint = 0, qTrQuestItemFakeLine
					for itemId, button in pairs(usableQuestItems) do
						i = i + 1
						button:SetPoint("TOPRIGHT", attachPoint, "TOPLEFT", 0, 0)
						attachPoint = button
						button:Show()
					end
					qTrQuestItemFakeLine:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", CELL_MARGIN_L + i*questItemIconSize, -vSpaceUsed)
					vSpaceUsed = vSpaceUsed + questItemIconSize + LINE_SPACING_V
				else
					for itemId, button in pairs(usableQuestItems) do
						button:Hide()
					end
				end
			else
				qTrQuestItemFakeLine:Hide()
				qTrQuestItemCategory:Hide()
				qTrQuestItemCategoryButton:Hide()
				for itemId, button in pairs(usableQuestItems) do
					button:Hide()
				end
			end
		else
			qTrQuestItemFakeLine:Hide()
			qTrQuestItemCategory:Hide()
			qTrQuestItemCategoryButton:Hide()
		end
		return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
	end

	local function sliderOnValueChanged(self)
		self:GetParent().scrollFrame:SetVerticalScroll(self:GetValue())
	end

	local function tooltipOnMouseWheel(self, delta)
		local slider = self.slider
		local currentValue = slider:GetValue()
		local minValue, maxValue = slider:GetMinMaxValues()
		if delta < 0 and currentValue < maxValue then
			slider:SetValue(min(maxValue, currentValue + 10))
		elseif delta > 0 and currentValue > minValue then
			slider:SetValue(max(minValue, currentValue - 10))
		end
	end

	function updateScrolling(self, maxheight)
		local scale, topside, bottomside = self:GetScale(), self:GetTop(), self:GetBottom()
		local screensize, tipsize = UIParent:GetHeight()/scale, (topside - bottomside)/scale
		if bottomside < 0 or topside > screensize or (maxheight and tipsize > maxheight) then
			local shrink = (bottomside < 0 and (5 - bottomside) or 0) + (topside > screensize and (topside - screensize + 5) or 0)
			if maxheight and tipsize - shrink > maxheight then
				shrink = tipsize - maxheight
			end
			self:SetHeight(2 * TOOLTIP_PADDING + self.height - shrink)
			self:SetWidth(2 * TOOLTIP_PADDING + self.width + 20)
			self.scrollFrame:SetPoint("RIGHT", self, "RIGHT", -(TOOLTIP_PADDING + 20), 0)
			self.slider:SetMinMaxValues(0, shrink)
			self.slider:Show()
			self:EnableMouseWheel(true)
			self:SetScript("OnMouseWheel", tooltipOnMouseWheel)
		else
			self:SetHeight(2 * TOOLTIP_PADDING + self.height)
			self:SetWidth(2 * TOOLTIP_PADDING + self.width)
			self.scrollFrame:SetPoint("RIGHT", self, "RIGHT", -TOOLTIP_PADDING, 0)
			if self.slider then
				self.slider:SetValue(0)
				self.slider:Hide()
				self:EnableMouseWheel(false)
				self:SetScript("OnMouseWheel", nil)
			end
		end
	end

	function getContainer(name, containerType)
		local container = CreateFrame("Frame", name, UIParent)
		container.containerType = containerType
		container.scrollFrame = CreateFrame("ScrollFrame", name.."ScrollFrame", container)
		container.scrollFrame:SetPoint("TOP", container, "TOP", 0, -TOOLTIP_PADDING)
		container.scrollFrame:SetPoint("BOTTOM", container, "BOTTOM", 0, TOOLTIP_PADDING)
		container.scrollFrame:SetPoint("LEFT", container, "LEFT", TOOLTIP_PADDING, 0)
		container.scrollFrame:SetPoint("RIGHT", container, "RIGHT", -TOOLTIP_PADDING, 0)
		container.slider = CreateFrame("Slider", name.."Slider", container)
		container.slider:SetOrientation("VERTICAL")
		container.slider:SetPoint("TOPRIGHT", container, "TOPRIGHT", -TOOLTIP_PADDING, -TOOLTIP_PADDING)
		container.slider:SetPoint("BOTTOMRIGHT", container, "BOTTOMRIGHT", -TOOLTIP_PADDING, TOOLTIP_PADDING)
		container.slider:SetBackdrop(sliderBackDrop)
		container.slider:SetThumbTexture([[Interface\Buttons\UI-SliderBar-Button-Vertical]])
		container.slider:SetMinMaxValues(0, 1)
		container.slider:SetValueStep(1)
		container.slider:SetWidth(12)
		container.slider:SetScript("OnValueChanged", sliderOnValueChanged)
		container.slider:SetValue(0)
		container.scrollChild = CreateFrame("Frame", name.."ScrollChild", container.scrollFrame)
		container.scrollChild.cellType = containerType
		container.scrollFrame:SetScrollChild(container.scrollChild)
		return container
	end

	function setBackDrop(cellType)
		framesBackDrop[cellType].bgFile = LSM:Fetch("background", prdb[cellType].bgTexture)
		framesBackDrop[cellType].edgeFile = LSM:Fetch("border", prdb[cellType].borderTexture)
		framesBackDrop[cellType].insets.left = prdb[cellType].borderInset
		framesBackDrop[cellType].insets.right = prdb[cellType].borderInset
		framesBackDrop[cellType].insets.top = prdb[cellType].borderInset
		framesBackDrop[cellType].insets.bottom = prdb[cellType].borderInset
		framesBackDrop[cellType].edgeSize = prdb[cellType].borderWidth
	end

	function setQuestsTooltipLayout()
		local minWidthQTo, maxWidthQTo = prdb.questsTooltip.minWidth + CELL_MARGIN_L, prdb.questsTooltip.maxWidth + CELL_MARGIN_L
		local statusMinWidthQTo, statusMaxWidthQTo = prdb.questsTooltip.statusMinWidth + CELL_MARGIN_R, prdb.questsTooltip.statusMaxWidth + CELL_MARGIN_R
		local totalMinWidthQTo, totalMaxWidthQTo = minWidthQTo + statusMinWidthQTo + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthQTo + statusMaxWidthQTo + CELL_MARGIN_L + CELL_MARGIN_R
		local collapseIconSizeQTo, questItemIconSizeQTo = prdb.questsTooltip.collapseButtonSize, prdb.questsTooltip.questItemIconSize
		local questsCellPaddingQTo, objectivesCellPaddingQTo
		if prdb.questsTooltip.showQuestItemIcon then
			questsCellPaddingQTo = prdb.questsTooltip.questsCellPadding + questItemIconSizeQTo
			objectivesCellPaddingQTo = prdb.questsTooltip.objectivesCellPadding + questItemIconSizeQTo
		else
			questsCellPaddingQTo = prdb.questsTooltip.questsCellPadding
			objectivesCellPaddingQTo = prdb.questsTooltip.objectivesCellPadding
		end
		local questsTooltip = displayFrames.questsTooltip
		local displayFrame = questsTooltip.scrollChild
		local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, 0, 0, 0
		vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, prdb.questsTooltip.showCollapseButton, collapseIconSizeQTo, true, true, displayFrame, tooltipHeaderCell, tooltipHeaderButton, true)
		vSpaceUsed = vSpaceUsed + 20
		for _, category in ipairs(sortedCategories) do
			vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, prdb.questsTooltip.showCollapseButton, collapseIconSizeQTo, true, true, displayFrame, questsCategories[category].questsTooltip, questsCategories[category].questsTooltipCollapse)
			if chdb.categoryDisplay.questsTooltip[category] == 1 then
				for _, qid in ipairs(sortedQuestsByCategory[category]) do
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestLayout(qid, QUESTS_TOOLTIP, questsCellPaddingQTo, objectivesCellPaddingQTo, questItemIconSizeQTo, minWidthQTo, maxWidthQTo, statusMinWidthQTo, statusMaxWidthQTo, totalMinWidthQTo, totalMaxWidthQTo, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, true)
				end
				maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
			else
				for _, qid in ipairs(sortedQuestsByCategory[category]) do
					quests[qid].questsTooltipText:Hide()
					quests[qid].questsTooltipStatus:Hide()
					if questsObjectives[qid] then
						for oid, qoData in ipairs(questsObjectives[qid]) do
							qoData.questsTooltipText:Hide()
							qoData.questsTooltipStatus:Hide()
						end
					elseif quests[qid].objective then
						quests[qid].questsTooltipDescription:Hide()
					end
				end
			end
		end
		vSpaceUsed = vSpaceUsed + 20
		if prdb.questsTooltip.showHints then
			for _, hintCell in pairs(hintCells) do
				vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, nil, nil, nil, true, displayFrame, hintCell, nil)
			end
		else
			for _, hintCell in pairs(hintCells) do
				hintCell:Hide()
			end
		end
		local headerWidth = tooltipHeaderCell.fs:GetStringWidth()
		tooltipHeaderCell.fs:SetWidth(headerWidth)
		local height = tooltipHeaderCell.fs:GetHeight()
		tooltipHeaderCell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", (maxTotalWidth - headerWidth)/2, -2*CELL_MARGIN_V)
		tooltipHeaderCell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPRIGHT", -(maxTotalWidth - headerWidth)/2, -2*CELL_MARGIN_V - height)
		questsTooltip:SetBackdrop(framesBackDrop.questsTooltip)
		questsTooltip:SetBackdropColor(prdb.questsTooltip.backDropColor[1], prdb.questsTooltip.backDropColor[2], prdb.questsTooltip.backDropColor[3], prdb.questsTooltip.backDropColor[4])
		questsTooltip:SetBackdropBorderColor(prdb.questsTooltip.borderColor[1], prdb.questsTooltip.borderColor[2], prdb.questsTooltip.borderColor[3], prdb.questsTooltip.borderColor[4])
		questsTooltip:SetScale(prdb.questsTooltip.scale)
		questsTooltip.height = vSpaceUsed
		questsTooltip.width = maxTotalWidth
		questsTooltip:SetHeight(vSpaceUsed)
		questsTooltip:SetWidth(maxTotalWidth)
		questsTooltip.scrollChild:SetHeight(vSpaceUsed)
		questsTooltip.scrollChild:SetWidth(maxTotalWidth)
		questsTooltip:EnableMouse(true)
	end

	function setQuestsTrackerLayout()
		local displayFrame = displayFrames.questsTracker
		if prdb.questsTracker.toggleTracker and not hideQuestsTracker then
			local minWidthQTr, maxWidthQTr = prdb.questsTracker.minWidth + CELL_MARGIN_L, prdb.questsTracker.maxWidth + CELL_MARGIN_L
			local statusMinWidthQTr, statusMaxWidthQTr = prdb.questsTracker.statusMinWidth + CELL_MARGIN_R, prdb.questsTracker.statusMaxWidth + CELL_MARGIN_R
			local totalMinWidthQTr, totalMaxWidthQTr = minWidthQTr + statusMinWidthQTr + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthQTr + statusMaxWidthQTr + CELL_MARGIN_L + CELL_MARGIN_R
			local collapseIconSizeQTr, questItemIconSizeQTr = prdb.questsTracker.collapseButtonSize, prdb.questsTracker.questItemIconSize
			local questsCellPaddingQTr, objectivesCellPaddingQTr
			if prdb.questsTracker.showByCategory then
				if prdb.questsTracker.showQuestItemIcon then
					questsCellPaddingQTr = prdb.questsTracker.questsCellPadding + questItemIconSizeQTr
					objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding + questItemIconSizeQTr
				else
					questsCellPaddingQTr = prdb.questsTracker.questsCellPadding
					objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding
				end
			else
				if prdb.questsTracker.showQuestItemIcon then
					questsCellPaddingQTr = prdb.questsTracker.questItemIconSize
					objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding - prdb.questsTracker.questsCellPadding + prdb.questsTracker.questItemIconSize
				else
					questsCellPaddingQTr = 0
					objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding - prdb.questsTracker.questsCellPadding
				end
			end
			local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, minWidthQTr, statusMinWidthQTr, totalMinWidthQTr
			if prdb.achievementsTracker.showInQuestTracker and next(achievementsCategories) then
				local columnMinWidthATr, columnMaxWidthATr = totalMinWidthQTr / prdb.achievementsTracker.numBooleanCriteriaColumns, totalMaxWidthQTr / prdb.achievementsTracker.numBooleanCriteriaColumns
				local categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr = prdb.achievementsTracker.categoryCollapseButtonSize, prdb.achievementsTracker.subCategoryCollapseButtonSize, prdb.achievementsTracker.achievementIconSize
				local criteriaCellPaddingATr, subCategoryCellPaddingATr = prdb.achievementsTracker.criteriaCellPadding, prdb.achievementsTracker.subCategoryCellPadding
				local achievementCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr
				if prdb.achievementsTracker.showByCategory then
					if prdb.achievementsTracker.showAchievementIcon then
						achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
					else
						achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
					end
					subAchievementCellPaddingATr = subCategoryCellPaddingATr + achievementCellPaddingATr
					subCriteriaCellPaddingATr = subCategoryCellPaddingATr + criteriaCellPaddingATr
				else
					if prdb.achievementsTracker.showAchievementIcon then
						achievementCellPaddingATr = achievementIconSizeATr
					else
						achievementCellPaddingATr = 0
					end
					subAchievementCellPaddingATr = achievementCellPaddingATr
					subCriteriaCellPaddingATr = criteriaCellPaddingATr
				end
				if prdb.achievementsTracker.positionInQuestTracker == 1 then
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsCategoryLayout(QUESTS_TRACKER, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr)
				else
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr)
					vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsCategoryLayout(QUESTS_TRACKER, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
				end
			else
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr)
			end
			if vSpaceUsed == 2*CELL_MARGIN_V then return displayFrame:Hide() end
			displayFrame:SetBackdrop(framesBackDrop.questsTracker)
			displayFrame:SetBackdropColor(prdb.questsTracker.backDropColor[1], prdb.questsTracker.backDropColor[2], prdb.questsTracker.backDropColor[3], prdb.questsTracker.backDropColor[4])
			displayFrame:SetBackdropBorderColor(prdb.questsTracker.borderColor[1], prdb.questsTracker.borderColor[2], prdb.questsTracker.borderColor[3], prdb.questsTracker.borderColor[4])
			displayFrame:SetScale(prdb.questsTracker.scale)
			displayFrame:SetParent(UIParent)
			displayFrame:SetPoint(prdb.questsTracker.point, UIParent, prdb.questsTracker.relativePoint, prdb.questsTracker.xOffset, prdb.questsTracker.yOffset)
			if not prdb.questsTracker.disableInteraction then
				displayFrame.height = vSpaceUsed
				displayFrame.width = maxTotalWidth
				displayFrame:SetHeight(vSpaceUsed)
				displayFrame:SetWidth(maxTotalWidth)
				displayFrame.scrollChild:SetHeight(vSpaceUsed)
				displayFrame.scrollChild:SetWidth(maxTotalWidth)
				displayFrame:EnableMouse(true)
				displayFrame:SetMovable(not prdb.questsTracker.lockTracker)
				displayFrame:RegisterForDrag("LeftButton")
				displayFrame:SetScript("OnDragStart", startTrackerMoving)
				displayFrame:SetScript("OnDragStop", stopTrackerMoving)
				updateScrolling(displayFrame, prdb.questsTracker.hasMaxHeight and prdb.questsTracker.maxHeight or nil)
			else
				displayFrame:SetHeight(vSpaceUsed)
				displayFrame:SetWidth(maxTotalWidth)
				displayFrame:EnableMouse(false)
			end
			displayFrame:Show()
		else
			displayFrame:Hide()
		end
	end

	function setAchievementsTrackerLayout()
		if not tomQuest2.moduleState[ACHIEVEMENTS_TRACKER] then return end
		local displayFrame = displayFrames.achievementsTracker
		if prdb.achievementsTracker.showInQuestTracker then
			displayFrame:Hide()
			return setQuestsTrackerLayout()
		elseif prdb.achievementsTracker.toggleTracker and next(achievements) and not hideAchievementsTracker then
			local minWidthATr, maxWidthATr = prdb.achievementsTracker.minWidth + CELL_MARGIN_L, prdb.achievementsTracker.maxWidth + CELL_MARGIN_L
			local statusMinWidthATr, statusMaxWidthATr = prdb.achievementsTracker.statusMinWidth + CELL_MARGIN_R, prdb.achievementsTracker.statusMaxWidth + CELL_MARGIN_R
			local totalMinWidthATr, totalMaxWidthATr = minWidthATr + statusMinWidthATr + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthATr + statusMaxWidthATr + CELL_MARGIN_L + CELL_MARGIN_R
			local columnMinWidthATr, columnMaxWidthATr = totalMinWidthATr / prdb.achievementsTracker.numBooleanCriteriaColumns, totalMaxWidthATr / prdb.achievementsTracker.numBooleanCriteriaColumns
			local categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr = prdb.achievementsTracker.categoryCollapseButtonSize, prdb.achievementsTracker.subCategoryCollapseButtonSize, prdb.achievementsTracker.achievementIconSize
			local criteriaCellPaddingATr, subCategoryCellPaddingATr = prdb.achievementsTracker.criteriaCellPadding, prdb.achievementsTracker.subCategoryCellPadding
			local achievementCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr
			if prdb.achievementsTracker.showByCategory then
				if prdb.achievementsTracker.showAchievementIcon then
					achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding + achievementIconSizeATr
				else
					achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
				end
				subAchievementCellPaddingATr = subCategoryCellPaddingATr + achievementCellPaddingATr
				subCriteriaCellPaddingATr = subCategoryCellPaddingATr + criteriaCellPaddingATr
			else
				if prdb.achievementsTracker.showAchievementIcon then
					achievementCellPaddingATr = achievementIconSizeATr
				else
					achievementCellPaddingATr = 0
				end
				subAchievementCellPaddingATr = achievementCellPaddingATr
				subCriteriaCellPaddingATr = criteriaCellPaddingATr
			end
			local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, minWidthATr, statusMinWidthATr, totalMinWidthATr
			vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setAchievementsCategoryLayout(tomQuest2.ACHIEVEMENTS_TRACKER_FRAME, 2*CELL_MARGIN_V, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthATr, maxWidthATr, statusMinWidthATr, statusMaxWidthATr, totalMinWidthATr, totalMaxWidthATr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
			if vSpaceUsed == 2*CELL_MARGIN_V then return displayFrame:Hide() end
			displayFrame:SetBackdrop(framesBackDrop[tomQuest2.ACHIEVEMENTS_TRACKER_FRAME])
			displayFrame:SetBackdropColor(prdb.achievementsTracker.backDropColor[1], prdb.achievementsTracker.backDropColor[2], prdb.achievementsTracker.backDropColor[3], prdb.achievementsTracker.backDropColor[4])
			displayFrame:SetBackdropBorderColor(prdb.achievementsTracker.borderColor[1], prdb.achievementsTracker.borderColor[2], prdb.achievementsTracker.borderColor[3], prdb.achievementsTracker.borderColor[4])
			displayFrame:SetScale(prdb.achievementsTracker.scale)
			displayFrame:SetParent(UIParent)
			displayFrame:SetPoint(prdb.achievementsTracker.point, UIParent, prdb.achievementsTracker.relativePoint, prdb.achievementsTracker.xOffset, prdb.achievementsTracker.yOffset)
			if not prdb.achievementsTracker.disableInteraction then
				displayFrame.height = vSpaceUsed
				displayFrame.width = maxTotalWidth
				displayFrame:SetHeight(vSpaceUsed)
				displayFrame:SetWidth(maxTotalWidth)
				displayFrame.scrollChild:SetHeight(vSpaceUsed)
				displayFrame.scrollChild:SetWidth(maxTotalWidth)
				displayFrame:EnableMouse(true)
				displayFrame:SetMovable(not prdb.achievementsTracker.lockTracker)
				displayFrame:RegisterForDrag("LeftButton")
				displayFrame:SetScript("OnDragStart", startTrackerMoving)
				displayFrame:SetScript("OnDragStop", stopTrackerMoving)
				updateScrolling(displayFrame, prdb.achievementsTracker.hasMaxHeight and prdb.achievementsTracker.maxHeight or nil)
			else
				displayFrame:SetHeight(vSpaceUsed)
				displayFrame:SetWidth(maxTotalWidth)
				displayFrame:EnableMouse(false)
			end
			displayFrame:Show()
		else
			displayFrame:Hide()
		end
	end
end
tomQuest2.setBackDrop, tomQuest2.setQuestsTrackerLayout, tomQuest2.setAchievementsTrackerLayout = setBackDrop, setQuestsTrackerLayout, setAchievementsTrackerLayout

local function skinChanged(self, SkinID, Gloss, Backdrop, Group, Button, Colors)
	prdb.skin.skin = SkinID
	prdb.skin.gloss = Gloss
	prdb.skin.backdrop = Backdrop
	prdb.skin.Colors = Colors
end

function tomQuest2:updateUsedMedia(event, mediatype, key)
	if mediatype == "font" then
		if key == prdb.questsTooltip.categoryFont then
			cQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.categoryFont), prdb.questsTooltip.categoryFontSize, prdb.questsTooltip.categoryFontOutline)
		end
		if key == prdb.questsTooltip.questFont then
			qQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questFont), prdb.questsTooltip.questFontSize, prdb.questsTooltip.questFontOutline)
		end
		if key == prdb.questsTooltip.questObjectiveFont then
			qoQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questObjectiveFont), prdb.questsTooltip.questObjectiveFontSize, prdb.questsTooltip.questObjectiveFontOutline)
		end
		if key == prdb.questsTracker.categoryFont then
			cQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.categoryFont), prdb.questsTracker.categoryFontSize, prdb.questsTracker.categoryFontOutline)
		end
		if key == prdb.questsTracker.questFont then
			qQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questFont), prdb.questsTracker.questFontSize, prdb.questsTracker.questFontOutline)
		end
		if key == prdb.questsTracker.questObjectiveFont then
			qoQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questObjectiveFont), prdb.questsTracker.questObjectiveFontSize, prdb.questsTracker.questObjectiveFontOutline)
		end
		if key == prdb.achievementsTracker.categoryFont then
			cATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.categoryFont), prdb.achievementsTracker.categoryFontSize, prdb.achievementsTracker.categoryFontOutline)
		end
		if key == prdb.achievementsTracker.subCategoryFont then
			scATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.subCategoryFont), prdb.achievementsTracker.subCategoryFontSize, prdb.achievementsTracker.subCategoryFontOutline)
		end
		if key == prdb.achievementsTracker.achievementFont then
			aATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementFont), prdb.achievementsTracker.achievementFontSize, prdb.achievementsTracker.achievementFontOutline)
		end
		if key == prdb.achievementsTracker.achievementCriterionFont then
			acATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementCriterionFont), prdb.achievementsTracker.achievementCriterionFontSize, prdb.achievementsTracker.achievementCriterionFontOutline)
		end
		if key == prdb.achievementsTracker.statusBarFont then
			sbATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.statusBarFont), prdb.achievementsTracker.statusBarFontSize, prdb.achievementsTracker.statusBarFontOutline)
		end
	end
end

function tomQuest2:PLAYER_REGEN_ENABLED()
	if self.updateBagAfterCombat then
		self.updateBagAfterCombat = nil
		BAG_UPDATE()
	end
	hideQuestsTracker = nil
	hideAchievementsTracker = nil
	setQuestsTrackerLayout()
	if not prdb.achievementsTracker.showInQuestTracker then
		setAchievementsTrackerLayout()
	end
end

function tomQuest2:PLAYER_REGEN_DISABLED()
	if prdb.questsTracker.hideTrackerInCombat then
		hideQuestsTracker = true
		displayFrames.questsTracker:Hide()
	end
	if prdb.achievementsTracker.hideTrackerInCombat and not prdb.achievementsTracker.showInQuestTracker then
		hideAchievementsTracker = true
		displayFrames.achievementsTracker:Hide()
	end
end

do --Cells generation
	local TOOLTIP_UPDATE_TIME, numItemButtons, numButtons, numStatusBar, numContentCells = TOOLTIP_UPDATE_TIME, 0, 0, 0, 0
	local itemButtonCache, buttonCache, statusBarCache, contentCellCache, temp = {}, {}, {}, {}, {}

	local interactivity = {
		chatLink = function(id, cellType)
			local _, link
			if cellType == QUESTS_TOOLTIP or cellType == QUESTS_TRACKER then
				link = format("|cff808080|Hquest:%d:%d|h[%s]|h|r", id, quests[id].level, quests[id].title)
			elseif cellType == ACHIEVEMENTS_TRACKER or cellType == "icon" then
				link = GetAchievementLink(id)
			end
			if link then
				ChatEdit_GetLastActiveWindow():Show()
				ChatEdit_GetLastActiveWindow():SetText(link)
				ChatEdit_FocusActiveWindow()
			end
		end,
		tooltip = function(id, cellType)
			local _, link
			if cellType == QUESTS_TOOLTIP or cellType == QUESTS_TRACKER then
				link = "quest:"..id
			elseif cellType == ACHIEVEMENTS_TRACKER or cellType == "icon" then
				link = GetAchievementLink(id)
			end
			if link then
				ItemRefTooltip:ClearLines()
				ShowUIPanel(ItemRefTooltip)
				if not ItemRefTooltip:IsVisible() then
					ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
				end
				ItemRefTooltip:SetHyperlink(link)
			end
		end,
		objectiveProgress = function(qid, cellType)
			if questsObjectives[qid] and quests[qid].playerStatus then
				ChatEdit_GetLastActiveWindow():Show()
				for _, qoData in pairs(questsObjectives[qid]) do
					ChatEdit_GetLastActiveWindow():SetText(format("{%s : %s/%s}", qoData.desc, qoData.playerGot, qoData.need))
				end
				ChatEdit_FocusActiveWindow()
			end
		end,
		macroUpdate = function(qid, cellType)
			if not quests[qid] or not quests[qid].specialItemID then return end
			local _, link = GetItemInfo(quests[qid].specialItemID)
			if link and not InCombatLockdown() then
				local _, _, itemString = find(link, "^|c%x+|H(.+)|h%[.*%]")
				local index = GetMacroIndexByName("tomQuest2_SI")
				if index == 0 then
					index = CreateMacro("tomQuest2_SI", 'INV_Misc_QuestionMark', format("#showtooltip\n/use %s", itemString), 0)
					PickupMacro(index)
				else
					EditMacro(index, "tomQuest2_SI", 'INV_Misc_QuestionMark', format("#showtooltip\n/use %s", itemString))
				end
			end
		end,
		shareQuest = function(qid, cellType)
			if numPartyMembers > 0 and quests[qid].id and quests[qid].sharable then
				local wasSelected = GetQuestLogSelection()
				SelectQuestLogEntry(quests[qid].id)
				QuestLogPushQuest()
				SelectQuestLogEntry(wasSelected)
			end
		end,
		trackQuest = function(qid, cellType)
			if chdb.questsTracked[qid] then
				RemoveQuestWatch(quests[qid].id, qid)
			elseif not chdb.questsTracked[qid] then
				AddQuestWatch(quests[qid].id, nil, qid)
			end
		end,
		abandonQuest = function(qid, cellType)
			if quests[qid].id then
				local wasSelected = GetQuestLogSelection()
				SelectQuestLogEntry(quests[qid].id)
				SetAbandonQuest()
				local abandonItems = GetAbandonQuestItems()
				if abandonItems then
					StaticPopup_Hide("ABANDON_QUEST")
					StaticPopup_Show("ABANDON_QUEST_WITH_ITEMS", GetAbandonQuestName(), abandonItems)
				else
					StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
					StaticPopup_Show("ABANDON_QUEST", GetAbandonQuestName())
				end
				SelectQuestLogEntry(wasSelected)
			end
		end,
		autoQuestComplete = function(qid, cellType)
			local id = quests[qid].id
			if id and quests[qid].playerStatus == 1 and GetQuestLogIsAutoComplete(id) then
				ShowQuestComplete(id)
			end
		end,
		displayQuest = function(qid, cellType)
			displayQuestInformation(qid)
		end,
		displayQuestInfo = function(qid, cellType)
			WorldMap_OpenToQuest(qid)
		end,
		removeTrackedAchievement = function(aid, cellType)
			RemoveTrackedAchievement(aid)
		end,
		displayAchievement = function(aid, cellType)
			ToggleAchievementFrame()
			if AchievementFrame:IsShown() then
				AchievementFrame_SelectAchievement(aid)
			end
		end,
		nothing = function()
			return
		end
	}

	local function formatTime(s)
		if s >= 60 then
			return format("%dm%ds", floor(s/60+0.5), floor(s%60))
		else
			return format("%ds", s)
		end
	end

	local function headerOnMouseDown(self, button)
		if chdb.collapseAll == 0 then
			chdb.collapseAll = 1
			for category in pairs(questsCategories) do
				chdb.categoryDisplay.questsTooltip[category] = 1
				questsCategories[category].questsTooltipCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
			end
			tooltipHeaderButton.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		else
			chdb.collapseAll = 0
			for category in pairs(questsCategories) do
				chdb.categoryDisplay.questsTooltip[category] = 0
				questsCategories[category].questsTooltipCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
			end
			tooltipHeaderButton.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		end
		setQuestsTooltipLayout()
		updateScrolling(displayFrames.questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
	end

	local function sQuestItemOnMouseDown(self, button)
		if chdb.sQuestItem == 1 then
			chdb.sQuestItem = 0
			qTrSQuestItemCategoryButton.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		else
			chdb.sQuestItem = 1
			qTrSQuestItemCategoryButton.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		end
		setQuestsTrackerLayout()
	end

	local function questItemOnMouseDown(self, button)
		if chdb.questItem == 1 then
			chdb.questItem = 0
			qTrQuestItemCategoryButton.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		else
			chdb.questItem = 1
			qTrQuestItemCategoryButton.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		end
		setQuestsTrackerLayout()
	end

	local function questsTooltipCategoryOnMouseDown(self, button)
		if chdb.categoryDisplay.questsTooltip[self.id] == 1 then
			chdb.categoryDisplay.questsTooltip[self.id] = 0
			local collapseAll = 0
			for category in pairs(questsCategories) do
				collapseAll = collapseAll + chdb.categoryDisplay.questsTooltip[category]
			end
			chdb.collapseAll = collapseAll == 0 and 0 or 1
			tooltipHeaderButton.iconTexture:SetTexture(collapseAll == 0 and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up")
			questsCategories[self.id].questsTooltipCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		else
			chdb.categoryDisplay.questsTooltip[self.id] = 1
			chdb.collapseAll = 1
			tooltipHeaderButton.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
			questsCategories[self.id].questsTooltipCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		end
		setQuestsTooltipLayout()
		updateScrolling(displayFrames.questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
	end

	local function questsTrackerCategoryOnMouseDown(self, button)
		if chdb.categoryDisplay.questsTracker[self.id] == 1 then
			chdb.categoryDisplay.questsTracker[self.id] = 0
			questsCategories[self.id].questsTrackerCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		else
			chdb.categoryDisplay.questsTracker[self.id] = 1
			questsCategories[self.id].questsTrackerCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		end
		setQuestsTrackerLayout()
	end

	local function achievementsTrackerCategoryOnMouseDown(self, button)
		if chdb.categoryDisplay.achievementsTracker[self.id] == 1 then
			chdb.categoryDisplay.achievementsTracker[self.id] = 0
			tomQuest2.achievementsCategoryButtons[self.id].iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
		else
			chdb.categoryDisplay.achievementsTracker[self.id] = 1
			tomQuest2.achievementsCategoryButtons[self.id].iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
		end
		setAchievementsTrackerLayout()
	end

	local function cellOnMouseDown(self, button)
		if button == "RightButton" then
			if IsShiftKeyDown() then
				interactivity[prdb[self.cellType].mouseRightShift](self.id, self.cellType)
			elseif IsControlKeyDown() then
				interactivity[prdb[self.cellType].mouseRightControl](self.id, self.cellType)
			elseif IsAltKeyDown() then
				interactivity[prdb[self.cellType].mouseRightAlt](self.id, self.cellType)
			else
				interactivity[prdb[self.cellType].mouseRight](self.id, self.cellType)
			end
		elseif button == "LeftButton" then
			if IsShiftKeyDown() then
				interactivity[prdb[self.cellType].mouseLeftShift](self.id, self.cellType)
			elseif IsControlKeyDown() then
				interactivity[prdb[self.cellType].mouseLeftControl](self.id, self.cellType)
			elseif IsAltKeyDown() then
				interactivity[prdb[self.cellType].mouseLeftAlt](self.id, self.cellType)
			else
				interactivity[prdb[self.cellType].mouseLeft](self.id, self.cellType)
			end
		elseif button == "MiddleButton" then
			if IsShiftKeyDown() then
				interactivity[prdb[self.cellType].mouseMiddleShift](self.id, self.cellType)
			elseif IsControlKeyDown() then
				interactivity[prdb[self.cellType].mouseMiddleControl](self.id, self.cellType)
			elseif IsAltKeyDown() then
				interactivity[prdb[self.cellType].mouseMiddleAlt](self.id, self.cellType)
			else
				interactivity[prdb[self.cellType].mouseMiddle](self.id, self.cellType)
			end
		end
	end

	local function wrongButtonOnClick(self, button)
		tomQuest2:Print(LC["This button is not clickable, you can use tomQuest2 macro system instead"])
		local _, link = GetItemInfo(self.id)
		if link and not InCombatLockdown() then
			local _, _, itemString = find(link, "^|c%x+|H(.+)|h%[.*%]")
			local index = GetMacroIndexByName("tomQuest2_SI")
			if index == 0 then
				index = CreateMacro("tomQuest2_SI", 'INV_Misc_QuestionMark', format("#showtooltip\n/use %s", itemString), 0)
				PickupMacro(index)
			else
				EditMacro(index, "tomQuest2_SI", 'INV_Misc_QuestionMark', format("#showtooltip\n/use %s", itemString))
			end
		end
	end

	local function linkOnEnter(self, link)
		if not link then return end
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:SetHyperlink(link)
		local width = GameTooltip:GetWidth()
		if width > prdb.maximumTooltipWidth then
			for i = 1, GameTooltip:NumLines() do
				_G["GameTooltipTextLeft"..i]:SetWidth(prdb.maximumTooltipWidth)
			end
		end
		GameTooltip:Show()
	end

	local function cellOnEnter(self)
		if self.cellType == QUESTS_TRACKER or self.cellType == QUESTS_TOOLTIP then
			if not prdb[self.cellType].overTooltip then return end
			linkOnEnter(self, "quest:"..self.id)
		elseif self.cellType == ACHIEVEMENTS_TRACKER or self.cellType == "icon" then
			if not prdb[ACHIEVEMENTS_TRACKER].overTooltip then return end
			linkOnEnter(self, GetAchievementLink(self.id))
		elseif self.cellType == "item" then
			if not prdb[self:GetParent().cellType].overTooltip then return end
			local _, link = GetItemInfo(self.id)
			linkOnEnter(self, link)
		end
	end

	local function itemOnEvent(self, event)
		if event == "BAG_UPDATE_COOLDOWN" then
			local start, duration, enable = GetItemCooldown(self.itemID)
			if start > 0 and duration > 0 and enable > 0 then
				self.coolDown:SetCooldown(start, duration)
				self.coolDown:Show()
			else
				self.coolDown:Hide()
			end
		elseif event == "PLAYER_TARGET_CHANGED" then
			self.rangeTimer = -1
		end
	end

	local function updateItemRange(self, elapsed)
		self.rangeTimer = self.rangeTimer - elapsed
		if self.rangeTimer <= 0 then
			if IsQuestLogSpecialItemInRange(self:GetID()) == 0 then
				self.iconTexture:SetVertexColor(0.8, 0.1, 0.1)
			else
				self.iconTexture:SetVertexColor(1.0, 1.0, 1.0)
			end
			self.rangeTimer = TOOLTIP_UPDATE_TIME
		end
	end

	local function timedQuestUpdate(self, elapsed)
		self.remainingTime = self.remainingTime - elapsed
		self.duration = self.duration + elapsed
		if self.duration >= 1 then
			self.duration = 0
			local qid, cellType = self.id, self.cellType
			if quests[qid] and self.remainingTime > 0 then
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s |cff%s%s|r", prdb[cellType].colorizeQuestLevel and quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or quests[qid].tag, prdb[cellType].colorizeQuestName and quests[qid].color or prdb[cellType].defaultQuestNameColor, quests[qid].title, quests[qid].playersOnQuest > 1 and "<"..quests[qid].playersOnQuest..">" or "", prdb[cellType].colorizeQuestTimer and getColorFromCompletionHEX(self.remainingTime / quests[qid].initialTimer) or prdb[cellType].defaultQuestTimerColor, formatTime(self.remainingTime))
			else
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s", prdb[cellType].colorizeQuestLevel and quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or quests[qid].tag, prdb[cellType].colorizeQuestName and quests[qid].color or prdb[cellType].defaultQuestNameColor, quests[qid].title, quests[qid].playersOnQuest > 1 and "<"..quests[qid].playersOnQuest..">" or "")
				self:SetScript("OnUpdate", nil)
				quests[qid].initialTimer, self.remainingTime = nil, nil
			end
		end
	end

	local function timedAchievementUpdate(self, elapsed)
		self.remainingTime = self.remainingTime - elapsed
		self.duration = self.duration + elapsed
		if self.duration >= 1 then
			self.duration = 0
			local aid = self.id
			if achievements[aid] and self.remainingTime > 0 then
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r", prdb.achievementsTracker.defaultANameColor, achievements[aid].name, prdb.achievementsTracker.colorizeATimer and getColorFromCompletionHEX(self.remainingTime / achievements[aid].duration) or prdb.achievementsTracker.defaultATimerColor, formatTime(self.remainingTime))
			else
				self.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultANameColor, achievements[aid].name)
				self:SetScript("OnUpdate", nil)
				self.remainingTime, achievements[aid].duration = nil, nil
			end
		end
	end

	function getItemButton(parentFrame, id, itemID, texture, hasRange, size)
		local button = tremove(itemButtonCache)
		if not button then
			numItemButtons = numItemButtons + 1
			local buttonName = "tomQuest2ItemButton"..numItemButtons
			button = CreateFrame("Button", buttonName, parentFrame, "WatchFrameItemButtonTemplate")
			button.iconTexture, button.coolDown, button.count, button.height = _G[buttonName.."IconTexture"], _G[buttonName.."Cooldown"], _G[buttonName.."Count"], button:GetHeight()
			button:SetNormalTexture("")
			button:SetPushedTexture("")
			button:SetHighlightTexture("")
			_G[buttonName.."HotKey"]:Hide()
			if LBFGroup then
				LBFGroup:AddButton(button)
			end
		else
			button:SetParent(parentFrame)
		end
		button:SetID(id)
		button.iconTexture:SetVertexColor(1.0, 1.0, 1.0)
		button.iconTexture:SetTexture(texture)
		if hasRange then
			button.rangeTimer = -1
			button:SetScript("OnUpdate", updateItemRange)
			button:RegisterEvent("PLAYER_TARGET_CHANGED")
		end
		button:RegisterEvent("BAG_UPDATE_COOLDOWN")
		button.itemID = itemID
		local start, duration, enable = GetItemCooldown(itemID)
		if start > 0 and duration > 0 and enable > 0 then
			button.coolDown:SetCooldown(start, duration)
			button.coolDown:Show()
		else
			button.coolDown:Hide()
		end
		button:SetScale(size/button.height)
		button:SetFrameLevel(parentFrame:GetFrameLevel()+1)
		button:SetScale(size/button.height)
		button:SetPoint("TOPRIGHT", parentFrame, "TOPLEFT")
		button:SetScript("OnEvent", itemOnEvent)
		return button
	end

	function recycleItemButton(button)
		if not button then return end
		button:SetParent(UIParent)
		button:ClearAllPoints()
		button:Hide()
		button:SetScript("OnEvent", nil)
		button:SetScript("OnUpdate", nil)
		button:UnregisterEvent("BAG_UPDATE_COOLDOWN")
		button:UnregisterEvent("PLAYER_TARGET_CHANGED")
		itemButtonCache[#itemButtonCache+1] = button
	end

	function getButton(parentFrame, texture, size, buttonType, value1)
		local button = tremove(buttonCache)
		if not button then
			numButtons = numButtons + 1
			local buttonName = "tomQuest2Button"..numButtons
			button = CreateFrame("Button", buttonName, parentFrame, "ItemButtonTemplate")
			button.iconTexture = _G[buttonName.."IconTexture"]
			button.height = button:GetHeight()
		else
			button:SetParent(parentFrame)
		end
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
		button.cellType = buttonType
		button.id = value1
		if buttonType == "item" then
			button:SetScript("OnEnter", cellOnEnter)
			button:SetScript("OnLeave", onLeave)
			button:SetScript("OnClick", wrongButtonOnClick)
			if LBFGroup then
				LBFGroup:AddButton(button)
			end
		elseif buttonType == "icon" then
			button:SetScript("OnEnter", cellOnEnter)
			button:SetScript("OnLeave", onLeave)
			if LBFGroup then
				LBFGroup:AddButton(button)
			end
		elseif buttonType == QUESTS_TOOLTIP then
			button:SetScript("OnClick", questsTooltipCategoryOnMouseDown)
		elseif buttonType == QUESTS_TRACKER then
			button:SetScript("OnClick", questsTrackerCategoryOnMouseDown)
		elseif buttonType == ACHIEVEMENTS_TRACKER then
			button:SetScript("OnClick", achievementsTrackerCategoryOnMouseDown)
		elseif buttonType == "header" then
			button:SetScript("OnClick", headerOnMouseDown)
		elseif buttonType == "sQuestItem" then
			button:SetScript("OnClick", sQuestItemOnMouseDown)
		elseif buttonType == "questItem" then
			button:SetScript("OnClick", questItemOnMouseDown)
		end
		button.iconTexture:SetTexture(texture)
		button:SetFrameLevel(parentFrame:GetFrameLevel()+1)
		button:SetScale(size/button.height)
		button:SetPoint("TOPRIGHT", parentFrame, "TOPLEFT")
		return button
	end

	function recycleButton(button)
		if not button then return end
		button:SetParent(UIParent)
		button:ClearAllPoints()
		button:Hide()
		if LBFGroup then
			LBFGroup:RemoveButton(button)
		end
		button:SetScript("OnEnter", nil)
		button:SetScript("OnLeave", nil)
		button:SetScript("OnClick", nil)
		button.link, button.category = nil, nil
		buttonCache[#buttonCache+1] = button
	end

	function getStatusBar(cellType, parentFrame, id, reqQuantity)
		local statusBar = tremove(statusBarCache)
		if not statusBar then
			numStatusBar = numStatusBar + 1
			local statusBarName = "tomQuest2StatusBar"..numStatusBar
			statusBar = CreateFrame("StatusBar", statusBarName, displayFrames[parentFrame].scrollChild)
			statusBar.status = statusBar:CreateFontString(statusBarName.."Status", "OVERLAY")
			statusBar.status:SetJustifyH("CENTER")
			statusBar.status:SetPoint("CENTER")
			statusBar.bg = statusBar:CreateTexture(nil, "BORDER")
			statusBar.bg:SetAllPoints(statusBar)
			statusBar:SetBackdrop(statusBarBackDrop)
			statusBar:SetBackdropColor(0, 0, 0)
		else
			statusBar:SetParent(displayFrames[parentFrame].scrollChild)
		end
		statusBar.cellType = cellType
		statusBar.id = id
		statusBar:SetScript("OnEnter", cellOnEnter)
		statusBar:SetScript("OnLeave", onLeave)
		statusBar:SetScript("OnMouseDown", cellOnMouseDown)
		statusBar.status:SetFontObject(sbATrFontTQ2)
		statusBar:SetMinMaxValues(0, reqQuantity)
		statusBar:SetFrameLevel(displayFrames[parentFrame].scrollChild:GetFrameLevel()+1)
		return statusBar
	end

	function recycleStatusBar(statusBar)
		if not statusBar then return end
		statusBar:SetParent(UIParent)
		statusBar:ClearAllPoints()
		statusBar:Hide()
		statusBarCache[#statusBarCache+1] = statusBar
	end

	function updateStatusbar(aid, cid, cType, quantity, reqQuantity, color)
		local statusBar = achievements[aid].criteria[cid].statusBar
		statusBar:SetValue(quantity)
		statusBar:SetStatusBarTexture(LSM:Fetch("statusbar", prdb.achievementsTracker.statusBarTexture))
		statusBar.bg:SetTexture(LSM:Fetch("statusbar", prdb.achievementsTracker.statusBarTexture))
		local r, g, b
		if prdb.achievementsTracker.colorizeStatusBar then
			r, g, b = getColorFromCompletionRGB(quantity / reqQuantity)
		else
			r, g, b = unpack(prdb.achievementsTracker.defaultStatusBarColor)
		end
		statusBar.bg:SetVertexColor(r*0.33, g*0.33, b*0.33)
		statusBar:SetStatusBarColor(r, g, b)
		if cType == 62 or cType == 67 then
			statusBar.status:SetText(GetMoneyString(quantity))
		elseif prdb.achievementsTracker.colorizeStatusBarText then
			statusBar.status:SetFormattedText("|cff%s%s / %s|r", color, quantity, reqQuantity)
		else
			statusBar.status:SetFormattedText("|cff%s%s / %s|r", prdb.achievementsTracker.defaultStatusBarTextColor, quantity, reqQuantity)
		end
	end

	function getContentCell(font, justification, cellType, parentFrame, id, content, category)
		local contentCell = tremove(contentCellCache)
		if not contentCell then
			numContentCells = numContentCells + 1
			local contentCellName = "tomQuest2ContentCell"..numContentCells
			contentCell = CreateFrame("frame", contentCellName, UIParent)
			contentCell.fs = contentCell:CreateFontString()
			contentCell.fs:SetFontObject(font)
			contentCell.fs:SetJustifyH(justification)
			contentCell.fs:SetAllPoints(contentCell)
		else
			contentCell.fs:SetFontObject(font)
			contentCell.fs:SetJustifyH(justification)
		end
		contentCell.id, contentCell.cellType = id, cellType
		if content then
			contentCell:SetScript("OnEnter", cellOnEnter)
			contentCell:SetScript("OnLeave", onLeave)
			contentCell:SetScript("OnMouseDown", cellOnMouseDown)
		elseif category then
			if cellType == QUESTS_TOOLTIP then
				contentCell:SetScript("OnMouseDown", questsTooltipCategoryOnMouseDown)
			elseif cellType == QUESTS_TRACKER then
				contentCell:SetScript("OnMouseDown", questsTrackerCategoryOnMouseDown)
			elseif cellType == ACHIEVEMENTS_TRACKER then
				contentCell:SetScript("OnMouseDown", achievementsTrackerCategoryOnMouseDown)
			elseif cellType == "header" then
				contentCell:SetScript("OnMouseDown", headerOnMouseDown)
			elseif cellType == "sQuestItem" then
				contentCell:SetScript("OnMouseDown", sQuestItemOnMouseDown)
			elseif cellType == "questItem" then
				contentCell:SetScript("OnMouseDown", questItemOnMouseDown)
			end
		end
		contentCell:SetParent(displayFrames[parentFrame].scrollChild)
		contentCell:SetFrameLevel(displayFrames[parentFrame].scrollChild:GetFrameLevel()+1)
		return contentCell
	end

	function recycleContentCell(contentCell)
		if not contentCell then return end
		contentCell:SetParent(UIParent)
		contentCell:ClearAllPoints()
		contentCell:Hide()
		contentCell:SetScript("OnEnter", nil)
		contentCell:SetScript("OnLeave", nil)
		contentCell:SetScript("OnMouseDown", nil)
		contentCell:SetScript("OnUpdate", nil)
		contentCell.id = nil
		contentCellCache[#contentCellCache+1] = contentCell
	end

	function updateQuestCategoryCell(category, cellType)
		questsCategories[category][cellType].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r", prdb[cellType].colorizeCategoryName and questsCategories[category].color or prdb[cellType].defaultCategoryNameColor, category, prdb[cellType].colorizeCategoryLevel and questsCategories[category].color or prdb[cellType].defaultCategoryLevelColor, prdb[cellType].hideZoneLevelRange and "" or questsCategories[category].level)
	end

	function createQuestCategoryCell(category, cellType, font)
		if not chdb.categoryDisplay[cellType][category] then
			chdb.categoryDisplay[cellType][category] = 1
		end
		questsCategories[category][cellType] = getContentCell(font, "LEFT", cellType, cellType, category, nil, true)
		questsCategories[category][cellType.."Collapse"] = getButton(questsCategories[category][cellType], chdb.categoryDisplay[cellType][category] == 0 and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up", prdb[cellType].collapseButtonSize, cellType, category)
		updateQuestCategoryCell(category, cellType)
	end

	function removeQuestCategoryCells(category)
		recycleContentCell(questsCategories[category].questsTooltip)
		recycleContentCell(questsCategories[category].questsTracker)
		recycleButton(questsCategories[category].questsTooltipCollapse)
		recycleButton(questsCategories[category].questsTrackerCollapse)
	end

	function updateQuestTextCell(qid, cellType)
		if quests[qid].initialTimer then
			local remainingTime = quests[qid].initialTimer + quests[qid].startTime - GetTime()
			quests[qid][cellType.."Text"].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s |cff%s%s|r", prdb[cellType].colorizeQuestLevel and quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or quests[qid].tag, prdb[cellType].colorizeQuestName and quests[qid].color or prdb[cellType].defaultQuestNameColor, quests[qid].title, quests[qid].playersOnQuest > 1 and "<"..quests[qid].playersOnQuest..">" or "", prdb[cellType].colorizeQuestTimer and getColorFromCompletionHEX(remainingTime / quests[qid].initialTimer) or prdb[cellType].defaultQuestTimerColor, formatTime(remainingTime))
			quests[qid][cellType.."Text"].remainingTime = remainingTime
			quests[qid][cellType.."Text"].duration = 0
			quests[qid][cellType.."Text"]:SetScript("OnUpdate", timedQuestUpdate)
		else
			quests[qid][cellType.."Text"].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s", prdb[cellType].colorizeQuestLevel and quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or quests[qid].tag, prdb[cellType].colorizeQuestName and quests[qid].color or prdb[cellType].defaultQuestNameColor, quests[qid].title, quests[qid].playersOnQuest > 1 and "<"..quests[qid].playersOnQuest..">" or "")
		end
	end

	function updateQuestCells(qid)
		local questStatus
		if quests[qid].complete and next(quests[qid].complete) then
			local tIndex, partyStatus = 0, 1
			for partyName, completed in pairs(quests[qid].complete) do
				if completed == 1 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|cff%s%s|r: |cff%s%s|r", party[partyName].color, party[partyName].subName, prdb.completedColor, LC["Finished"])
				else
					partyStatus = 0
					if completed == -1 then
						tIndex = tIndex + 1
						temp[tIndex] = format("|cff%s%s|r: |cff%s%s|r", party[partyName].color, party[partyName].subName, prdb.failedColor, LC["Failed"])
					end
				end
			end
			if quests[qid].playerStatus then
				if quests[qid].playerStatus == 1 then
					tIndex = tIndex + 1
					temp[tIndex] = format("|cff%s%s|r", prdb.completedColor, LC["Finished"])
				else
					partyStatus = 0
					if quests[qid].playerStatus == -1 then
						tIndex = tIndex + 1
						temp[tIndex] = format("|cff%s%s|r", prdb.failedColor, LC["Failed"])
					end
				end
			end
			quests[qid].partyStatus = partyStatus
			questStatus = tconcat(temp, ", ", 1, tIndex)
		else
			if quests[qid].playerStatus == 1 then
				quests[qid].partyStatus = 1
				questStatus = format("|cff%s%s|r", prdb.completedColor, LC["Finished"])
			elseif quests[qid].playerStatus == -1 then
				quests[qid].partyStatus = 0
				questStatus = format("|cff%s%s|r", prdb.failedColor, LC["Failed"])
			else
				quests[qid].partyStatus = 0
				questStatus = ""
			end
		end
		updateQuestTextCell(qid, QUESTS_TOOLTIP)
		updateQuestTextCell(qid, QUESTS_TRACKER)
		quests[qid].questsTooltipStatus.fs:SetText(questStatus)
		quests[qid].questsTrackerStatus.fs:SetText(questStatus)
	end

	function removeQuestCells(qid)
		recycleItemButton(quests[qid].questsTooltipSpecialItem)
		recycleItemButton(quests[qid].questsTrackerSpecialItem)
		recycleButton(quests[qid].questsTooltipFakeItem)
		recycleButton(quests[qid].questsTrackerFakeItem)
		if questsObjectives[qid] then
			for oid, qoData in pairs(questsObjectives[qid]) do
				recycleContentCell(qoData.questsTooltipText)
				recycleContentCell(qoData.questsTrackerText)
				recycleContentCell(qoData.questsTooltipStatus)
				recycleContentCell(qoData.questsTrackerStatus)
			end
		end
		recycleContentCell(quests[qid].questsTooltipDescription)
		recycleContentCell(quests[qid].questsTrackerDescription)
		recycleContentCell(quests[qid].questsTooltipText)
		recycleContentCell(quests[qid].questsTrackerText)
		recycleContentCell(quests[qid].questsTooltipStatus)
		recycleContentCell(quests[qid].questsTrackerStatus)
	end

	function updateQuestObjectiveStatus(qid, oid)
		local qoStatus, qoColor
		local nNeed = questsObjectives[qid][oid].nNeed
		if questsObjectives[qid][oid].got and next(questsObjectives[qid][oid].got) then
			local tIndex, totalGot, playerStatus, partyStatus = 0, 0, 0, 1
			local totalNeed = nNeed * quests[qid].playersOnQuest
			for partyName, qoData in pairs(questsObjectives[qid][oid].got) do
				local nGot = questsObjectives[qid][oid].nGot[partyName]
				totalGot = totalGot + nGot
				tIndex = tIndex + 1
				if nGot == nNeed then
					temp[tIndex] = format("|cff%s%s|r : |cff%%1$s%s|r", party[partyName].color, party[partyName].subName, LC["d"])
				else
					partyStatus = 0
					temp[tIndex] = format("|cff%s%s|r : |cff%%1$s%s|r", party[partyName].color, party[partyName].subName, qoData)
				end
			end
			local nGot = questsObjectives[qid][oid].nPlayerGot
			if nGot then
				totalGot = totalGot + nGot
				tIndex = tIndex + 1
				if nGot == nNeed then
					playerStatus = 1
					temp[tIndex] = format("|cff%%1$s%s|r", LC["d"])
				else
					partyStatus = 0
					temp[tIndex] = format("|cff%%1$s%s|r", questsObjectives[qid][oid].playerGot)
				end
			end
			questsObjectives[qid][oid].playerStatus, questsObjectives[qid][oid].partyStatus = playerStatus, partyStatus
			qoColor = getColorFromCompletionHEX(totalGot/totalNeed)
			qoStatus = format("%s/|cff%s%s", tconcat(temp, ", ", 1, tIndex), qoColor, questsObjectives[qid][oid].need)
		else
			local nGot = questsObjectives[qid][oid].nPlayerGot
			if nGot == nNeed then
				questsObjectives[qid][oid].playerStatus, questsObjectives[qid][oid].partyStatus = 1, 1
				qoColor = getColorFromCompletionHEX(1)
				qoStatus = format("|cff%%1$s%s|r/|cff%%1$s%s", LC["d"], questsObjectives[qid][oid].need)
			else
				questsObjectives[qid][oid].playerStatus, questsObjectives[qid][oid].partyStatus = 0, 0
				qoColor = getColorFromCompletionHEX(nGot/nNeed)
				qoStatus = format("|cff%%1$s%s|r/|cff%%1$s%s", questsObjectives[qid][oid].playerGot, questsObjectives[qid][oid].need)
			end
		end
		return qoStatus, qoColor
	end

	function updateQuestObjectiveCells(qid, oid)
		local qoStatus, qoColor = updateQuestObjectiveStatus(qid, oid)
		questsObjectives[qid][oid].questsTooltipText.fs:SetFormattedText("|cff%s%s|r", prdb.questsTooltip.colorizeQuestObjective and qoColor or prdb.questsTooltip.defaultQuestObjectiveColor, questsObjectives[qid][oid].desc)
		questsObjectives[qid][oid].questsTrackerText.fs:SetFormattedText("|cff%s%s|r", prdb.questsTracker.colorizeQuestObjective and qoColor or prdb.questsTracker.defaultQuestObjectiveColor, questsObjectives[qid][oid].desc)
		questsObjectives[qid][oid].questsTooltipStatus.fs:SetFormattedText(qoStatus, prdb.questsTooltip.colorizeQuestObjectiveCounter and qoColor or prdb.questsTooltip.defaultQuestObjectiveColor)
		questsObjectives[qid][oid].questsTrackerStatus.fs:SetFormattedText(qoStatus, prdb.questsTracker.colorizeQuestObjectiveCounter and qoColor or prdb.questsTracker.defaultQuestObjectiveColor)
	end

	function createQuestDescriptionCells(qid)
		quests[qid].questsTooltipDescription = getContentCell(qoQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
		quests[qid].questsTrackerDescription = getContentCell(qoQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
		quests[qid].questsTooltipDescription.fs:SetFormattedText("|cff%s%s|r", prdb.questsTooltip.defaultQuestDescriptionColor, quests[qid].objective)
		quests[qid].questsTrackerDescription.fs:SetFormattedText("|cff%s%s|r", prdb.questsTracker.defaultQuestDescriptionColor, quests[qid].objective)
	end

	function updateAllQuestsStatus(event)
		for qid, questData in pairs(quests) do
			updateQuestCells(qid)
			if questsObjectives[qid] then
				for oid in pairs(questsObjectives[qid]) do
					updateQuestObjectiveCells(qid, oid)
				end
			end
		end
	end

	function updateAchievementCategoryCells(category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
		tomQuest2.achievementCategoryTextCells[category].fs:SetFormattedText("|cff%s%s|r", categoryColor, categoryName)
		tomQuest2.achievementCategoryStatusCells[category].fs:SetFormattedText("|cff%s%d/%d|r", categoryCounterColor, numTCA, numTA)
	end

	function createAchievementCategoryCells(font, size, category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
		if not chdb.categoryDisplay.achievementsTracker[category] then
			chdb.categoryDisplay.achievementsTracker[category] = 1
		end
		tomQuest2.achievementCategoryTextCells[category] = getContentCell(font, "LEFT", ACHIEVEMENTS_TRACKER, tomQuest2.ACHIEVEMENTS_TRACKER_FRAME, category, nil, true)
		tomQuest2.achievementCategoryStatusCells[category] = getContentCell(font, "RIGHT", ACHIEVEMENTS_TRACKER, tomQuest2.ACHIEVEMENTS_TRACKER_FRAME, category, nil, true)
		tomQuest2.achievementsCategoryButtons[category] = getButton(tomQuest2.achievementCategoryTextCells[category], chdb.categoryDisplay.achievementsTracker[category] == 1 and "Interface\\Buttons\\UI-MinusButton-Up" or "Interface\\Buttons\\UI-PlusButton-Up", size, ACHIEVEMENTS_TRACKER, category)
		updateAchievementCategoryCells(category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
	end

	function removeAchievementsCategoryCells(category)
		recycleContentCell(tomQuest2.achievementCategoryTextCells[category])
		recycleContentCell(tomQuest2.achievementCategoryStatusCells[category])
		recycleButton(tomQuest2.achievementsCategoryButtons[category])
		tomQuest2.achievementCategoryTextCells[category], tomQuest2.achievementCategoryStatusCells[category], tomQuest2.achievementsCategoryButtons[category] = nil, nil, nil
	end

end
tomQuest2.updateStatusbar, tomQuest2.updateQuestCategoryCell, tomQuest2.removeQuestCategoryCells, tomQuest2.updateQuestTextCell, tomQuest2.updateQuestObjectiveStatus, tomQuest2.updateQuestObjectiveCells, tomQuest2.createQuestDescriptionCells, tomQuest2.updateAchievementCategoryCells, tomQuest2.updateQuestCells = updateStatusbar, updateQuestCategoryCell, removeQuestCategoryCells, updateQuestTextCell, updateQuestObjectiveStatus, updateQuestObjectiveCells, createQuestDescriptionCells, updateAchievementCategoryCells, updateQuestCells

-----------------------------------
--- Achievements Tracker module ---
-----------------------------------
function tomQuest2:ACHIEVEMENT_EARNED(event, aid)
	if achievements[aid] then
		RemoveTrackedAchievement(aid)
	end
	local subCategory = GetAchievementCategory(aid)
	local subCategoryName, category = GetCategoryInfo(subCategory)
	local categoryName = GetCategoryInfo(category)
	if category and category > 0 then
		if achievementsCategories[subCategory] then
			local numTA, numTCA = GetCategoryNumAchievements(subCategory)
			local color = getColorFromCompletionHEX(numTCA / numTA)
			updateAchievementCategoryCells(subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			if achievementsCategories[subCategory].subCategory and achievementsCategories[subCategory].subCategory[category] then
				local numTA, numTCA = GetCategoryNumAchievements(category)
				local color = getColorFromCompletionHEX(numTCA / numTA)
				updateAchievementCategoryCells(category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			end
		end
	elseif achievementsCategories[subCategory] then
		local numTA, numTCA = GetCategoryNumAchievements(subCategory)
		local color = getColorFromCompletionHEX(numTCA / numTA)
		updateAchievementCategoryCells(subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
	end
end

function tomQuest2:CRITERIA_UPDATE()
	for aid in pairs(achievements) do
		for cid, critData in ipairs(achievements[aid].criteria) do
			local name, cType, completed, quantity, reqQuantity, _, flags = GetAchievementCriteriaInfo(aid, cid)
			completed = completed or 0
			if quantity ~= critData.quantity or completed ~= critData.completed then
				critData.completed, critData.quantity = completed, quantity
				if reqQuantity == 0 then reqQuantity = 1 end
				local color = getColorFromCompletionHEX(quantity / reqQuantity)
				if critData.booleanCell then
					critData.booleanCell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
					setAchievementsTrackerLayout()
				elseif critData.statusBar then
					updateStatusbar(aid, cid, cType, quantity, reqQuantity, color)
				elseif critData.textCell then
					critData.textCell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
					critData.statusCell.fs:SetFormattedText("|cff%s / %s|r", prdb.achievementsTracker.colorizeACrStatus and color or prdb.achievementsTracker.defaultACrStatusColor, quantity, reqQuantity)
				end
			end
		end
	end
end

function tomQuest2:TRACKED_ACHIEVEMENT_UPDATE(event, aid, cid, elapsed, duration)
	if not aid or not duration or not elapsed then return end
	if duration > elapsed then
		local startTime = GetTime() - elapsed
		if not achievements[aid] then
			AddTrackedAchievement(aid)
		end
		achievements[aid].startTime, achievements[aid].duration, achievements[aid].cell.duration = startTime, duration, 0
		achievements[aid].cell.remainingTime = duration - elapsed
		achievements[aid].cell:SetScript("OnUpdate", timedAchievementUpdate)
	elseif achievements[aid] and achievements[aid].startTime then
		achievements[aid].startTime = nil
		achievements[aid].duration = nil
	end
end

function tomQuest2:AddTrackedAchievement(aid, batch)
	if not self.achievementsFirstRun and IsTrackedAchievement(aid) then
		RemoveTrackedAchievement(aid)
	else
		local _, name, _, completed, _, _, _, description, _, texture = GetAchievementInfo(aid)
		local numCriteria = GetAchievementNumCriteria(aid)
		local subCategory = GetAchievementCategory(aid)
		local subCategoryName, category = GetCategoryInfo(subCategory)
		local categoryName = GetCategoryInfo(category)
		if category > 0 then
			achievements[aid] = {name = name, completed = completed, description = description, numCriteria = numCriteria, criteria = {}, category = category, subCategory = subCategory}
			if not achievementsCategories[category] then
				achievementsCategories[category] = {subCategory = {}, achievements = {}}
				local numTA, numTCA = GetCategoryNumAchievements(category)
				local color = getColorFromCompletionHEX(numTCA / numTA)
				createAchievementCategoryCells(cATrFontTQ2, prdb.achievementsTracker.categoryCollapseButtonSize, category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			end
			if not achievementsCategories[category].subCategory[subCategory] then
				local numTA, numTCA = GetCategoryNumAchievements(subCategory)
				achievementsCategories[category].subCategory[subCategory] = {[aid] = true}
				local color = getColorFromCompletionHEX(numTCA / numTA)
				createAchievementCategoryCells(scATrFontTQ2, prdb.achievementsTracker.subCategoryCollapseButtonSize, subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			else
				achievementsCategories[category].subCategory[subCategory][aid] = true
			end
		else
			achievements[aid] = {name = name, completed = completed, description = description, numCriteria = numCriteria, criteria = {}, category = category, subCategory = subCategory}
			if not achievementsCategories[subCategory] then
				local numTA, numTCA = GetCategoryNumAchievements(subCategory)
				achievementsCategories[subCategory] = {subCategory = {}, achievements = {[aid] = true}, name = subCategoryName}
				local color = getColorFromCompletionHEX(numTCA / numTA)
				createAchievementCategoryCells(cATrFontTQ2, prdb.achievementsTracker.categoryCollapseButtonSize, subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			else
				achievementsCategories[subCategory].achievements[aid] = true
			end
		end
		achievements[aid].cell = getContentCell(aATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
		achievements[aid].cell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultANameColor, name)
		achievements[aid].icon = getButton(achievements[aid].cell, texture, prdb.achievementsTracker.achievementIconSize, "icon", aid)
		achievements[aid].descriptionCell = getContentCell(acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
		achievements[aid].descriptionCell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultDescriptionColor, achievements[aid].description)
		if numCriteria > 0 then
			achievements[aid].criteria = {}
			for cid = 1, numCriteria do
				local name, cType, completed, quantity, reqQuantity, charName, flags, assetID, quantityString, cid2 = GetAchievementCriteriaInfo(aid, cid)
				if reqQuantity == 0 then reqQuantity = 1 end
				local color = getColorFromCompletionHEX(quantity / reqQuantity)
				if reqQuantity == 1 then
					achievements[aid].criteria[cid] = {id = cid2, name = name, completed = completed or 0, quantity = quantity}
					achievements[aid].criteria[cid].booleanCell = getContentCell(acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
					achievements[aid].criteria[cid].booleanCell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
				elseif bit.band(flags, ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR then
					achievements[aid].criteria[cid] = {id = cid2, name = name, completed = completed or 0, quantity = quantity, statusBar = getStatusBar(ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, reqQuantity)}
					updateStatusbar(aid, cid, cType, quantity, reqQuantity, color)
				else
					if (cType == 7 and quantity > 0) or cType ~= 7 then
						achievements[aid].criteria[cid] = {id = cid2, name = name, completed = completed or 0, quantity = quantity}
						achievements[aid].criteria[cid].textCell = getContentCell(acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
						achievements[aid].criteria[cid].statusCell = getContentCell(acATrFontTQ2, "RIGHT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
						achievements[aid].criteria[cid].textCell.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
						achievements[aid].criteria[cid].statusCell.fs:SetFormattedText("|cff%s%s/%s|r", prdb.achievementsTracker.colorizeACrStatus and color or prdb.achievementsTracker.defaultACrStatusColor, quantity, reqQuantity)
					end
				end
			end
		end
		if not batch then
			setAchievementsTrackerLayout()
		end
	end
	if AchievementFrame then
		AchievementFrameAchievements_ForceUpdate()
	end
end

function tomQuest2:RemoveTrackedAchievement(aid)
	if not IsTrackedAchievement(aid) or not achievements[aid] then return end
	if achievements[aid].startTime then
		achievements[aid].startTime = nil
		achievements[aid].duration = nil
	end
	local category, subCategory = achievements[aid].category, achievements[aid].subCategory
	recycleContentCell(achievements[aid].cell)
	recycleButton(achievements[aid].icon)
	if achievements[aid].descriptionCell then
		recycleContentCell(achievements[aid].descriptionCell)
	end
	if achievements[aid].criteria then
		for cid, critData in pairs(achievements[aid].criteria) do
			recycleContentCell(critData.textCell)
			recycleContentCell(critData.statusCell)
			recycleContentCell(critData.booleanCell)
			recycleStatusBar(critData.statusBar)
		end
	end
	achievements[aid] = nil
	if category > 0 and subCategory > 0 then
		achievementsCategories[category].subCategory[subCategory][aid] = nil
		if not next(achievementsCategories[category].subCategory[subCategory]) then
			removeAchievementsCategoryCells(subCategory)
			achievementsCategories[category].subCategory[subCategory] = nil
			if not next(achievementsCategories[category].subCategory) and not next(achievementsCategories[category].achievements) then
				achievementsCategories[category] = nil
				removeAchievementsCategoryCells(category)
			end
		end
	elseif subCategory > 0 then
		achievementsCategories[subCategory].achievements[aid] = nil
		if not next(achievementsCategories[subCategory].subCategory) and not next(achievementsCategories[subCategory].achievements) then
			achievementsCategories[subCategory] = nil
			removeAchievementsCategoryCells(subCategory)
		end
	end
	setAchievementsTrackerLayout()
	if AchievementFrame then
		AchievementFrameAchievements_ForceUpdate()
	end
end

function tomQuest2:IsTrackedAchievement(aid)
	return achievements[aid] and true or false
end

------------------------
--- quests functions ---
------------------------
local function removeCategory(category)
	removeQuestCategoryCells(category)
	questsCategories[category], questsByCategory[category], sortedQuestsByCategory[category] = nil, nil, nil
	for index, cat in ipairs(sortedCategories) do
		if cat == category then
			tremove(sortedCategories, index)
		end
	end
end

local function addQuest(qid, title, level, qtag, group, daily, numObjectives, category)
	if numObjectives > 0 then
		questsObjectives[qid] = {}
	end
	local qc = getDifficultyColor(level - playerLevel)
	local weightedLevel = levelTag[qtag](qid, level, group)
	local tagLevel = prdb.level == "questLevel" and level or weightedLevel
	local tag
	if tagLevel > 0 or qtag ~= "notag" or group > 0 or daily == 1 then
		tag = format("[%s%s%s%s]", tagLevel > 0 and tagLevel or "", prdb[qtag], group > 0 and group or "", daily == 1 and (qtag ~= "daily" and prdb["daily"] or "") or "")
	else
		tag = ""
	end
	quests[qid] = {
		title = title, level = level, weightedLevel = weightedLevel, shortTag = qtag, tag = tag, group = group, daily = daily,
		numObjectives = numObjectives, category = category, playersOnQuest = 0, color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	}
	quests[qid].questsTooltipText = getContentCell(qQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	quests[qid].questsTooltipStatus = getContentCell(qQToFontTQ2, "RIGHT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	quests[qid].questsTrackerText = getContentCell(qQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
	quests[qid].questsTrackerStatus = getContentCell(qQTrFontTQ2, "RIGHT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
end

local function addPlayerToQuest(qid, status, category, player)
	quests[qid].playersOnQuest = quests[qid].playersOnQuest + 1
	if not player then
		questsTitleToqid[quests[qid].title] = qid
		quests[qid].playerStatus = status
		questsByCategory[category][qid] = true
		if category == localClass then quests[qid].class = true end
		if prdb.partyHeader and quests[qid].playersOnQuest > 1 then
			questsByCategory[PARTYQUESTSZONE][qid] = nil
			if not next(questsByCategory[PARTYQUESTSZONE]) then
				removeCategory(PARTYQUESTSZONE)
			end
			tomQuest2:questsSort()
		end
		if not firstRun then
			tomQuest2:sendMessage("q", qid, quests[qid].title, quests[qid].level, quests[qid].shortTag, quests[qid].group, quests[qid].daily, quests[qid].numObjectives, status, category)
		end
	else
		if not quests[qid].complete then
			quests[qid].complete = {[player] = status}
		else
			quests[qid].complete[player] = status
		end
	end
	updateQuestCells(qid)
end

local function updateQuest(qid, status, message, player)
	if not player then
		quests[qid].playerStatus = status
		tomQuest2:sendMessage(message, qid)
	else
		quests[qid].complete[player] = status
	end
	updateQuestCells(qid)
end

local function addQuestObjective(qid, oid, desc, need, nNeed)
	questsObjectives[qid][oid] = {desc = desc, nNeed = nNeed, need = need}
	questsObjectives[qid][oid].questsTooltipText = getContentCell(qoQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	questsObjectives[qid][oid].questsTooltipStatus = getContentCell(qoQToFontTQ2, "RIGHT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	questsObjectives[qid][oid].questsTrackerText = getContentCell(qoQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
	questsObjectives[qid][oid].questsTrackerStatus = getContentCell(qoQTrFontTQ2, "RIGHT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
end

local function addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot, player)
	if not player then
		questsObjectives[qid][oid].playerGot = got
		questsObjectives[qid][oid].nPlayerGot= nGot
		if not firstRun then
			tomQuest2:sendMessage("o", qid, oid, desc, got, need, nGot, nNeed)
		end
	elseif not questsObjectives[qid][oid].got then
		questsObjectives[qid][oid].got = {[player] = got}
		questsObjectives[qid][oid].nGot = {[player] = nGot}
	else
		questsObjectives[qid][oid].got[player] = got
		questsObjectives[qid][oid].nGot[player] = nGot
	end
	updateQuestObjectiveCells(qid, oid)
end

local function removePartyFromQuest(sender, qid, abandoning)
	quests[qid].complete[sender] = nil
	if quests[qid].playersOnQuest == 1 then
		removeQuestCells(qid)
		questsObjectives[qid] = nil
		local category = prdb.partyHeader and PARTYQUESTSZONE or quests[qid].category
		quests[qid] = nil
		questsByCategory[category][qid] = nil
		if not next(questsByCategory[category]) then
			removeCategory(category)
		end
	else
		quests[qid].playersOnQuest = quests[qid].playersOnQuest - 1
		updateQuestCells(qid)
		if not next(quests[qid].complete) then
			quests[qid].complete = nil
			if questsObjectives[qid] then
				for oid in pairs(questsObjectives[qid]) do
					questsObjectives[qid][oid].got = nil
					questsObjectives[qid][oid].nGot = nil
					updateQuestObjectiveCells(qid, oid)
				end
			end
		else
			if questsObjectives[qid] then
				for oid in pairs(questsObjectives[qid]) do
					questsObjectives[qid][oid].got[sender] = nil
					questsObjectives[qid][oid].nGot[sender] = nil
					updateQuestObjectiveCells(qid, oid)
				end
			end
		end
	end
end

local function questLost(qid)
	if not quests[qid] then
		chdb.questsTracked[qid] = nil
		chdb.questsSubZoneAutoTracked[qid] = nil
		chdb.questsZoneAutoTracked[qid] = nil
		hideQuestInformation(qid)
	end
end

-----------------------------
--- Quests Tracker module ---
-----------------------------
function tomQuest2:AddQuestWatch(id, timeToTrack, qid, batch)
	if not qid then
		_, _, _, _, _, _, _, _, qid = GetQuestLogTitle(id)
		if not qid or not quests[qid] then return end
	end
	chdb.questsTracked[qid] = true
	if QuestLogFrame:IsVisible() then
		QuestLog_Update()
	end
	if not batch then
		setQuestsTrackerLayout()
	end
end

function tomQuest2:RemoveQuestWatch(id, qid, batch)
	if not qid and id then
		_, _, _, _, _, _, _, _, qid = GetQuestLogTitle(id)
	end
	if not qid or not quests[qid] then return end
	chdb.questsTracked[qid] = nil
	chdb.questsSubZoneAutoTracked[qid] = nil
	chdb.questsZoneAutoTracked[qid] = nil
	if not batch then
		setQuestsTrackerLayout()
	end
	if QuestLogFrame:IsVisible() then
		QuestLog_Update()
	end
end

local function questObjectiveProgress(qid, oid, got, nGot)
	if tomQuest2.moduleState["questsTracker"] and prdb.onObjectiveProgress then
		if not chdb.questsTracked[qid] then
			AddQuestWatch(quests[qid].id, prdb.unTrackInactive and prdb.unTrackDelay * 60 or nil, qid)
		else
			chdb.questsSubZoneAutoTracked[qid], chdb.questsZoneAutoTracked[qid] = nil, nil
		end
	end
end

------------------
--- Sync Party ---
------------------
local onCommand
do --Sync Receive
	local function short(value)
		if value >= 10000000 then
			return format("%.1fm", value / 1000000)
		elseif value >= 1000000 then
			return format("%.2fm", value / 1000000)
		elseif value >= 100000 then
			return format("%.0fk", value / 1000)
		elseif value >= 10000 then
			return format("%.1fk", value / 1000)
		else
			return format("%d", value)
		end
	end

	local function utf8sub(name)
		local bytes = string.len(name)
		if bytes <= 3 then
			return name
		else
			local len, pos = 0, 1
			while pos <= bytes do
				len = len + 1
				local c = string.byte(name, pos)
				if c > 0 and c <= 127 then
					pos = pos + 1
				elseif c >= 192 and c <= 223 then
					pos = pos + 2
				elseif c >= 224 and c <= 239 then
					pos = pos + 3
				elseif c >= 240 and c <= 247 then
					pos = pos + 4
				end
				if len == 3 then break end
			end
			return sub(name, 1, pos - 1)
		end
	end

	local comm = {
		v = function(sender, senderVersion, senderFirstCompatibleVersion, senderClass, currXP, maxXP)
			if senderVersion <= lastIncompatibleVersion then
				tomQuest2:Print(format(LC["The tomQuest2 release (%d) used by %s is too old to synchronise with your release (%d) (min %d)"], senderVersion, sender, version, firstCompatibleVersion))
				return
			elseif version < senderFirstCompatibleVersion then
				tomQuest2:Print(format(LC["Your tomQuest2 release (%d) is too old to synchorise with release (%d) of %s (min %d)"], version, senderVersion, sender, firstCompatibleVersion))
				tomQuest2.moduleState["syncParty"] = nil
				syncParty = nil
				return
			elseif version < senderVersion then
				tomQuest2:Print(format(LC["New release available (%d) ask %s where to find it"], senderVersion, sender))
			end
			if not party[sender] then
				party[sender] = {
					subName = utf8sub(sender), class = senderClass, color = classColors[senderClass], currXP = currXP, maxXP = maxXP, transfer = true,
					fmtXP = format("|cff%s%s / %s (%d%%)|r", getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
				}
			end
			syncParty = true
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("w", version, firstCompatibleVersion, playerClass, UnitXP("player"), UnitXPMax("player")), "WHISPER", sender, "BULK")
			for qid, qData in pairs(quests) do
				if qData.playerStatus then
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("q", qid, qData.title, qData.level, qData.shortTag, qData.group, qData.daily, qData.numObjectives, qData.playerStatus, qData.category), "WHISPER", sender, "BULK")
					local begun = 0
					if questsObjectives[qid] then
						for oid, qoData in pairs(questsObjectives[qid]) do
							tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("o", qid, oid, qoData.desc, qoData.playerGot, qoData.need, qoData.nPlayerGot, qoData.nNeed), "WHISPER", sender, "BULK")
							if qoData.nPlayerGot ~= 0 then begun = 1 end
						end
					end
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("r", qid, begun), "WHISPER", sender, "BULK")
				end
			end
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("d"), "WHISPER", sender, "BULK")
		end,
		w = function(sender, senderVersion, senderFirstCompatibleVersion, senderClass, currXP, maxXP)
			if senderVersion <= lastIncompatibleVersion then
				tomQuest2:Print(format(LC["The tomQuest2 release (%d) used by %s is too old to synchronise with your release (%d) (min %d)"], senderVersion, sender, version, firstCompatibleVersion))
				return
			elseif version < senderFirstCompatibleVersion then
				tomQuest2:Print(format(LC["Your tomQuest2 release (%d) is too old to synchorise with release (%d) of %s (min %d)"], version, senderVersion, sender, firstCompatibleVersion))
				tomQuest2.moduleState["syncParty"] = nil
				syncParty = nil
			elseif version < senderVersion then
				tomQuest2:Print(format(LC["New release available (%d) ask %s where to find it"], senderVersion, sender))
			end
			if not party[sender] then
				party[sender] = {
					subName = utf8sub(sender), class = senderClass, color = classColors[senderClass], currXP = currXP, maxXP = maxXP, transfer = true,
					fmtXP = format("|cff%s%s / %s (%d%%)|r", getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
				}
			end
			syncParty = true
		end,
		d = function(sender)
			if not party[sender] then return end
			party[sender].transfer = nil
			tomQuest2:questsSort()
			setQuestsTrackerLayout()
		end,
		q = function(sender, qid, title, level, tag, group, daily, numObjectives, completed, category)
			if not party[sender] then return end
			if not quests[qid] then
				addQuest(qid, title, level, tag, group, daily, numObjectives, category)
				category = prdb.partyHeader and PARTYQUESTSZONE or category
				if not questsCategories[category] then
					tomQuest2:addQuestCategory(category)
				end
				questsByCategory[category][qid] = true
				if not party[sender].transfer then
					sortedQuestsByCategory[category][#sortedQuestsByCategory[category]+1] = qid
					sort(sortedQuestsByCategory[category], qSort[prdb.questsSorting])
					sortedQuests[#sortedQuests+1] = qid
					sort(sortedQuests, qSort[prdb.questsSorting])
				end
			end
			addPlayerToQuest(qid, completed, category, sender)
			if not quests[qid].extras then
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("e", qid), "WHISPER", sender, "BULK")
			end
		end,
		o = function(sender, qid, oid, desc, got, need, nGot, nNeed)
			if not party[sender] or not questsObjectives[qid] then return end
			if not questsObjectives[qid][oid] then
				addQuestObjective(qid, oid, desc, need, nNeed)
			end
			addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot, sender)
		end,
		p = function(sender, qid, oid, got, nGot)
			if not party[sender] or not questsObjectives[qid] or not questsObjectives[qid][oid] or not questsObjectives[qid][oid].got or not questsObjectives[qid][oid].got[sender] then return end
			questsObjectives[qid][oid].got[sender] = got
			questsObjectives[qid][oid].nGot[sender] = nGot
			updateQuestObjectiveCells(qid, oid)
			if nGot == questsObjectives[qid][oid].nNeed then
				setQuestsTrackerLayout()
			end
			if tomQuest2.moduleState["notifications"] and prdb.notifyPartyObjectiveProgress then
				if nGot == questsObjectives[qid][oid].nNeed and prdb.notifyPartyObjectiveComplete then
					if not prdb.notifiyObjectiveProgressWhenQuestComplete and quests[qid].complete[sender] ~= 0 then return end
					tomQuest2:Pour(format(LC["(%s : %s) %s : finished"], sender, quests[qid].title, questsObjectives[qid][oid].desc), 0, 1, 0)
				elseif nGot > 0 then
					tomQuest2:Pour(format("(%s : %s) %s : %s / %s", sender, quests[qid].title, questsObjectives[qid][oid].desc, got, questsObjectives[qid][oid].need), getColorFromCompletionRGB(nGot/questsObjectives[qid][oid].nNeed))
				end
			end
			questObjectiveProgress(qid, oid, got, nGot)
		end,
		r = function(sender, qid, numObjectives, started)
			if not party[sender] or not quests[qid] or not quests[qid].complete[sender] then return end
			if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestAccepted and not party[sender].transfer then
				tomQuest2:Pour(format(LC["(%s : %s) : accepted"], sender, quests[qid].title), 0, 1, 0)
			end
			if party[sender].transfer then
				if not chdb.questsTracked[qid] and prdb.onLogIn then
					AddQuestWatch(quests[qid].id, nil, qid, true)
				end
			elseif prdb.onQuestAccepted == 1 or (prdb.onQuestAccepted == 2 and playerLevel ~= MAX_PLAYER_LEVEL) or (prdb.onObjectiveProgress and started == 1) or (prdb.onDaily and quests[qid].daily == 1) then
				if not chdb.questsTracked[qid] then
					AddQuestWatch(quests[qid].id, nil, qid)
				else
					chdb.questsSubZoneAutoTracked[qid] = nil
					chdb.questsZoneAutoTracked[qid] = nil
				end
			end
		end,
		e = function(sender, qid)
			if not party[sender] or not quests[qid] or not quests[qid].playerStatus then return end
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("g", qid, quests[qid].money,quests[qid].talent, quests[qid].titleReward, quests[qid].numRewards, quests[qid].numChoices, quests[qid].rewardSpellName, quests[qid].rewardSpellTexture, quests[qid].xp, quests[qid].numReputations, quests[qid].numCurrencies), "WHISPER", sender, "BULK")
			if quests[qid].numRewards and quests[qid].numRewards > 0 then
				for i, irData in pairs (quests[qid].itemRewards) do
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("i", qid, i, irData.name, irData.texture, irData.numItems, irData.quality, irData.isUsable, irData.link), "WHISPER", sender, "BULK")
				end
			end
			if quests[qid].numChoices and quests[qid].numChoices > 0 then
				for i, icData in pairs (quests[qid].itemChoices) do
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("j", qid, i, icData.name, icData.texture, icData.numItems, icData.quality, icData.isUsable, icData.link), "WHISPER", sender, "BULK")
				end
			end
			if quests[qid].numCurrencies and quests[qid].numCurrencies > 0 then
				for i, cData in pairs (quests[qid].currencies) do
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("m", qid, i, cData.name, cData.texture, cData.numItems), "WHISPER", sender, "BULK")
				end
			end
			if quests[qid].numReputations and quests[qid].numReputations > 0 then
				for faction, amount in pairs (quests[qid].reputationRewards) do
					tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("k", qid, faction, amount), "WHISPER", sender, "BULK")
				end
			end
			if quests[qid].objective then
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("n", qid, quests[qid].objective), "WHISPER", sender, "BULK")
			end
			if quests[qid].description then
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("t", qid, quests[qid].description), "WHISPER", sender, "BULK")
			end
		end,
		n = function(sender, qid, objective)
			if not party[sender] or not quests[qid] or quests[qid].objective then return end
			quests[qid].objective = objective
			local refresh
			if prdb.onSubZone and subZone ~= "" then
				if not chdb.questsTracked[qid] and quests[qid].objective and quests[qid].objective:find(subZone, 1, true) then
					chdb.questsSubZoneAutoTracked[qid] = true
					AddQuestWatch(quests[qid].id, nil, qid, true)
					refresh = true
				end
			end
			if not questsObjectives[qid] then
				createQuestDescriptionCells(qid)
				refresh = true
			end
			if refresh then
				setQuestsTrackerLayout()
			end
		end,
		t = function(sender, qid, description)
			if not party[sender] or not quests[qid] or quests[qid].description then return end
			quests[qid].description, quests[qid].extras = description, true
			if prdb.onSubZone and subZone ~= "" then
				if not chdb.questsTracked[qid] and quests[qid].description and quests[qid].description:find(subZone, 1, true) then
					chdb.questsSubZoneAutoTracked[qid] = true
					AddQuestWatch(quests[qid].id, nil, qid)
				end
			end
		end,
		g = function(sender, qid, money, talent, titleReward, numRewards, numChoices, rewardSpellName, rewardSpellTexture, xp, numReputations, numCurrencies)
			if not party[sender] or not quests[qid] or quests[qid].playerStatus then return end
			quests[qid].money = money
			quests[qid].talent = talent
			quests[qid].titleReward = titleReward
			quests[qid].numRewards = numRewards
			quests[qid].numChoices = numChoices
			quests[qid].rewardSpellName = rewardSpellName
			quests[qid].rewardSpellTexture = rewardSpellTexture
			quests[qid].xp = xp
			quests[qid].numReputations = numReputations
			quests[qid].numCurrencies = numCurrencies
		end,
		i = function(sender, qid, i, name, texture, numItems, quality, isUsable, link)
			if not party[sender] or not quests[qid] or quests[qid].playerStatus then return end
			quests[qid].itemRewards = quests[qid].itemRewards or {}
			if not quests[qid].itemRewards[i] then
				quests[qid].itemRewards[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = link}
			end
		end,
		j = function(sender, qid, i, name, texture, numItems, quality, isUsable, link)
			if not party[sender] or not quests[qid] or quests[qid].playerStatus then return end
			quests[qid].itemChoices = quests[qid].itemChoices or {}
			if not quests[qid].itemChoices[i] then
				quests[qid].itemChoices[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = link}
			end
		end,
		m = function(sender, qid, i, name, texture, numItems)
			if not party[sender] or not quests[qid] or quests[qid].playerStatus then return end
			quests[qid].currencies = quests[qid].currencies or {}
			if not quests[qid].currencies[i] then
				quests[qid].currencies[i] = {name = name, texture = texture, numItems = numItems}
			end
		end,
		k = function(sender, qid, faction, amount)
			if not party[sender] or not quests[qid] or quests[qid].playerStatus then return end
			quests[qid].reputationRewards = quests[qid].reputationRewards or {}
			quests[qid].reputationRewards[faction] = amount
		end,
		c = function(sender, qid)
			if not party[sender] or not quests[qid] or not quests[qid].complete or not quests[qid].complete[sender] then return end
			updateQuest(qid, 1, nil, sender)
			if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestComplete then
				tomQuest2:Pour(format(LC["(%s : %s) : finished"], sender, quests[qid].title), 0, 1, 0)
			end
		end,
		a = function(sender, qid)
			if not party[sender] or not quests[qid] or not quests[qid].complete or not quests[qid].complete[sender] then return end
			updateQuest(qid, 0, nil, sender)
		end,
		f = function(sender, qid)
			if not party[sender] or not quests[qid] or not quests[qid].complete or not quests[qid].complete[sender] then return end
			updateQuest(qid, -1, nil, sender)
			if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestFailed then
				tomQuest2:Pour(format(LC["(%s : %s) : failed"], sender, quests[qid].title), 1, 0, 0)
			end
		end,
		l = function(sender, qid, abandoning)
			if not party[sender] or not quests[qid] or not quests[qid].complete or not quests[qid].complete[sender] then return end
			if tomQuest2.moduleState["notifications"] then 
				if abandoning then
					if prdb.notifyPartyQuestAbandonned then
						tomQuest2:Pour(format(LC["(%s : %s) : abandonned"], sender, quests[qid].title), 1, 0, 0)
					end
				elseif prdb.notifyPartyQuestTurnedIn then
					tomQuest2:Pour(format(LC["(%s : %s) : turned in"], sender, quests[qid].title), 0, 1, 0)
				end
			end
			questLost(qid)
			removePartyFromQuest(sender, qid, abandoning)
			tomQuest2:questsSort()
			setQuestsTrackerLayout()
		end,
		x = function(sender, currXP)
			if not party[sender] then return end
			party[sender].currXP = currXP
			party[sender].fmtXP = format("|cff%s%s / %s (%d%%)|r", getColorFromCompletionHEX(currXP/party[sender].maxXP), short(currXP), short(party[sender].maxXP), floor(currXP/party[sender].maxXP*10000)/100)
		end,
		u = function(sender, currXP, maxXP)
			if not party[sender] then return end
			party[sender].currXP = currXP
			party[sender].maxXP = maxXP
			party[sender].fmtXP = format("|cff%s%s / %s (%d%%)|r", getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
		end,
	}

	function onCommand(sender, success, commHandler, ...)
		if not success then
			return
		elseif comm[commHandler] then
			comm[commHandler](sender, ...)
		end
	end
end

function tomQuest2:sendMessage(...)
	if self.moduleState["syncParty"] and syncParty then
		self:SendCommMessage("tomQ2", self:Serialize(...), "PARTY", nil, "BULK")
	end
end

function tomQuest2:commHandler(prefix, message, distribution, sender)
	if sender ~= playerName then
		onCommand(sender, self:Deserialize(message))
	end
end

-------------------------------------
--- Quests & Daily Quests Tooltip ---
-------------------------------------
local createQuestsTooltipDataObj, createDailyQuestsTooltipDataObj, updateDQToText, CHAT_MSG_SYSTEM, updateQuestCounter, resetDailyQuestsDB
do--Quest and daily quests dataobj OnLeave / OnClick
	local numCompletedDailyQuests = GetDailyQuestsCompleted() or 0
	local questsTooltipDataObj, dailyQuestsTooltipDataObj
	local fd, fh, fm = 1/86400, 1/3600, 1/60
	local NO_DAILY_QUESTS_REMAINING, MAX_QUESTS, MAX_DAILY, dailyPattern = NO_DAILY_QUESTS_REMAINING, MAX_QUESTS, 25, "^(%d-)^(.-)$"

	local function toggleModule(module)
		if tomQuest2.moduleState[module] then
			tomQuest2:disableModule(module)
		else
			tomQuest2:enableModule(module)
		end
	end

	local function getTipAnchor(frame)
		local x, y = frame:GetCenter()
		if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
		local hhalf = (x > UIParent:GetWidth() * 2/3) and "RIGHT" or (x < UIParent:GetWidth() / 3) and "LEFT" or ""
		local vhalf = (y > UIParent:GetHeight() / 2) and "TOP" or "BOTTOM"
		return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
	end

	local function hideTooltip()
		if displayFrames.questsTooltip:IsMouseOver() then return end
		displayFrames.questsTooltip:SetScript("OnUpdate", nil)
		displayFrames.questsTooltip:Hide()
	end

	local ldbOnClick = {
		openOptions = function()
			LoadAddOn("tomQuest2_Config")
			InterfaceOptionsFrame_OpenToCategory(tomQuest2.profilesOptionFrame)
			InterfaceOptionsFrame_OpenToCategory(tomQuest2.mainOptionFrame)
		end,
		toggleQuestTracker = function()
			tomQuest2:tQ2toggleQuestsTracker()
		end,
		toggleAchievementsTracker = function()
			tomQuest2:tQ2toggleAchievementsTracker()
		end,
		toggleAnnouncementModule = function()
			toggleModule("announce")
		end,
		toggleQuestsLog = function()
			ToggleFrame(QuestLogFrame)
		end,
		toggleSyncPartyModule = function()
			toggleModule("syncParty")
		end,
		toggleQuestsTrackerModule = function()
			toggleModule("questsTracker")
		end,
		toggleAchievementsTrackerModule = function()
			toggleModule("achievementsTracker")
		end,
		lockQuestsTracker = function()
			prdb.questsTracker.lockTracker = not prdb.questsTracker.lockTracker
			_G["tomQuest2QuestsTracker"]:SetMovable(prdb.questsTracker.lockTracker)
		end,
		lockAchievementsTracker = function()
			prdb.achievementsTracker.lockTracker = not prdb.achievementsTracker.lockTracker
			_G["tomQuest2AchievementsTracker"]:SetMovable(prdb.achievementsTracker.lockTracker)
		end,
		nothing = function(value)
			return
		end,
	}

	local function questsTooltipDataObjOnEnter(frame)
		setQuestsTooltipLayout()
		local questsTooltip = displayFrames.questsTooltip
		questsTooltip:SetPoint(getTipAnchor(frame))
		questsTooltip:SetFrameStrata("DIALOG")
		updateScrolling(questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
		questsTooltip:Show()
	end

	local function dailyQuestsTooltipDataObjOnEnter(frame)
		if not prdb.showCOTD then return end
		GameTooltip:SetOwner(frame, "ANCHOR_NONE")
		GameTooltip:ClearLines()
		GameTooltip:ClearAllPoints()
		GameTooltip:AddLine(LC["Daily quests completed today"])
		GameTooltip:AddLine(" ")
		for player, playerData in pairs(gldb.dailyList) do
			if next(playerData.dailies) then
				GameTooltip:AddLine(format("|cff%s%s|r", classColors[playerData.class], player))
				for index, questData in ipairs(playerData.dailies) do
					local dateJ, titreJ = match(questData, dailyPattern)
					GameTooltip:AddDoubleLine(format("%d. %s", index, titreJ), date("%x %H:%M", tonumber(dateJ)))
				end
				GameTooltip:AddLine(" ")
			end
		end
		GameTooltip:SetPoint(getTipAnchor(frame))
		GameTooltip:Show()
	end

	local function questsTooltipDataObjOnLeave(frame)
		if displayFrames.questsTooltip:IsMouseOver() then
			displayFrames.questsTooltip:SetScript("OnUpdate", hideTooltip)
		else
			displayFrames.questsTooltip:Hide()
		end
	end

	local function dataObjOnClick(frame, button)
		if button == "RightButton" then
			if IsShiftKeyDown() then
				ldbOnClick[prdb.dataObjMouseRightShift]()
			elseif IsControlKeyDown() then
				ldbOnClick[prdb.dataObjMouseRightControl]()
			elseif IsAltKeyDown() then
				ldbOnClick[prdb.dataObjMouseRightAlt]()
			else
				ldbOnClick[prdb.dataObjMouseRight]()
			end
		elseif button == "LeftButton" then
			if IsShiftKeyDown() then
				ldbOnClick[prdb.dataObjMouseLeftShift]()
			elseif IsControlKeyDown() then
				ldbOnClick[prdb.dataObjMouseLeftControl]()
			elseif IsAltKeyDown() then
				ldbOnClick[prdb.dataObjMouseLeftAlt]()
			else
				ldbOnClick[prdb.dataObjMouseLeft]()
			end
		elseif button == "MiddleButton" then
			if IsShiftKeyDown() then
				ldbOnClick[prdb.dataObjMouseMiddleShift]()
			elseif IsControlKeyDown() then
				ldbOnClick[prdb.dataObjMouseMiddleControl]()
			elseif IsAltKeyDown() then
				ldbOnClick[prdb.dataObjMouseMiddleAlt]()
			else
				ldbOnClick[prdb.dataObjMouseMiddle]()
			end
		end
	end

	function createQuestsTooltipDataObj()
		if questsTooltipDataObj then return end
		questsTooltipDataObj = LDB:NewDataObject("tomQuest2_QuestsTooltip", {type = "data source", icon = "Interface\\AddOns\\tomQuest2\\media\\icon", text = ""})
		questsTooltipDataObj.OnEnter = questsTooltipDataObjOnEnter
		questsTooltipDataObj.OnLeave = questsTooltipDataObjOnLeave
		questsTooltipDataObj.OnClick = dataObjOnClick
	end

	function createDailyQuestsTooltipDataObj()
		if dailyQuestsTooltipDataObj then return end
		dailyQuestsTooltipDataObj = LDB:NewDataObject("tomQuest2_DailyTooltip", {type = "data source", icon = "Interface\\AddOns\\tomQuest2\\media\\icon", text = ""})
		dailyQuestsTooltipDataObj.OnEnter = dailyQuestsTooltipDataObjOnEnter
		dailyQuestsTooltipDataObj.OnLeave = onLeave
		dailyQuestsTooltipDataObj.OnClick = dataObjOnClick
	end

	function updateDQToText()
		if not tomQuest2.moduleState["dailyTooltip"] then return end
		local rt = GetQuestResetTime()
		if prdb.showNumCompletedDailyQuests then
			if prdb.showMaxDailyQuest then
				if prdb.showRemainingTime and rt >= 0 and rt <= 86400 then
					dailyQuestsTooltipDataObj.text = format("|cff%s%d/%d|r |cff%s%d:%02d|r", prdb.colorizeDailyQuestsCounter and getColorFromCompletionHEX(numCompletedDailyQuests/MAX_DAILY) or "ffffff", numCompletedDailyQuests, MAX_DAILY, prdb.colorizeDailyQuestsTime and getColorFromCompletionHEX(rt*fd) or "ffffff", rt*fh, mod(rt*fm, 60))
				else
					dailyQuestsTooltipDataObj.text = format("|cff%s%d/%d|r", prdb.colorizeDailyQuestsCounter and getColorFromCompletionHEX(numCompletedDailyQuests/MAX_DAILY) or "ffffff", numCompletedDailyQuests, MAX_DAILY)
				end
			elseif prdb.showRemainingTime and rt >= 0 and rt <= 86400 then
				dailyQuestsTooltipDataObj.text = format("|cff%s%d|r |cff%s%d:%02d|r", prdb.colorizeDailyQuestsCounter and getColorFromCompletionHEX(numCompletedDailyQuests/MAX_DAILY) or "ffffff", numCompletedDailyQuests, prdb.colorizeDailyQuestsTime and getColorFromCompletionHEX(rt*fd) or "ffffff", rt*fh, mod(rt*fm, 60))
			else
				dailyQuestsTooltipDataObj.text = format("|cff%s%d|r", prdb.colorizeDailyQuestsCounter and getColorFromCompletionHEX(numCompletedDailyQuests/MAX_DAILY) or "ffffff", numCompletedDailyQuests)
			end
		elseif prdb.showMaxDailyQuest then
			if prdb.showRemainingTime and rt >= 0 and rt <= 86400 then
				dailyQuestsTooltipDataObj.text = format("%d |cff%s%d:%02d|r", MAX_DAILY, prdb.colorizeDailyQuestsTime and getColorFromCompletionHEX(rt*fd) or "ffffff", rt*fh, mod(rt*fm, 60))
			else
				dailyQuestsTooltipDataObj.text = MAX_DAILY
			end
		elseif prdb.showRemainingTime and rt >= 0 and rt <= 86400 then
			dailyQuestsTooltipDataObj.text = format("|cff%s%d:%02d|r", prdb.colorizeDailyQuestsTime and getColorFromCompletionHEX(rt*fd) or "ffffff", rt*fh, mod(rt*fm, 60))
		else
			dailyQuestsTooltipDataObj.text = ""
		end
	end

	function CHAT_MSG_SYSTEM(event, message)
		if message == NO_DAILY_QUESTS_REMAINING then
			numCompletedDailyQuests = MAX_DAILY
			updateDQToText()
		else
			local remaining = tonumber(message:match(dailyCounterPattern))
			if remaining then
				numCompletedDailyQuests = MAX_DAILY - remaining
				updateDQToText()
				if remaining == 25 then
					wipe(gldb.dailyList[playerName].dailies)
				end
			end
		end
	end

	function updateQuestCounter()
		if not tomQuest2.moduleState["questsTooltip"] then return end
		if prdb.showNumCompletedQuests then
			if prdb.showNumQuests then
				if prdb.showMaxQuest then
					questsTooltipDataObj.text = format("|cff%s%d/%d/%d|r", numQuests > 0 and getColorFromCompletionHEX(numCompletedQuests/numQuests) or "ffffff", numCompletedQuests, numQuests, MAX_QUESTS)
				else
					questsTooltipDataObj.text = format("|cff%s%d/%d|r", numQuests > 0 and getColorFromCompletionHEX(numCompletedQuests/numQuests) or "ffffff", numCompletedQuests, numQuests)
				end
			elseif prdb.showMaxQuest then
				questsTooltipDataObj.text = format("|cff%s%d/%d|r", getColorFromCompletionHEX(numCompletedQuests/MAX_QUESTS), numCompletedQuests, MAX_QUESTS)
			else
				questsTooltipDataObj.text = format("|cff%s%d|r", numQuests > 0 and getColorFromCompletionHEX(numCompletedQuests/numQuests) or "ffffff", numCompletedQuests)
			end
		elseif prdb.showNumQuests then
			if prdb.showMaxQuest then
				questsTooltipDataObj.text = format("|cff%s%d/%d|r", getColorFromCompletionHEX(numQuests/MAX_QUESTS), numQuests, MAX_QUESTS)
			else
				questsTooltipDataObj.text = format("|cff%s%d|r", getColorFromCompletionHEX(numQuests/MAX_QUESTS), numQuests)
			end
		elseif prdb.showMaxQuest then
			questsTooltipDataObj.text = format("|cffffffff%d|r", MAX_QUESTS)
		else
			questsTooltipDataObj.text = ""
		end
	end

	function resetDailyQuestsDB()
		numCompletedDailyQuests = GetDailyQuestsCompleted() or 0
		local previousResetTime = time() - 86400 + GetQuestResetTime()
		for player, playerData in pairs(gldb.dailyList) do
			if next(playerData.dailies) then
				local dateJ, _ = match(playerData.dailies[#playerData.dailies], dailyPattern)
				if tonumber(dateJ) < previousResetTime then
					wipe(gldb.dailyList[player].dailies)
				end
			end
		end
	end
end
tomQuest2.updateDQToText, tomQuest2.updateQuestCounter = updateDQToText, updateQuestCounter
---------------------
--- Quests Givers ---
---------------------
local setQuestsGivers, unSetQuestsGivers
do
	local buttonIndex = 0
	local isDailyQuest
	local trivialText = "|cff%02x%02x%02x[%s%s]|r "..gsub(TRIVIAL_QUEST_DISPLAY, "cff000000", "cff%%s")
	local normalText = "|cff%02x%02x%02x[%s%s]|r "..gsub(NORMAL_QUEST_DISPLAY, "cff000000", "cff%%s")
	local forbiddenQuests = {}

	local function clickQuest(button)
		if button:IsVisible() then
			local title, isDaily = button.title, button.isDaily
			if button.type == "Available" and (prdb.automaticAccept == 1 or (prdb.automaticAccept == 2 and isDaily) or (prdb.automaticAccept == 3 and not isDaily)) then
				isDailyQuest = isDaily
				button:Click()
			elseif button.type == "Active" and prdb.automaticTurnIn and button.isComplete then
				button:Click()
			end
		end
	end

	local function loopAvailableQuests(...)
		local numQuests = select('#', ...)
		if numQuests == 0 then return end
		for i = 1, numQuests, 5 do
			local title, level, isTrivial, isDaily, isRepeatable = select(i, ...)
			local titleButton = _G["GossipTitleButton"..buttonIndex]
			titleButton.title, titleButton.isDaily, titleButton.isComplete = title, isDaily, nil
			if prdb.addQuestLevel then
				local color = getDifficultyColor(level - playerLevel)
				titleButton:SetFormattedText(isTrivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, isDaily and prdb.daily or "", prdb.questTitleColor, title)
				titleButton:SetHeight(titleButton:GetTextHeight() + 2)
			end
			buttonIndex = buttonIndex + 1
		end
		if buttonIndex > 1 then
			local titleButton = _G["GossipTitleButton"..buttonIndex]
			titleButton.title, titleButton.isDaily, titleButton.isComplete = nil, nil, nil
			buttonIndex = buttonIndex + 1
		end
	end

	local function loopActiveQuests(...)
		local numQuests = select("#", ...)
		if numQuests == 0 then return end
		for i = 1, numQuests, 4 do
			local title, level, isTrivial, isComplete = select(i, ...)
			local isDaily = quests[questsTitleToqid[title]] and (quests[questsTitleToqid[title]].daily == 1 and true or nil) or nil
			local titleButton = _G["GossipTitleButton"..buttonIndex]
			titleButton.title, titleButton.isDaily, titleButton.isComplete = title, isDaily, isComplete
			if prdb.addQuestLevel then
				local color = getDifficultyColor(level - playerLevel)
				titleButton:SetFormattedText(isTrivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, isDaily and prdb.daily or "", prdb.questTitleColor, title)
				titleButton:SetHeight(titleButton:GetTextHeight() + 2)
			end
			buttonIndex = buttonIndex + 1
		end
		buttonIndex = buttonIndex + 1
	end

	local function GOSSIP_SHOW()
		buttonIndex = 1
		loopAvailableQuests(GetGossipAvailableQuests())
		loopActiveQuests(GetGossipActiveQuests())
		if IsShiftKeyDown() then return end
		for i = 1, buttonIndex do
			clickQuest(_G["GossipTitleButton" .. i])
		end
	end

	local function QUEST_GREETING()
		local numActive, numAvailable = GetNumActiveQuests() or 0, GetNumAvailableQuests() or 0
		buttonIndex = 0
		for i = 1, numActive do
			buttonIndex = buttonIndex + 1
			local title, isComplete = GetActiveTitle(i)
			local isDaily = quests[questsTitleToqid[title]].daily == 1 and true or nil
			local titleButton = _G["QuestTitleButton"..buttonIndex]
			titleButton.title, titleButton.isDaily, titleButton.isComplete = title, isDaily, isComplete
			if prdb.addQuestLevel then
				local level = GetActiveLevel(i)
				local color = getDifficultyColor(level - playerLevel)
				local isTrivial = IsActiveQuestTrivial(i)
				titleButton:SetFormattedText(isTrivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, isDaily and prdb.daily or "", prdb.questTitleColor, title)
				titleButton:SetHeight(titleButton:GetTextHeight() + 2)
			end
		end
		for i = 1, numAvailable do
			buttonIndex = buttonIndex + 1
			local title = GetAvailableTitle(i)
			local isTrivial, isDaily, isRepeatable = GetAvailableQuestInfo(i)
			local titleButton = _G["QuestTitleButton"..buttonIndex]
			titleButton.title, titleButton.isDaily, titleButton.isComplete = title, isDaily, nil
			if prdb.addQuestLevel then
				local level = GetAvailableLevel(i)
				local color = getDifficultyColor(level - playerLevel)
				titleButton:SetFormattedText(isTrivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, isDaily and prdb.daily or "", prdb.questTitleColor, title)
				titleButton:SetHeight(titleButton:GetTextHeight() + 2)
			end
		end
		if IsShiftKeyDown() then return end
		for i = 1, buttonIndex do
			clickQuest(_G["QuestTitleButton" .. i])
		end
	end

	local function QUEST_DETAIL()
		local title = GetTitleText()
		if not IsShiftKeyDown() and (prdb.automaticAccept == 1 or (prdb.automaticAccept == 2 and isDailyQuest) or (prdb.automaticAccept == 3 and not isDailyQuest)) and not forbiddenQuests[title] then
			isDailyQuest = nil
			AcceptQuest()
		end
	end

	local function QUEST_COMPLETE()
		if not IsShiftKeyDown() and prdb.automaticTurnIn and GetNumQuestChoices() <= 1 then
			GetQuestReward(QuestFrameRewardPanel.itemChoice)
		end
	end

	local function QUEST_PROGRESS()
		if not IsShiftKeyDown() and prdb.automaticTurnIn and IsQuestCompletable() then
			CompleteQuest()
		end
	end

	local function QUEST_ACCEPT_CONFIRM()
		if not IsShiftKeyDown() and prdb.automaticAcceptEscort then
			ConfirmAcceptQuest()
		end
	end

	function setQuestsGivers()
		local LFQ = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-ForbidenQuests")
		for _, v in pairs(LFQ) do
			forbiddenQuests[v] = true
		end
		LFQ = nil
		tomQuest2:RegisterEvent("GOSSIP_SHOW", GOSSIP_SHOW)
		tomQuest2:RegisterEvent("QUEST_GREETING", QUEST_GREETING)
		tomQuest2:RegisterEvent("QUEST_COMPLETE", QUEST_COMPLETE)
		tomQuest2:RegisterEvent("QUEST_DETAIL", QUEST_DETAIL)
		tomQuest2:RegisterEvent("QUEST_PROGRESS", QUEST_PROGRESS)
		tomQuest2:RegisterEvent("QUEST_ACCEPT_CONFIRM", QUEST_ACCEPT_CONFIRM)
	end

	function unSetQuestsGivers()
		for k in pairs(forbiddenQuests) do
			forbiddenQuests[k] = nil
		end
		tomQuest2:UnregisterEvent("GOSSIP_SHOW")
		tomQuest2:UnregisterEvent("QUEST_GREETING")
		tomQuest2:UnregisterEvent("QUEST_COMPLETE")
		tomQuest2:UnregisterEvent("QUEST_DETAIL")
		tomQuest2:UnregisterEvent("QUEST_PROGRESS")
		tomQuest2:UnregisterEvent("QUEST_ACCEPT_CONFIRM")
	end
end

--------------------------------------------
--- Achievements Trade Skills & Tooltips ---
--------------------------------------------
local setAchievementsTradeSkills, unSetAchievementsTradeSkills, setMobTooltip, setItemTooltip
do --Achievements Trade Skills & Tooltips
	local achievementsPattern = "^(%d-)~(%d-)$"
	local cooking = GetCategoryInfo(170)
	local achievementsTradeSkills, achievementsItems, achievementsMobs, achievementName, achievementIcon = {}, {}, {}, {}, {}
	local achTrade, achMobs, achItems, substitute = {1779, 1800}, {1206, 2557, 2556, 1312, 2257, 5548}, {1244, 1956, 1225, 1517}, {["Écureuil"] = "Ecureuil", ["Écureuil des Grisonnes"] = "Ecureuil des Grisonnes"}

	local function addCriteriaToTooltip(tooltip, aid, cid)
		local _, _, _, completed = GetAchievementCriteriaInfo(aid, cid)
		if completed == 1 then
			tooltip:AddLine(achievementName[aid], 0, 1, 0)
		else
			tooltip:AddLine(achievementName[aid], 1, 0, 0)
		end
		tooltip:AddTexture(achievementIcon[aid])
	end

	local function onTooltipSetUnit(tooltip)
		local name, unit = tooltip:GetUnit()
		if not unit then return end
		if achievementsMobs[name] then
			for _, critData in ipairs(achievementsMobs[name]) do
				local aid, cid = critData:match(achievementsPattern)
				addCriteriaToTooltip(tooltip, tonumber(aid), tonumber(cid))
			end
			tooltip:Show()
		end
		if party[name] and party[name].currXP and UnitLevel(unit) ~= MAX_PLAYER_LEVEL then
			tooltip:AddDoubleLine(EXPERIENCE_COLON, party[name].fmtXP)
			tooltip:Show()
		end
	end

	local function onTooltipSetItem(tooltip)
		local name = tooltip:GetItem()
		if not name or not achievementsItems[name] then return end
		for _, critData in ipairs(achievementsItems[name]) do
			local aid, cid = critData:match(achievementsPattern)
			addCriteriaToTooltip(tooltip, tonumber(aid), tonumber(cid))
		end
		tooltip:Show()
	end

	local function onShow(tooltip)
		if tooltip:NumLines() == 1 then
			local name = _G["GameTooltipTextLeft1"]:GetText()
			if not name or not achievementsItems[name] then return end
			for _, critData in ipairs(achievementsItems[name]) do
				local aid, cid = critData:match(achievementsPattern)
				addCriteriaToTooltip(tooltip, tonumber(aid), tonumber(cid))
			end
			tooltip:Show()
		end
	end

	local function tradeSkillOnEnter(self)
		local aid = self.aid
		if aid then
			if achievementIcon[aid] and achievementName[aid] then
				GameTooltip:SetOwner(self, "ANCHOR_NONE")
				GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
				GameTooltip:AddLine(format("|T%s:0|t %s", achievementIcon[aid], achievementName[aid]), 1, 0, 0)
				GameTooltip:Show()
			end
		end
	end

	local function mrtButtonOnEnter(self)
		local aid = self.aid
		if aid then
			if achievementIcon[aid] and achievementName[aid] then
				GameTooltip:AddLine(format("|T%s:0|t %s", achievementIcon[aid], achievementName[aid]), 1, 0, 0)
				GameTooltip:Show()
			end
		end
	end

	local function skilletButtonOnEnter(self)
		local aid = self.aid
		if aid then
			if achievementIcon[aid] and achievementName[aid] then
				SkilletTradeskillTooltip:AddLine(format("|T%s:0|t %s", achievementIcon[aid], achievementName[aid]), 1, 0, 0)
				SkilletTradeskillTooltip:Show()
			end
		end
	end

	local function atswButtonOnEnter(self)
		local aid = self.aid
		if aid then
			if achievementIcon[aid] and achievementName[aid] then
				ATSWTradeskillTooltip:AddLine(format("|T%s:0|t %s", achievementIcon[aid], achievementName[aid]), 1, 0, 0)
				ATSWTradeskillTooltip:Show()
			end
		end
	end

	local function cleanTradeSkillButton(button, highlightButton)
		button.aid = nil
		button:SetNormalTexture("")
		if highlightButton then
			highlightButton:SetTexture("")
		end
	end

	local function updateTradeSkillButton(skillName, button, highlightButton, hook, onEnter)
		local aidcid = achievementsTradeSkills[skillName]
		if aidcid then
			local ach_id, crit_id = aidcid:match(achievementsPattern)
			ach_id, crit_id = tonumber(ach_id), tonumber(crit_id)
			if ach_id then
				local _, _, _, completed = GetAchievementCriteriaInfo(ach_id, crit_id)
				if not completed or completed == 0 then
					button.aid = ach_id
					button:SetNormalTexture(achievementIcon[ach_id])
					if highlightButton then
						highlightButton:SetTexture(achievementIcon[ach_id])
					end
					if hook then
						if not button.hooked then
							button:HookScript("OnEnter", onEnter)
							button.hooked = true
						end
					else
						button:SetScript("OnEnter", onEnter)
						button:SetScript("OnLeave", onLeave)
					end
				else
					cleanTradeSkillButton(button, highlightButton)
				end
			else
				cleanTradeSkillButton(button, highlightButton)
			end
		else
			cleanTradeSkillButton(button, highlightButton)
		end
	end

	local function clearTradeSkillButton(skillName, button, highlightButton, hook, onEnter)
		local aidcid = achievementsTradeSkills[skillName]
		if aidcid then
			local aid, cid = aidcid:match(achievementsPattern)
			aid, cid = tonumber(aid), tonumber(cid)
			button.aid = aid
			if aid then
				local _, _, _, completed = GetAchievementCriteriaInfo(aid, cid)
				if not completed or completed == 0 then
					button:SetNormalTexture(achievementIcon[aid])
					highlightButton:SetTexture(achievementIcon[aid])
					if hook then
						if not button.hooked then
							button:HookScript("OnEnter", onEnter)
							button.hooked = true
						end
					else
						button:SetScript("OnEnter", onEnter)
						button:SetScript("OnLeave", onLeave)
					end
				else
					
				end
			else
				button:SetNormalTexture("")
				highlightButton:SetTexture("")
			end
		end
	end

	local function TradeSkillFrame_Update()
		local offset = FauxScrollFrame_GetOffset(TradeSkillListScrollFrame)
		local tradeSkillName = GetTradeSkillLine()
		if tradeSkillName == cooking then
			for i = 1, TRADE_SKILLS_DISPLAYED do
				local skillName, skillType = GetTradeSkillInfo(i + offset)
				if skillType ~= "header" then
					updateTradeSkillButton(skillName, _G["TradeSkillSkill"..i], _G["TradeSkillSkill"..i.."Highlight"], false, tradeSkillOnEnter)
				end
			end
		else
			for i = 1, TRADE_SKILLS_DISPLAYED do
				cleanTradeSkillButton(_G["TradeSkillSkill"..i], _G["TradeSkillSkill"..i.."Highlight"])
			end
		end
	end

	local function DrawSkillList()
		local offset = FauxScrollFrame_GetOffset(MRTSkillListScrollFrame)
		local tradeSkillName = GetTradeSkillLine()
		if tradeSkillName == cooking then
			for i = 1, 10 do
				local skillName, skillType = GetTradeSkillInfo(i + offset)
				if skillType ~= "header" then
					updateTradeSkillButton(skillName, _G["MRTSkillButton"..i], nil, true, mrtButtonOnEnter)
				end
			end
		else
			for i = 1, 10 do
				cleanTradeSkillButton(_G["MRTSkillButton"..i], nil)
			end
		end
	end

	local function internal_UpdateTradeSkillWindow()
		local offset = FauxScrollFrame_GetOffset(SkilletSkillList)
		local tradeSkillName = GetTradeSkillLine()
		if tradeSkillName == cooking then
			for i = 1, floor(SkilletSkillList:GetHeight() / SKILLET_TRADE_SKILL_HEIGHT) do
				local skillName, skillType = GetTradeSkillInfo(i + offset)
				if skillType ~= "header" then
					updateTradeSkillButton(skillName, _G["SkilletScrollButton"..i], _G["SkilletScrollButton"..i.."Highlight"], true, skilletButtonOnEnter)
					_G["SkilletScrollButton"..i.."Level"]:SetWidth(20)
				end
			end
		else
			for i = 1, floor(SkilletSkillList:GetHeight() / SKILLET_TRADE_SKILL_HEIGHT) do
				cleanTradeSkillButton(_G["SkilletScrollButton"..i], _G["SkilletScrollButton"..i.."Highlight"])
			end
		end
	end

	local function ATSWFrame_Update()
		if not ATSWFrame:IsVisible() then return end
		local offset = FauxScrollFrame_GetOffset(ATSWListScrollFrame)
		local tradeSkillName = GetTradeSkillLine()
		if tradeSkillName == cooking then
			for i = 1, ATSW_TRADE_SKILLS_DISPLAYED do
				local skillName, skillType = GetTradeSkillInfo(i + offset)
				if skillType ~= "header" then
					updateTradeSkillButton(skillName, _G["ATSWSkill"..i], _G["ATSWSkill"..i.."Highlight"], true, atswButtonOnEnter)
				end
			end
		else
			for i = 1, ATSW_TRADE_SKILLS_DISPLAYED do
				cleanTradeSkillButton(_G["ATSWSkill"..i], _G["ATSWSkill"..i.."Highlight"])
			end
		end
	end

	local function ADDON_LOADED(event, addon)
		if addon == "Blizzard_TradeSkillUI" then
			tomQuest2:SecureHook("TradeSkillFrame_Update", TradeSkillFrame_Update)
		elseif addon == "MrTrader_SkillWindow" then
			tomQuest2:SecureHook(MRTSkillWindow, "DrawSkillList", DrawSkillList)
		elseif addon == "Skillet" then
			tomQuest2:SecureHook(Skillet, "internal_UpdateTradeSkillWindow", internal_UpdateTradeSkillWindow)
		elseif addon == "AdvancedTradeSkillWindow" then
			tomQuest2:SecureHook("ATSWFrame_Update", ATSWFrame_Update)
		else
			return
		end
		tomQuest2:UnregisterEvent("ADDON_LOADED")
	end

	function setAchievementsTradeSkills()
		for _, aid in pairs(achTrade) do
			local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
			if not completed then
				achievementName[aid] = name
				achievementIcon[aid] = icon
				local numCriteria = GetAchievementNumCriteria(aid)
				for cid = 1, numCriteria do
					local cString, _, completed = GetAchievementCriteriaInfo(aid, cid)
					if not completed then
						achievementsTradeSkills[cString] = aid.."~"..cid
					end
				end
			end
		end
		if next(achievementsTradeSkills) then
			if IsAddOnLoaded("Blizzard_TradeSkillUI") then
				tomQuest2:SecureHook("TradeSkillFrame_Update", TradeSkillFrame_Update)
			elseif IsAddOnLoaded("MrTrader_SkillWindow") then
				tomQuest2:SecureHook(MRTSkillWindow, "DrawSkillList", DrawSkillList)
			elseif IsAddOnLoaded("Skillet") then
				tomQuest2:SecureHook(Skillet, "internal_UpdateTradeSkillWindow", internal_UpdateTradeSkillWindow)
			elseif IsAddOnLoaded("AdvancedTradeSkillWindow") then
				tomQuest2:SecureHook("ATSWFrame_Update", ATSWFrame_Update)
			else
				tomQuest2:RegisterEvent("ADDON_LOADED", ADDON_LOADED)
			end
		else
			achievementsTradeSkills = nil
		end
	end

	function unSetAchievementsTradeSkills()
		tomQuest2:UnregisterEvent("ADDON_LOADED")
		if achievementsTradeSkills then
			if IsAddOnLoaded("Blizzard_TradeSkillUI") then
				tomQuest2:Unhook("TradeSkillFrame_Update")
			elseif IsAddOnLoaded("MrTrader_SkillWindow") then
				tomQuest2:Unhook(MRTSkillWindow, "DrawSkillList")
			elseif IsAddOnLoaded("Skillet") then
				tomQuest2:Unhook(Skillet, "internal_UpdateTradeSkillWindow")
			elseif IsAddOnLoaded("AdvancedTradeSkillWindow") then
				tomQuest2:Unhook("ATSWFrame_Update")
			else
				tomQuest2:UnregisterEvent("ADDON_LOADED")
			end
		end
	end

	function setMobTooltip()
		if tomQuest2.moduleState["tooltips"] and prdb.mobTooltip then
			for _, aid in pairs(achMobs) do
				local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
				if not completed then
					achievementName[aid], achievementIcon[aid] = name, icon
					local numCriteria = GetAchievementNumCriteria(aid)
					for cid = 1, numCriteria do
						local cString = GetAchievementCriteriaInfo(aid, cid)
						cString = substitute[cString] or cString
						achievementsMobs[cString] = achievementsMobs[cString] or {}
						achievementsMobs[cString][#achievementsMobs[cString]+1] = aid.."~"..cid
					end
				end
			end
			GameTooltip:HookScript("OnTooltipSetUnit", onTooltipSetUnit)
		else
			for _, aid in pairs(achMobs) do
				achievementName[aid], achievementIcon[aid] = nil
			end
			for k in pairs(achievementsMobs) do
				achievementsMobs[k] = nil
			end
			tomQuest2:Unhook(GameTooltip, "OnTooltipSetUnit")
		end
	end

	function setItemTooltip()
		if tomQuest2.moduleState["tooltips"] and prdb.itemTooltip then
			for _, aid in pairs(achItems) do
				local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
				if not completed then
					achievementName[aid], achievementIcon[aid] = name, icon
					local numCriteria = GetAchievementNumCriteria(aid)
					for cid = 1, numCriteria do
						local cString = GetAchievementCriteriaInfo(aid, cid)
						achievementsItems[cString] = achievementsItems[cString] or {}
						achievementsItems[cString][#achievementsItems[cString]+1] = aid.."~"..cid
					end
				end
			end
			GameTooltip:HookScript("OnShow", onShow)
			GameTooltip:HookScript("OnTooltipSetItem", onTooltipSetItem)
		else
			for _, aid in pairs(achItems) do
				achievementName[aid], achievementIcon[aid] = nil, nil
			end
			for k in pairs(achievementsItems) do
				achievementsItems[k] = nil
			end
			tomQuest2:Unhook(GameTooltip, "OnShow")
			tomQuest2:Unhook(GameTooltip, "OnTooltipSetItem")
		end
	end
end
tomQuest2.setMobTooltip, tomQuest2.setItemTooltip = setMobTooltip, setItemTooltip

-------------------
--- tagQuestLog ---
-------------------
local blizzQuestLogUpdate
do
	local repl = {["<"] = "[", [">"] = "]"}
	local COMPLETE, FAILED = COMPLETE, FAILED
	function blizzQuestLogUpdate()
		if not QuestLogFrame:IsShown() then return end
		local buttons = QuestLogScrollFrame.buttons
		local numEntries, numQuests = GetNumQuestLogEntries()
		for i = 1, #buttons do
			local questLogTitle = buttons[i]
			local index = questLogTitle:GetID()
			if index > numEntries then break end
			local _, _, _, _, _, _, _, _, qid = GetQuestLogTitle(index)
			if qid and quests[qid] then
				if quests[qid].playerStatus == 1 then
					questLogTitle:SetFormattedText("  %s%s (%s)", quests[qid].tag, quests[qid].title, COMPLETE)
				elseif quests[qid].playerStatus == -1 then
					questLogTitle:SetFormattedText("  %s%s (%s)", quests[qid].tag, quests[qid].title, FAILED)
				else
					questLogTitle:SetFormattedText("  %s%s", quests[qid].tag, quests[qid].title)
				end
				questLogTitle.tag:Hide()
				questLogTitle.groupMates:SetText(gsub((questLogTitle.groupMates:GetText() or ""), "[<>]", repl))
				QuestLogTitleButton_Resize(questLogTitle)
			end
		end
	end
end

------------
--- Core ---
------------
function tomQuest2:WatchFrame_Update()
	WatchFrame:Hide()
end

function tomQuest2:hideShowDefaultBlizTracker()
	if quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		self:SecureHook("WatchFrame_Update")
	else
		WatchFrame:Show()
		self:Unhook("WatchFrame_Update")
	end
end

function tomQuest2:zoneChanged()
	if UnitIsDead("player") then return end
	subZone = GetSubZoneText() or ""
	currentZone = GetZoneText() or ""
	if prdb.questsTracker.autoCollapseCategory then
		for category, cData in pairs(questsCategories) do
			if currentZone == category or subZone == category then
				chdb.categoryDisplay.questsTracker[category] = 1
				questsCategories[category].questsTrackerCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-MinusButton-Up")
			elseif cData.zone then
				chdb.categoryDisplay.questsTracker[category] = 0
				questsCategories[category].questsTrackerCollapse.iconTexture:SetTexture("Interface\\Buttons\\UI-PlusButton-Up")
			end
		end
	end
	if prdb.onZone and currentZone ~= oldZone then
		for qid in pairs(chdb.questsZoneAutoTracked) do
			RemoveQuestWatch(quests[qid] and quests[qid].id, qid, true)
		end
		for qid, qData in pairs(quests) do
			if not chdb.questsTracked[qid] and qData.category == currentZone then
				chdb.questsZoneAutoTracked[qid] = true
				AddQuestWatch(quests[qid].id, nil, qid, true)
			end
		end
	end
	if prdb.onSubZone and subZone ~= "" then
		for qid in pairs(chdb.questsSubZoneAutoTracked) do
			RemoveQuestWatch(quests[qid] and quests[qid].id, qid, true)
		end
		for qid, qData in pairs(quests) do
			if not chdb.questsTracked[qid] and (qData.category == subZone or (qData.objective and qData.objective:find(subZone, 1, true)) or (qData.description and qData.description:find(subZone, 1, true))) then
				chdb.questsSubZoneAutoTracked[qid] = true
				AddQuestWatch(quests[qid].id, nil, qid, true)
			end
		end
	end
	setQuestsTrackerLayout()
	oldZone = currentZone
end

function tomQuest2:AbandonQuest()
	abandoning = true
end

function tomQuest2:addQuestCategory(category)
	local minLevel, maxLevel = LibTourist:GetLevel(category)
	if maxLevel == 0 then
		local zoneColor = category == localClass and playerColor or "ffffff"
		questsCategories[category] = {sLevel = prdb.categoryWithoutLvlPos, level = "", color = zoneColor}
	else
		local r, g, b = LibTourist:GetLevelColor(category)
		questsCategories[category] = {sLevel = (minLevel + maxLevel)/2, level = format("(%d-%d)", minLevel, maxLevel), color = format("%02x%02x%02x", r*255, g*255, b*255), zone = true}
	end
	questsByCategory[category] = {}
	sortedQuestsByCategory[category] = {}
	createQuestCategoryCell(category, QUESTS_TOOLTIP, cQToFontTQ2)
	createQuestCategoryCell(category, QUESTS_TRACKER, cQTrFontTQ2)
	sortedCategories[#sortedCategories+1] = category
	sort(sortedCategories, cSort[prdb.categorySorting])
end

local parseObjective = {
	item = function(description, done)
		local desc, got, need = description:match(objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	object = function(description, done)
		local desc, got, need = description:match(objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	spell = function(description, done)
		local desc, got, need = description:match(objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	monster = function(description, done)
		local desc, got, need = description:match(monstersPattern)
		if desc == nil or got == nil or need == nil then
			desc, got, need = description:match(objectsPattern)
		end
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	reputation = function(description, done)
		local desc, got, need = description:match(factionPattern)
		return desc, got, need, reactions[got], reactions[need]
	end,
	log = function(description, done)
		if done then
			return description, 1, 1, 1, 1
		else
			return description, 0, 1, 0, 1
		end
	end,
	event = function(description, done)
		if done then
			return description, 1, 1, 1, 1
		else
			return description, 0, 1, 0, 1
		end
	end,
	player = function(description, done)
		local got, need = description:match(playersPattern)
		if UnitFactionGroup("player") == "Alliance" then
			return LC["Horde player killed"], got, need, tonumber(got), tonumber(need)
		else
			return LC["Alliance player killed"], got, need, tonumber(got), tonumber(need)
		end
	end,
}

function tomQuest2:QUEST_LOG_UPDATE()
	local refresh
	if self.questLogUpdating and not self.questLogUpdateHandle then 
		self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
		return
	end
	if self.questLogUpdateHandle then
		self:CancelTimer(self.questLogUpdateHandle, true)
	end
	self.questLogUpdating = true
	local selectionId = GetQuestLogSelection()
	local timeStamp = GetTime()
	local newNumCompletedQuests, numEntries, newNumQuests = 0, GetNumQuestLogEntries()
	local category
	for id = 1, numEntries do
		local title, level, tag, group, header, collapsed, completed, daily, qid = GetQuestLogTitle(id)
		if header then
			category = title or _G.UNKNOWN
			if collapsed then
				collapsedHeader[category] = true
			elseif collapsedHeader[category] then
				collapsedHeader[category] = nil
			end
			if not questsCategories[category] then
				self:addQuestCategory(category)
			end
		else
			level, tag, group, daily, completed = level or 0, tag or "", group or 0, daily or 0, completed or 0
			if completed == 1 then newNumCompletedQuests = newNumCompletedQuests + 1 end
			if not quests[qid] then
				if tags[tag] then
					tag = tags[tag]
				elseif tag == RAID then
					tag = "raid"
					group = LibTourist:GetInstanceGroupSize(category) or group
				elseif tag:find(RAID) then
					tag = "raid"
					group = tonumber(tag:match("%d+")) or group
				else
					self:Print("tag ["..tag.."] is missing for quest ["..qid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
					tag = "notag"
				end
				local numObjectives = GetNumQuestLeaderBoards(id) or 0
				addQuest(qid, title, level, tag, group, daily, numObjectives, category)
				addPlayerToQuest(qid, completed, category)
				sortedQuestsByCategory[category][#sortedQuestsByCategory[category]+1] = qid
				sort(sortedQuestsByCategory[category], qSort[prdb.questsSorting])
				sortedQuests[#sortedQuests+1] = qid
				sort(sortedQuests, qSort[prdb.questsSorting])
				refresh = true
				if questStartedByItem[qid] then
					recycleButton(itemStartingQuest[questStartedByItem[qid]])
					items[questStartedByItem[qid]] = nil
					BAG_UPDATE()
				end
			elseif not quests[qid].playerStatus then 
				addPlayerToQuest(qid, completed, category)
				refresh = true
			else
				if completed == 0 and quests[qid].playerStatus == 1 then
					updateQuest(qid, 0, "a")
					refresh = true
				elseif completed == 1 and quests[qid].playerStatus == 0 then
					updateQuest(qid, 1, "c")
					if self.moduleState["notifications"] and prdb.notifyPlayerQuestComplete then
						self:Pour(format(LC["(%s) : finished"], title), 0, 1, 0)
					end
					if self.moduleState["soundNotifications"] then
						play(LSM:Fetch("sound", prdb.soundQuestComplete))
					end
					if self.moduleState["announce"] and prdb.announcePlayerQuestComplete and numPartyMembers > 0 then
						SendChatMessage(format(LC["(%s) : finished"], title), "PARTY")
					end
					refresh = true
				elseif completed == -1 and quests[qid].playerStatus ~= -1 then
					updateQuest(qid, -1, "f")
					if self.moduleState["announce"] and prdb.announcePlayerQuestFailed and numPartyMembers > 0 then
						SendChatMessage(format(LC["(%s) : failed"], title), "PARTY")
					end
					if self.moduleState["notifications"] and prdb.notifyPlayerQuestFailed then
						self:Pour(format(LC["(%s) : failed"], title), 1, 0, 0)
					end
					if self.moduleState["soundNotifications"] then
						play(LSM:Fetch("sound", prdb.soundQuestFailed))
					end
					refresh = true
				end
			end
			quests[qid].id, quests[qid].timeStamp = id, timeStamp
			local started = 0
			for oid = 1, quests[qid].numObjectives do
				local description, qType, done = GetQuestLogLeaderBoard(oid, id)
				if qType and description then
					if parseObjective[qType] then
						local desc, got, need, nGot, nNeed = parseObjective[qType](description, done)
						if not desc or strtrim(desc) == "" then
							if not self.questLogUpdateHandle then 
								self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
							end
							return
						elseif not questsObjectives[qid][oid] then
							addQuestObjective(qid, oid, desc, need, nNeed)
							addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot)
							refresh = true
						elseif not questsObjectives[qid][oid].nPlayerGot then
							addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot)
							refresh = true
						elseif questsObjectives[qid][oid].nPlayerGot ~= nGot then
							questsObjectives[qid][oid].playerGot, questsObjectives[qid][oid].nPlayerGot = got, nGot
							updateQuestObjectiveCells(qid, oid)
							if nGot == nNeed then
								if self.moduleState["announce"] and prdb.announcePlayerObjectiveComplete and (quests[qid].playerStatus == 0 or prdb.announceObjectiveProgressWhenQuestComplete) and numPartyMembers > 0 then
									SendChatMessage(format(LC["(%s) %s : finished"], title, desc), "PARTY")
								end
								if self.moduleState["notifications"] and prdb.notifyPlayerObjectiveComplete and (quests[qid].playerStatus == 0 or prdb.notifiyObjectiveProgressWhenQuestComplete) then
									self:Pour(format(LC["(%s) %s : finished"], title, desc), 0, 1, 0)
								end
								if self.moduleState["soundNotifications"] and quests[qid].playerStatus == 0 then
									play(LSM:Fetch("sound", prdb.soundObjectiveComplete))
								end
								refresh = true
							else
								if self.moduleState["announce"] and prdb.announcePlayerObjectiveProgress and numPartyMembers > 0 and nGot > 0 then
									SendChatMessage(format("(%s) %s : %s / %s", title, desc, got, need), "PARTY")
								end
								if self.moduleState["notifications"] and prdb.notifyPlayerObjectiveProgress and nGot > 0 then
									self:Pour(format("(%s) %s : %s / %s", title, desc, got, need), getColorFromCompletionRGB(nGot/ nNeed))
								end
							end
							self:sendMessage("p", qid, oid, got, nGot)
							questObjectiveProgress(qid, oid, got, nGot)
						end
						if nGot ~= 0 then started = 1 end
					else
						self:Print("objective type ["..qType.."] unknown for objective ["..description.."] and quest ["..qid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
					end
				else
					if not self.questLogUpdateHandle then 
						self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
					end
					return
				end
			end
			local itemLink, itemIcon, itemCharges = GetQuestLogSpecialItemInfo(id)
			if itemLink then
				local _, _, itemID = find(itemLink, "^|c%x+|Hitem:(%d+):(.+)|h%[.*%]")
				itemID = tonumber(itemID)
				quests[qid].specialItemID = itemID
				if items[itemID] and items[itemID] ~= qid then
					if items[itemID] == 0 then
						recycleButton(itemStartingQuest[itemID])
						itemStartingQuest[itemID] = nil
					elseif items[itemID] == -1 then
						recycleButton(usableQuestItems[itemID])
						usableQuestItems[itemID] = nil
					end
				end
				local itemHasRange = ItemHasRange(itemID)
				if not quests[qid].questsTooltipSpecialItem then
					if quests[qid].questsTooltipFakeItem then
						recycleButton(quests[qid].questsTooltipFakeItem)
						recycleButton(quests[qid].questsTrackerFakeItem)
						quests[qid].questsTooltipFakeItem, quests[qid].questsTrackerFakeItem = nil, nil
					end
					quests[qid].questsTooltipSpecialItem = getItemButton(quests[qid].questsTooltipText, id, itemID, itemIcon, itemHasRange, prdb.questsTooltip.questItemIconSize)
					quests[qid].questsTrackerSpecialItem = getItemButton(quests[qid].questsTrackerText, id, itemID, itemIcon, itemHasRange, prdb.questsTracker.questItemIconSize)
				else
					quests[qid].questsTooltipSpecialItem:SetID(id)
					quests[qid].questsTrackerSpecialItem:SetID(id)
				end
				if itemCharges > 1 then
					quests[qid].questsTooltipSpecialItem.count:SetText(itemCharges)
					quests[qid].questsTrackerSpecialItem.count:SetText(itemCharges)
					quests[qid].questsTooltipSpecialItem.count:Show()
					quests[qid].questsTrackerSpecialItem.count:Show()
				else
					quests[qid].questsTooltipSpecialItem.count:Hide()
					quests[qid].questsTrackerSpecialItem.count:Hide()
				end
				items[itemID] = qid
			end
			if not quests[qid].extras then
				SelectQuestLogEntry(id)
				quests[qid].description, quests[qid].objective = GetQuestLogQuestText()
				if not quests[qid].description or not quests[qid].objective then
					if not self.questLogUpdateHandle then 
						self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
					end
					return
				else
					if not questsObjectives[qid] then
						createQuestDescriptionCells(qid)
					end
					quests[qid].extras = true
				end
				if not questsObjectives[qid] then
					refresh = true
				end
				quests[qid].sharable = GetQuestLogPushable()
				quests[qid].money = GetQuestLogRewardMoney() or 0
				quests[qid].talent = GetQuestLogRewardTalents() or 0
				quests[qid].xp = GetQuestLogRewardXP() or 0
				ProcessQuestLogRewardFactions()
				quests[qid].numReputations = GetNumQuestLogRewardFactions() or 0
				if quests[qid].numReputations > 0 then
					quests[qid].reputationRewards = {}
					for i = 1, quests[qid].numReputations do
						local factionId, amount = GetQuestLogRewardFactionInfo(i)
						local factionName = GetFactionInfoByID(factionId)
						quests[qid].reputationRewards[factionName] = floor(amount / 100)
					end
				end
				quests[qid].titleReward = GetQuestLogRewardTitle() or ""
				local numRewards = GetNumQuestLogRewards() or 0
				local numChoices = GetNumQuestLogChoices() or 0
				local numCurrencies = GetNumQuestLogRewardCurrencies() or 0
				quests[qid].numRewards, quests[qid].numChoices, quests[qid].numCurrencies = numRewards, numChoices, numCurrencies
				local rewardSpellTexture, rewardSpellName = GetQuestLogRewardSpell()
				quests[qid].rewardSpellTexture = rewardSpellTexture or ""
				quests[qid].rewardSpellName = rewardSpellName or ""
				if numRewards > 0 then
					quests[qid].itemRewards = {}
					for i = 1, numRewards do
						local name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(i)
						local itemLink = GetQuestLogItemLink("reward", i)
						quests[qid].itemRewards[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = itemLink}
					end
				end
				if numChoices > 0 then
					quests[qid].itemChoices = {}
					for i = 1, numChoices do
						local name, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(i)
						local itemLink = GetQuestLogItemLink("choice", i)
						quests[qid].itemChoices[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = itemLink}
					end
				end
				if numCurrencies > 0 then
					quests[qid].currencies = {}
					for i = 1, numCurrencies do
						local name, texture, numItems = GetQuestLogRewardCurrencyInfo(i)
						quests[qid].currencies[i] = {name = name, texture = texture, numItems = numItems}
					end
				end
				for itemID in pairs(usableQuestItems) do
					local itemName = GetItemInfo(itemID)
					if (quests[qid].objective and quests[qid].objective:find(itemName, 1, true)) or (quests[qid].description and quests[qid].description:find(itemName, 1, true)) then
						items[itemID] = qid
						quests[qid].specialItemID = itemID
						usableQuestItems[itemID] = nil
					end
				end
				for itemID in pairs(itemStartingQuest) do
					local itemName = GetItemInfo(itemID)
					if (quests[qid].objective and quests[qid].objective:find(itemName, 1, true)) or (quests[qid].description and quests[qid].description:find(itemName, 1, true)) then
						items[itemID] = qid
						quests[qid].specialItemID = itemID
						itemStartingQuest[itemID] = nil
					end
				end
				local initialTimer = GetQuestLogTimeLeft()
				if initialTimer then
					quests[qid].initialTimer = initialTimer
					quests[qid].startTime = GetTime()
					updateQuestCells(qid)
				end
			end
			if firstRun then
				quests[qid].old = true
			elseif not quests[qid].old then
				quests[qid].old = true
				self:sendMessage("r", qid, started)
				if prdb.onQuestAccepted == 1 or (prdb.onQuestAccepted == 2 and playerLevel ~= MAX_PLAYER_LEVEL) or (prdb.onObjectiveProgress and started == 1) or (prdb.onDaily and quests[qid].daily == 1) or (prdb.onClass and quests[qid].class) then
					if not chdb.questsTracked[qid] then
						AddQuestWatch(id, nil, qid, true)
						refresh = true
					else
						chdb.questsSubZoneAutoTracked[qid] = nil
						chdb.questsZoneAutoTracked[qid] = nil
					end
				elseif prdb.onZone and quests[qid].category == currentZone then
					if not chdb.questsTracked[qid] then
						chdb.questsZoneAutoTracked[qid] = true
						AddQuestWatch(id, nil, qid, true)
						refresh = true
					else
						chdb.questsSubZoneAutoTracked[qid] = nil
					end
				elseif prdb.onSubZone and not chdb.questsTracked[qid] and subZone ~= "" and ((quests[qid].objective and quests[qid].objective:find(subZone, 1, true)) or (quests[qid].description and quests[qid].description:find(subZone, 1, true))) then
					chdb.questsSubZoneAutoTracked[qid] = true
					AddQuestWatch(id, nil, qid, true)
					refresh = true
				end
			end
		end
	end
	if GetQuestLogSelection() ~= selectionId then
		SelectQuestLogEntry(selectionId)
	end
	if not firstRun then
		for qid, qData in pairs(quests) do
			if qData.playerStatus and qData.timeStamp ~= timeStamp then
				if not collapsedHeader[qData.category] then
					refresh = true
					local daily, title = quests[qid].daily, quests[qid].title
					questsTitleToqid[title] = nil
					if quests[qid].playersOnQuest == 1 then
						removeQuestCells(qid)
						questsObjectives[qid] = nil
						local category = quests[qid].category
						quests[qid], questsByCategory[category][qid] = nil, nil
						if not next(questsByCategory[category]) then
							removeCategory(category)
						end
						self:questsSort()
					else
						quests[qid].playersOnQuest = quests[qid].playersOnQuest - 1
						quests[qid].playerStatus, quests[qid].id = nil, nil
						updateQuestCells(qid)
						if questsObjectives[qid] then
							for oid, qoData in pairs(questsObjectives[qid]) do
								questsObjectives[qid][oid].playerGot, questsObjectives[qid][oid].nPlayerGot = nil, nil
								updateQuestObjectiveCells(qid, oid)
							end
						end
						if prdb.partyHeader then
							local category = quests[qid].category
							questsByCategory[category][qid] = nil
							if not next(questsByCategory[category]) then
								removeCategory(category)
							end
							if not questsByCategory[PARTYQUESTSZONE] then
								self:addQuestCategory(PARTYQUESTSZONE)
							end
							questsByCategory[PARTYQUESTSZONE][qid] = true
							self:questsSort()
						end
					end
					questLost(qid)
					self:sendMessage("l", qid, abandoning)
					if daily == 1 and not abandoning then
						gldb.dailyList[playerName].dailies[#gldb.dailyList[playerName].dailies+1] = time().."^"..title
					end
				else
					quests[qid].id = nil
				end
			end
		end
	else
		firstRun = nil
		self:PARTY_MEMBERS_CHANGED()
		BAG_UPDATE()
		self:RegisterBucketEvent("BAG_UPDATE", 0.2, BAG_UPDATE)
		if prdb.onLogIn then
			for qid in pairs (quests) do
				AddQuestWatch(quests[qid].id, nil, qid, true)
			end
			for qid in pairs(chdb.questsTracked) do
				if not quests[qid] then
					chdb.questsTracked[qid] = nil
					chdb.questsSubZoneAutoTracked[qid] = nil
					chdb.questsZoneAutoTracked[qid] = nil
				end
			end
		else
			for qid in pairs(chdb.questsTracked) do
				if not quests[qid] then
					chdb.questsTracked[qid] = nil
					chdb.questsSubZoneAutoTracked[qid] = nil
					chdb.questsZoneAutoTracked[qid] = nil
				else
					AddQuestWatch(quests[qid].id, nil, qid, true)
				end
			end
		end
		if prdb.achievementsTracker.showInQuestTracker and not self.aTrInit then
			refresh = nil
		end
		self.qTrInit = true
	end
	if numQuests ~= newNumQuests or numCompletedQuests ~= newNumCompletedQuests then
		numQuests, numCompletedQuests = newNumQuests, newNumCompletedQuests
		self:updateQuestCounter()
	end
	if refresh then
		setQuestsTrackerLayout()
	end
	abandoning, self.questLogUpdating = nil, nil
end

function tomQuest2:PLAYER_XP_UPDATE()
	if self.sendXPMax then
		self:sendMessage("u", UnitXP("player"), UnitXPMax("player"))
		self.sendXPMax = nil
	else
		self:sendMessage("x", UnitXP("player"))
	end
end

function tomQuest2:PLAYER_LEVEL_UP(event, newPlayerLevel)
	playerLevel = newPlayerLevel
	if playerLevel == MAX_PLAYER_LEVEL and self.xpHandle then
		self:UnregisterBucket(self.xpHandle)
		self.xpHandle = nil
		self:UnregisterEvent("PLAYER_LEVEL_UP")
	elseif syncParty then
		self.sendXPMax = true
	end
	for category, cData in pairs(questsCategories) do
		if cData.minLevel ~= 0 then
			local r, g, b = LibTourist:GetLevelColor(category)
			questsCategories[category].color = format("%02x%02x%02x", r*255, g*255, b*255)
		end
	end
	for qid, qData in pairs(quests) do
		local qc = getDifficultyColor(qData.level - playerLevel)
		quests[qid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	end
end

function tomQuest2:PARTY_MEMBERS_CHANGED()
	local newNumPartyMembers = GetNumPartyMembers() or 0
	if numPartyMembers ~= newNumPartyMembers then
		if numPartyMembers == 0 then
			if playerLevel ~= MAX_PLAYER_LEVEL then
				self.xpHandle = self:RegisterBucketEvent("PLAYER_XP_UPDATE", 60, "PLAYER_XP_UPDATE")
			end
		elseif newNumPartyMembers == 0 then
			if self.xpHandle then
				self:UnregisterBucket(self.xpHandle)
				self.xpHandle = nil
			end
		end
		self:computeQuestsLevel()
		numPartyMembers = newNumPartyMembers
		if self.moduleState["syncParty"] then
			local timeStamp = GetTime()
			local partySync = 0
			if numPartyMembers > 0 then
				for i=1, numPartyMembers do
					local partyName, partyRealm = UnitName(pId[i])
					if partyRealm and partyRealm ~= "" then
						partyName = partyName.."-"..partyRealm
					end
					if not partyTimeStamp[partyName] then
						self:SendCommMessage("tomQ2", self:Serialize("v", version, firstCompatibleVersion, playerClass, UnitXP("player"), UnitXPMax("player")), "WHISPER", partyName, "BULK")
					end
					partyTimeStamp[partyName] = timeStamp
					partySync = partySync + (party[partyName] and 1 or 0)
				end
			end
			for partyName, latestTimeStamp in pairs(partyTimeStamp) do
				if latestTimeStamp ~= timeStamp then
					if party[partyName] then
						for qid, questData in pairs(quests) do
							if questData.complete and questData.complete[partyName] then
								removePartyFromQuest(partyName, qid)
							end
						end
						party[partyName] = nil
					end
					partyTimeStamp[partyName] = nil
					self:questsSort()
					setQuestsTrackerLayout()
				end
			end
			if partySync == 0 then
				syncParty = false
			else
				syncParty = true
			end
		end
	end
end

----------------------
--- Initialization ---
----------------------
function tomQuest2:computeQuestsLevel()
	for qid, questData in pairs(quests) do
		quests[qid].weightedLevel = levelTag[questData.shortTag](qid, questData.level, questData.group)
	end
	for category in pairs(questsCategories) do
		sort(sortedQuestsByCategory[category], qSort[prdb.questsSorting])
	end
	sort(sortedQuests, qSort[prdb.questsSorting])
	setQuestsTrackerLayout()
end

function tomQuest2:computeQuestsTag()
	for qid, questData in pairs(quests) do
		local tagLevel = prdb.level == "questLevel" and questData.level or questData.weightedLevel
		if tagLevel > 0 or questData.shortTag ~= "notag" or questData.group > 0 or questData.daily == 1 then
			quests[qid].tag = format("[%s%s%s%s]", tagLevel > 0 and tagLevel or "", prdb[questData.shortTag], questData.group > 0 and questData.group or "", questData.daily == 1 and (questData.shortTag ~= "daily" and prdb["daily"] or "") or "")
		else
			quests[qid].tag = ""
		end
		updateQuestCells(qid)
	end
	setQuestsTrackerLayout()
end

local function hideBlizzNotification(frame, event, message, ...)
	if event == "UI_INFO_MESSAGE" and (message:match(found) or message:match(item) or message:match(kill) or message:match(playerKilled) or message:match(oComplete) or message:match(qComplete) or message:match(qFailed)) then return end
	tomQuest2.hooks[frame].OnEvent(frame, event, message, ...)
end

function tomQuest2:setBlizzNotification()
	if prdb.hideBlizzardNotification then
		self:RawHookScript(UIErrorsFrame, "OnEvent", hideBlizzNotification)
	else
		self:Unhook(UIErrorsFrame, "OnEvent")
	end
end

function tomQuest2:enableModule(module)
	self.moduleState[module] = true
	if module == "syncParty" then
		self:RegisterComm("tomQ2", "commHandler")
	elseif module == "achievementsTracker" then
		self.achievementsFirstRun = true
		for _, aid in ipairs({GetTrackedAchievements()}) do
			self:AddTrackedAchievement(aid, true)
		end
		self:SecureHook("AddTrackedAchievement")
		self:SecureHook("RemoveTrackedAchievement")
		self:RawHook("IsTrackedAchievement", true)
		self.criteriaHandle = self:RegisterBucketEvent("CRITERIA_UPDATE", 1, "CRITERIA_UPDATE")
		self:RegisterEvent("ACHIEVEMENT_EARNED")
		if prdb.timedAchievements then
			self:RegisterEvent("TRACKED_ACHIEVEMENT_UPDATE")
		end
		self.achievementsFirstRun = nil
		if prdb.achievementsTracker.showInQuestTracker then
			if self.qTrInit then
				setQuestsTrackerLayout()
			end
		else
			setAchievementsTrackerLayout()
		end
		self.aTrInit = true
		if AchievementFrame then
			AchievementFrameAchievements_ForceUpdate()
		end
	elseif module == "questsTracker" then
		self:SecureHook("AddQuestWatch")
		self:SecureHook("RemoveQuestWatch")
	elseif module == "questsTooltip" then
		createQuestsTooltipDataObj()
	elseif module == "dailyTooltip" then
		createDailyQuestsTooltipDataObj()
		self.dailyTimer = self:ScheduleRepeatingTimer(updateDQToText, 60)
		updateDQToText()
	elseif module == "questsGivers" then
		setQuestsGivers()
	elseif module == "tooltips" then
		setMobTooltip()
		setItemTooltip()
	elseif module == "achievementsTradeSkills" then
		setAchievementsTradeSkills()
	elseif module == "tagQuestLog" then
		self:SecureHook("QuestLog_Update", blizzQuestLogUpdate)
		QuestLogScrollFrame:HookScript("OnMouseWheel", blizzQuestLogUpdate)
		QuestLogScrollFrameScrollBar:HookScript("OnValueChanged", blizzQuestLogUpdate)
	elseif module == "notifications" then
		self:setBlizzNotification()
	end
end

function tomQuest2:disableModule(module)
	self.moduleState[module] = nil
	if module == "syncParty" then
		self:UnregisterComm("tomQ2")
	elseif module == "achievementsTracker" then
		self:Unhook("AddTrackedAchievement")
		self:Unhook("RemoveTrackedAchievement")
		self:Unhook("IsTrackedAchievement")
		self:UnregisterBucket(self.criteriaHandle)
		self:UnregisterEvent("ACHIEVEMENT_EARNED")
		if prdb.timedAchievements then
			self:UnregisterEvent("TRACKED_ACHIEVEMENT_UPDATE")
		end
		self.achievementsFirstRun = true
	elseif module == "questsTracker" then
		self:Unhook("AddQuestWatch")
		self:Unhook("RemoveQuestWatch")
	elseif module == "dailyTooltip" then
		self:CancelTimer(self.dailyTimer, true)
		self.dailyTimer = nil
	elseif module == "questsGivers" then
		unSetQuestsGivers()
	elseif module == "tooltips" then
		setMobTooltip()
		setItemTooltip()
	elseif module == "achievementsTradeSkills" then
		unSetAchievementsTradeSkills()
	elseif module == "tagQuestLog" then
		self:Unhook("QuestLog_Update")
		self:Unhook(QuestLogScrollFrame, "OnMouseWheel")
		self:Unhook(QuestLogScrollFrameScrollBar, "OnValueChanged")
	elseif module == "notifications" then
		self:Unhook(UIErrorsFrame, "OnEvent")
	end
end

function tomQuest2:RAID_ROSTER_UPDATE(event, forced)
	local newNumRaidMembers = GetNumRaidMembers()
	if numRaidMembers ~= newNumRaidMembers then
		self:computeQuestsLevel()
		numRaidMembers = newNumRaidMembers
	end
	if not prdb.raidModules.enabled then return end
	local inRaid = numRaidMembers > 0 and true or nil
	local _, instanceType = IsInInstance()
	local inRaidInstance = instanceType == "raid" and true or nil
	if inRaid ~= self.inRaid or forced then
		for module, raidState in pairs(prdb.raidModules) do
			if raidState == "inRaid" then
				if inRaid and self.moduleState[module] then
					self:disableModule(module)
					self:Print(format(LC["%s module is now disabled"], module))
				elseif not inRaid and not self.moduleState[module] and prdb.modules[module] then
					self:enableModule(module)
					self:Print(format(LC["%s module is now enabled"], module))
				end
			elseif raidState == "hiddenInRaid" and self.moduleState[module] then
				if module == "questsTracker" then
					self:tQ2toggleQuestsTracker(inRaid and 0 or 1)
				elseif module == "achievementsTracker" then
					self:tQ2toggleAchievementsTracker(inRaid and 0 or 1)
				end
			end
		end
		self.inRaid = inRaid
	end
	if inRaidInstance ~= self.inRaidInstance or forced then
		for module, raidState in pairs(prdb.raidModules) do
			if raidState == "inRaidInstance" then
				if inRaidInstance and self.moduleState[module] then
					self:disableModule(module)
					self:Print(format(LC["%s module is now disabled"], module))
				elseif not inRaidInstance and not self.moduleState[module] and prdb.modules[module] then
					self:enableModule(module)
					self:Print(format(LC["%s module is now enabled"], module))
				end
			elseif raidState == "hiddenInRaidInstance" and self.moduleState[module] then
				if module == "questsTracker" then
					self:tQ2toggleQuestsTracker(inRaidInstance and 0 or 1)
				elseif module == "achievementsTracker" then
					self:tQ2toggleAchievementsTracker(inRaidInstance and 0 or 1)
				end
			end
		end
		self.inRaidInstance = inRaidInstance
	end
end

function tomQuest2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("tomQuest2DB", defaults, "Default")
	prdb, chdb, gldb = self.db.profile, self.db.char, self.db.global
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	chdb.questsTracked = chdb.questsTracked or {}
	chdb.questsSubZoneAutoTracked = chdb.questsSubZoneAutoTracked or {}
	chdb.questsZoneAutoTracked = chdb.questsZoneAutoTracked or {}
	chdb.collapseAll = chdb.collapseAll or 0
	chdb.sQuestItem = chdb.sQuestItem or 0
	chdb.questItem = chdb.questItem or 0
	chdb.categoryDisplay = chdb.categoryDisplay or {}
	chdb.categoryDisplay.questsTooltip = chdb.categoryDisplay.questsTooltip or {}
	chdb.categoryDisplay.questsTracker = chdb.categoryDisplay.questsTracker or {}
	chdb.categoryDisplay.achievementsTracker = chdb.categoryDisplay.achievementsTracker or {}
	gldb.dailyList = gldb.dailyList or {}
	if not gldb.dailyList[playerName] then
		gldb.dailyList[playerName] = {class = playerClass, dailies = {}}
	end
	self:SetSinkStorage(prdb.sinkOptions)
end

function tomQuest2:QUEST_AUTOCOMPLETE(event, qid)
	quests[qid].autoComplete = true
	if self.moduleState["notifications"] and prdb.notifyPlayerQuestAutoComplete then
		self:Pour(format(LC["(%s) : finished, you can complete it from the tracker or from the quest log"], quests[qid].title), 0, 1, 0)
	end
	if self.moduleState["soundNotifications"] then
		play(LSM:Fetch("sound", prdb.soundQuestAutoComplete))
	end
end

function tomQuest2:OnEnable()
	if prdb.version and prdb.version < 2 then
		self.db:ResetDB()
		self:Refresh()
	end
	setBackDrop("questsTooltip")
	setBackDrop("questsTracker")
	setBackDrop("achievementsTracker")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("QUEST_AUTOCOMPLETE")
	cQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.categoryFont), prdb.questsTooltip.categoryFontSize, prdb.questsTooltip.categoryFontOutline)
	qQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questFont), prdb.questsTooltip.questFontSize, prdb.questsTooltip.questFontOutline)
	qoQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questObjectiveFont), prdb.questsTooltip.questObjectiveFontSize, prdb.questsTooltip.questObjectiveFontOutline)
	cQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.categoryFont), prdb.questsTracker.categoryFontSize, prdb.questsTracker.categoryFontOutline)
	qQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questFont), prdb.questsTracker.questFontSize, prdb.questsTracker.questFontOutline)
	qoQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questObjectiveFont), prdb.questsTracker.questObjectiveFontSize, prdb.questsTracker.questObjectiveFontOutline)
	cATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.categoryFont), prdb.achievementsTracker.categoryFontSize, prdb.achievementsTracker.categoryFontOutline)
	scATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.subCategoryFont), prdb.achievementsTracker.subCategoryFontSize, prdb.achievementsTracker.subCategoryFontOutline)
	aATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementFont), prdb.achievementsTracker.achievementFontSize, prdb.achievementsTracker.achievementFontOutline)
	acATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementCriterionFont), prdb.achievementsTracker.achievementCriterionFontSize, prdb.achievementsTracker.achievementCriterionFontOutline)
	sbATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.statusBarFont), prdb.achievementsTracker.statusBarFontSize, prdb.achievementsTracker.statusBarFontOutline)
	displayFrames = {
		questsTooltip = getContainer("tomQuest2QuestsTooltip", "questsTooltip"),
		questsTracker = getContainer("tomQuest2QuestsTracker", "questsTracker"),
		achievementsTracker = getContainer("tomQuest2AchievementsTracker", "achievementsTracker")
	}
	if prdb.achievementsTracker.showInQuestTracker then
		self.ACHIEVEMENTS_TRACKER_FRAME = QUESTS_TRACKER
	else
		self.ACHIEVEMENTS_TRACKER_FRAME = ACHIEVEMENTS_TRACKER
	end
	if LBF then
		LBFGroup = LBF:Group("tomQuest2", "Items")
		LBFGroup.SkinID = prdb.skin.skin or "DreamLayout"
		LBFGroup.Backdrop = prdb.skin.backdrop
		LBFGroup.Gloss = prdb.skin.gloss
		LBFGroup.Colors = prdb.skin.Colors
		LBF:RegisterSkinCallback("tomQuest2", skinChanged)
	end
	LSM.RegisterCallback(self, "LibSharedMedia_Registered", "updateUsedMedia")
	tooltipHeaderCell = getContentCell(cQToFontTQ2, "CENTER", "header", QUESTS_TOOLTIP, nil, nil, true)
	tooltipHeaderCell.fs:SetText("|cfffffffftomQuest2|r")
	tooltipHeaderButton = getButton(tooltipHeaderCell, chdb.collapseAll == 0 and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up", prdb.questsTooltip.collapseButtonSize, "header")
	qTrSQuestItemCategory = getContentCell(cQTrFontTQ2, "LEFT", "sQuestItem", QUESTS_TRACKER, nil, nil, true)
	qTrSQuestItemCategory.fs:SetText(LC["Items starting a quest"])
	qTrSQuestItemCategoryButton = getButton(qTrSQuestItemCategory, chdb.sQuestItem == 0 and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up", prdb.questsTracker.collapseButtonSize, "sQuestItem")
	qTrSQuestItemFakeLine = CreateFrame("frame", "qTrSQuestItemFakeLine", displayFrames[QUESTS_TRACKER].scrollChild)
	qTrQuestItemCategory = getContentCell(cQTrFontTQ2, "LEFT", "questItem", QUESTS_TRACKER, nil, nil, true)
	qTrQuestItemCategory.fs:SetText(LC["Usable quest items not linked to a quest"])
	qTrQuestItemCategoryButton = getButton(qTrQuestItemCategory, chdb.questItem == 0 and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up", prdb.questsTracker.collapseButtonSize, "questItem")
	qTrQuestItemFakeLine = CreateFrame("frame", "qTrQuestItemFakeLine", displayFrames[QUESTS_TRACKER].scrollChild)
	for k, v in pairs(interactivityAction) do
		local action = prdb.questsTooltip[k]
		if action ~= "nothing" then
			hintCells[action] = getContentCell(cQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP)
			hintCells[action].fs:SetFormattedText("|cffeda55f%s|r |cff19ff19%s|r", v, self.interactivityList[action])
		end
	end
	ExpandQuestHeader(0)
	for module, state in pairs(prdb.modules) do
		if state then
			self:enableModule(module)
		end
	end
	prdb.version = 3
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(updateClassColors)
	end
	self:SecureHook("AbandonQuest")
	if prdb.hideDefaultBlizTracker then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	end
	self:RegisterEvent("CHAT_MSG_SYSTEM", CHAT_MSG_SYSTEM)
	self:RegisterEvent("QUEST_LOG_UPDATE")
	if playerLevel ~= MAX_PLAYER_LEVEL then
		self:RegisterEvent("PLAYER_LEVEL_UP")
	end
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "RAID_ROSTER_UPDATE")
	subZone = GetSubZoneText() or ""
	currentZone = GetZoneText() or ""
	self:RegisterEvent("ZONE_CHANGED", "zoneChanged")
	self:RegisterEvent("ZONE_CHANGED_INDOORS", "zoneChanged")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "zoneChanged")
	self:ScheduleTimer(resetDailyQuestsDB, 10)
end

function tomQuest2:Refresh()
	prdb, chdb, gldb = self.db.profile, self.db.char, self.db.global
	prdb.version = 3
	chdb.questsTracked = chdb.questsTracked or {}
	chdb.questsSubZoneAutoTracked = chdb.questsSubZoneAutoTracked or {}
	chdb.questsZoneAutoTracked = chdb.questsZoneAutoTracked or {}
	chdb.collapseAll = chdb.collapseAll or 0
	chdb.categoryDisplay = chdb.categoryDisplay or {}
	chdb.categoryDisplay.questsTooltip = chdb.categoryDisplay.questsTooltip or {}
	chdb.categoryDisplay.questsTracker = chdb.categoryDisplay.questsTracker or {}
	chdb.categoryDisplay.achievementsTracker = chdb.categoryDisplay.achievementsTracker or {}
	gldb.dailyList = gldb.dailyList or {}
	if not gldb.dailyList[playerName] then
		gldb.dailyList[playerName] = {class = playerClass, dailies = {}}
	end
	for module, state in pairs(prdb.modules) do
		if state and not self.moduleState[module] then
			self:enableModule(module)
		elseif not state and self.moduleState[module] then
			self:disableModule(module)
		end
	end
	self:computeQuestsTag()
	if prdb.hideDefaultBlizTracker and not self:IsHooked("WatchFrame_Update") then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	elseif not prdb.hideDefaultBlizTracker and self:IsHooked("WatchFrame_Update") then
		self:Unhook("WatchFrame_Update")
		WatchFrame:Show()
	end
	updateAllQuestsStatus()
	self:updateQuestCounter()
end

local optionFrame = CreateFrame("Frame", nil, InterfaceOptionsFrameAddOns)
local function loadConfigGUI()
	optionFrame:SetScript("OnShow", nil)
	LoadAddOn("tomQuest2_Config")
end
optionFrame:SetScript("OnShow", loadConfigGUI)

--------------------------
--- Keybinding globals ---
--------------------------
BINDING_HEADER_TOMQUEST2 = "tomQuest2"
BINDING_NAME_TQ2QUESTTRACKERTOGGLE = LC["Quests tracker"]
BINDING_NAME_TQ2ACHIEVEMENTTRACKERTOGGLE = LC["Achievements tracker"]

function tomQuest2:tQ2toggleQuestsTracker(display)
	if not display then
		if not prdb.questsTracker.toggleTracker then
			prdb.questsTracker.toggleTracker = true
		else
			prdb.questsTracker.toggleTracker = false
		end
	elseif display == 1 and not prdb.questsTracker.toggleTracker then
		prdb.questsTracker.toggleTracker = true
	elseif display == 0 and prdb.questsTracker.toggleTracker then
		prdb.questsTracker.toggleTracker = false
	end
	setQuestsTrackerLayout()
end

function tomQuest2:tQ2toggleAchievementsTracker(display)
	if not display then
		if not prdb.achievementsTracker.toggleTracker then
			prdb.achievementsTracker.toggleTracker = true
		else
			prdb.achievementsTracker.toggleTracker = false
		end
	elseif display == 1 and not prdb.achievementsTracker.toggleTracker then
		prdb.achievementsTracker.toggleTracker = true
	elseif display == 0 and prdb.achievementsTracker.toggleTracker then
		prdb.achievementsTracker.toggleTracker = false
	end
	setAchievementsTrackerLayout()
end